--[[

All UI functions involving the Friendlist*Frame elements will be here.
This should help clean up the mess that is the current Friendlist.lua file.

]]--

--[[

Friendlist globals.

]]--
FRIENDLIST_VERSION_NUM = "0.5.9";
FRIENDLIST_TITLE = "Friendlist";
FRIENDLIST_NAMES_TO_DISPLAY = 8;
FRIENDLIST_FRAME_HEIGHT = 34;

FRIENDLIST_NAME_BOX 		= 1;
FRIENDLIST_GIVEN_NAME_BOX 	= 2;
FRIENDLIST_SURNAME_BOX 		= 3;
FRIENDLIST_TITLE_BOX 		= 4;
FRIENDLIST_FRIENDSTATE_DROPDOWN = 5;
FRIENDLIST_NOTES_BOX 		= 6;

local buffTable = { };


--[[

Friendlist library functions.

]]--
FriendlistFrame = {
	tabs = {
		--{Tooltip text, icon, object}
		FRIENDLISTFrame = {tooltip = "", icon = "Interface\\Icons\\INV_Misc_Book_08", name = "FRIENDLISTFrame" },
		FriendlistCharFrame = { tooltip = "", icon = "Interface\\Icons\\INV_Misc_Note_02", name = "FriendlistCharFrame" },
		FriendlistConfigFrame = { tooltip = "", icon = "Interface\\Icons\\INV_Misc_Wrench_01", name = "FriendlistConfigFrame" }
		--FriendlistAdminFrame = { tooltip = "", icon = "Interface\\Icons\\INV_Feather_11", name = "FriendlistAdminFrame" },
	};

	editBoxes = {
		FriendlistCharFramePg1ScrollFrameChildFrameEditBox = {
			"FriendlistCharFramePg1TitleBox",
			"FriendlistCharFramePg1NameBox",
		},
		FriendlistCharFramePg1TitleBox = {
			"FriendlistCharFramePg1SurnameBox",
			"FriendlistCharFramePg1ScrollFrameChildFrameEditBox"
		},
		FriendlistCharFramePg1SurnameBox = {
			"FriendlistCharFramePg1NameBox",
			"FriendlistCharFramePg1TitleBox"
		},
		FriendlistCharFramePg1NameBox = {
			"FriendlistCharFramePg1ScrollFrameChildFrameEditBox",
			"FriendlistCharFramePg1SurnameBox"
		},
		FRIENDLISTStaticPopUpAddEditBox1 = {
			"FRIENDLISTStaticPopUpAddScrollFrameChildFrameEditBox",
			"FRIENDLISTStaticPopUpAddEditBox4"
		},
		FRIENDLISTStaticPopUpAddEditBox2 = {
			"FRIENDLISTStaticPopUpAddEditBox4",
			"FRIENDLISTStaticPopUpAddEditBox3"
		},
		FRIENDLISTStaticPopUpAddEditBox3 = {
			"FRIENDLISTStaticPopUpAddEditBox2",
			"FRIENDLISTStaticPopUpAddScrollFrameChildFrameEditBox"
		},
		FRIENDLISTStaticPopUpAddEditBox4 = {
			"FRIENDLISTStaticPopUpAddEditBox1",
			"FRIENDLISTStaticPopUpAddEditBox2"
		},
		FRIENDLISTStaticPopUpAddScrollFrameChildFrameEditBox = {
			"FRIENDLISTStaticPopUpAddEditBox3",
			"FRIENDLISTStaticPopUpAddEditBox1"
		},
		FRIENDLISTStaticPopUpAddGuildEditBox1 = {
			"FRIENDLISTStaticPopUpAddGuildScrollFrameChildFrameEditBox",
			"FRIENDLISTStaticPopUpAddGuildScrollFrameChildFrameEditBox"
		},
		FRIENDLISTStaticPopUpAddGuildScrollFrameChildFrameEditBox = {
			"FRIENDLISTStaticPopUpAddGuildEditBox1",
			"FRIENDLISTStaticPopUpAddGuildEditBox1",
		},
		FRIENDLISTStaticPopUpEditEditBox1 = {
			"FRIENDLISTStaticPopUpEditScrollFrameChildFrameEditBox",
			"FRIENDLISTStaticPopUpEditEditBox4"
		},
		FRIENDLISTStaticPopUpEditEditBox2 = {
			"FRIENDLISTStaticPopUpEditEditBox4",
			"FRIENDLISTStaticPopUpEditEditBox3"
		},
		FRIENDLISTStaticPopUpEditEditBox3 = {
			"FRIENDLISTStaticPopUpEditEditBox2",
			"FRIENDLISTStaticPopUpEditScrollFrameChildFrameEditBox"
		},
		FRIENDLISTStaticPopUpEditEditBox4 = {
			"FRIENDLISTStaticPopUpEditEditBox1",
			"FRIENDLISTStaticPopUpEditEditBox2",
		},
		FRIENDLISTStaticPopUpEditScrollFrameChildFrameEditBox = {
			"FRIENDLISTStaticPopUpEditEditBox3",
			"FRIENDLISTStaticPopUpEditEditBox1"
		},
	};
   
	pageButtons = {
		FriendlistCharFrameNextPageButton = {type="turn", activePage=1, pages={"FriendlistCharFramePg1", "FriendlistCharFramePg2"}},
	};
   
	scrollFrames ={
		FRIENDLISTStaticPopUpAddScrollFrameChildFrameEditBox = {
			height = 150;
		},
		FRIENDLISTStaticPopUpAddGuildScrollFrameChildFrameEditBox = {
			height = 150;
		},
		FRIENDLISTStaticPopUpEditScrollFrameChildFrameEditBox = {
			height = 150;
		}
	};

	dropDowns = {
		FRIENDLISTStaticPopUpAddDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 250,
			buttons = {
				{
					text = FRIENDLIST_LOCALE_FRIENDSTATE_TEXT[0],
					value = 0,
					checked = true
				},
				{
					text = FRIENDLIST_LOCALE_FRIENDSTATE_TEXT[10],
					value = 10,
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_FRIENDSTATE_TEXT[-10],
					value = -10,
					checked = false
				},
			},
			selectedValue = 0,
			selectedText = FRIENDLIST_LOCALE_FRIENDSTATE_TEXT[0],
			readFunction = "",
			writeFunction = ""
		},
		FRIENDLISTStaticPopUpAddGuildDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 250,
			buttons = {
				{
					text = FRIENDLIST_LOCALE_GUILDFRIENDSTATE_TEXT[0],
					value = 0,
					checked = true
				},
				{
					text = FRIENDLIST_LOCALE_GUILDFRIENDSTATE_TEXT[10],
					value = 10,
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_GUILDFRIENDSTATE_TEXT[-10],
					value = -10,
					checked = false
				},
			},
			selectedValue = 0,
			selectedText = FRIENDLIST_LOCALE_GUILDFRIENDSTATE_TEXT[0],
			readFunction = "",
			writeFunction = ""
		},
		FRIENDLISTStaticPopUpEditDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 250,
			buttons = {
				{
					text = "",
					value = 0,
					checked = true
				}
			},
			selectedValue = 0,
			selectedText = "",
			readFunction = "",
			writeFunction = ""
		},
		FriendlistCharFramePg2RPDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 250,
			buttons = {
				{
					text = FRIENDLIST_LOCALE_DropDownRP0,
					value = 0,
					checked = true
				},
				{
					text = FRIENDLIST_LOCALE_DropDownRP1,
					value = 1,
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_DropDownRP4,
					value = 4,
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_DropDownRP2,
					value = 2,
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_DropDownRP3,
					value = 3,
					checked = false
				}
			},
			selectedValue = 0,
			selectedText = "StartText",
			readFunction = "DropDown_getRPFlag",
			writeFunction = "DropDown_setRPFlag"
		},
		FriendlistCharFramePg2CSDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 250,
			buttons = {
				{
					text = FRIENDLIST_LOCALE_DropDownCSNone,
					value = "none",
					checked = true
				},
				{
					text = FRIENDLIST_LOCALE_DropDownCSOOC,
					value = "ooc",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_DropDownCSIC,
					value = "ic",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_DropDownCSFFAIC,
					value = "ffa-ic",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_DropDownCSST,
					value = "st",
					checked = false
				}
			},
			selectedValue = "ic",
			selectedText = "StartText",
			readFunction = "DropDown_getCStatus",
			writeFunction = "DropDown_setCStatus"
		},
		FriendlistConfigFramePg1TooltipStyleDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 150,
			buttons = {
				{
					text = FRIENDLIST_LOCALE_TooltipDropDownNormal,
					value = "normal",
					checked = true,
					tooltipTitle = FRIENDLIST_LOCALE_TooltipDropDownNormalTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_TooltipDropDownNormalTooltipText
				},
				{
					text = FRIENDLIST_LOCALE_TooltipDropDownLight,
					value = "light",
					checked = false,
					tooltipTitle = FRIENDLIST_LOCALE_TooltipDropDownLightTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_TooltipDropDownLightTooltipText
				},
				{
					text = FRIENDLIST_LOCALE_TooltipDropDownNone,
					value = "none",
					checked = false,
					tooltipTitle = FRIENDLIST_LOCALE_TooltipDropDownNoneTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_TooltipDropDownNoneTooltipText
				}
			},
			selectedValue = "normal",
			selectedText = "Normal",
			readFunction = "DropDown_GetTooltipStyleState",
			writeFunction = "DropDown_SetTooltipStyleState"
		},
		FriendlistConfigFramePg1AltLevelDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 150,
			buttons = {
				{
					text = FRIENDLIST_LOCALE_LevelDropDownNone,
					value = "none",
					checked = true,
					tooltipTitle = FRIENDLIST_LOCALE_LevelDropDownNoneTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_LevelDropDownNoneTooltipText
				},
				{
					text = FRIENDLIST_LOCALE_LevelDropDownRelative,
					value = "relative",
					checked = false,
					tooltipTitle = FRIENDLIST_LOCALE_LevelDropDownRelativeTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_LevelDropDownRelativeTooltipText
				},
				{
					text = FRIENDLIST_LOCALE_LevelDropDownColor,
					value = "color",
					checked = false,
					tooltipTitle = FRIENDLIST_LOCALE_LevelDropDownColorTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_LevelDropDownColorTooltipText
				}
			},
			selectedValue = "none",
			selectedText = "None",
			readFunction = "DropDown_GetAltLevelState",
			writeFunction = "DropDown_SetAltLevelState"
		},
		FriendlistConfigFramePg1GuildDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 150,
			buttons = {
				{
					text = FRIENDLIST_LOCALE_GuildDropDownNone,
					value = "none",
					checked = true,
					tooltipTitle = FRIENDLIST_LOCALE_GuildDropDownNoneTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_GuildDropDownNoneTooltipText
				},
				{
					text = FRIENDLIST_LOCALE_GuildDropDownKnown,
					value = "known",
					checked = false,
					tooltipTitle = FRIENDLIST_LOCALE_GuildDropDownKnownTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_GuildDropDownKnownTooltipText
				},
				{
					text = FRIENDLIST_LOCALE_GuildDropDownAll,
					value = "all",
					checked = false,
					tooltipTitle = FRIENDLIST_LOCALE_GuildDropDownAllTooltipTitle,
					tooltipText = FRIENDLIST_LOCALE_GuildDropDownAllTooltipText
				}
			},
			selectedValue = "none",
			selectedText = "None",
			readFunction = "DropDown_GetGuildState",
			writeFunction = "DropDown_SetGuildState"
		},
		Friendlist_SortDropDown = {
			initialize = "Friendlist_DropDownInitializer",
			width = 250,
			buttons = {
				{
					text = FRIENDLIST_LOCALE_SortDropDown_AlphOnlineSurname,
					value = "FLSorting_onlineCompSurname",
					checked = true
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_AlphOnline,
					value = "FLSorting_onlineCompName",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_TypeOnline,
					value = "FLSorting_onlineCompType",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_FStateOnline,
					value = "FLSorting_onlineCompFState",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_EDateOnline,
					value = "FLSorting_onlineCompEDate",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_AlphSurname,
					value = "FLSorting_alphCompSurname", 
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_Alph,
					value = "FLSorting_alphCompName",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_Type,
					value = "FLSorting_typeComp",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_FState,
					value = "FLSorting_fStateComp",
					checked = false
				},
				{
					text = FRIENDLIST_LOCALE_SortDropDown_EDate,
					value = "FLSorting_eDateComp",
					checked = false
				}
			},
			selectedValue = "FLSorting_eDateComp",
			selectedText = FRIENDLIST_LOCALE_SortDropDown_AlphOnlineSurname,
			readFunction = "DropDown_getSortSettings",
			writeFunction = "DropDown_setSortSettings",
			instantSave = true
		}
	};

	addEditDialogs = {
		FRIENDLISTStaticPopUpAdd = {
			titleText = FRIENDLIST_LOCALE_ADD_FRIEND_FRAME_TITLE,
			acceptText = FRIENDLIST_LOCALE_ADD_FRIEND_FRAME_ADD_BUTTON,
			closeText = FRIENDLIST_LOCALE_ADD_FRIEND_FRAME_ABORT_BUTTON,
	 
			initialize = "Friendlist_initAddFriendDialog",
			acceptClicked = "Friendlist_addFriendOnAccept",
	 
			textsVisibility = {true, true, true, true, true, true}
		},
		FRIENDLISTStaticPopUpAddGuild = {
			titleText = FRIENDLIST_LOCALE_ADD_GUILD_FRAME_TITLE,
			acceptText = FRIENDLIST_LOCALE_ADD_FRIEND_FRAME_ADD_BUTTON,
			closeText = FRIENDLIST_LOCALE_ADD_FRIEND_FRAME_ABORT_BUTTON,
	 
			initialize = "Friendlist_initAddGuildDialog",
			acceptClicked = "Friendlist_addGuildOnAccept",
	 
			textsVisibility = {true, false, false, false, true, true}
		},
		FRIENDLISTStaticPopUpEdit = {
			titleText = FRIENDLIST_LOCALE_EDITENTRY_FRAME_TITLE,
			acceptText = FRIENDLIST_LOCALE_EDITENTRY_FRAME_OK_BUTTON,
			closeText = FRIENDLIST_LOCALE_EDITENTRY_FRAME_ABORT_BUTTON,
	 
			initialize = "Friendlist_initEditEntryDialog",
			acceptClicked = "Friendlist_editEntryOnAccept",
	 
			textsVisibility = nil,
			guildTextsVisibility = {true, false, false, false, true, true, true},
			charTextsVisibility = {true, true, true, true, true, true}
		},
	};
	
	checkBoxes = {
		FriendlistConfigFramePg1ColorClassCheckBox = {
			tooltipText = FRIENDLIST_LOCALE_ColorClassTooltipText,
			disabled = nil,
			checked = nil,
			text = FRIENDLIST_LOCALE_ColorClass,
			
			writeFunction = "CheckBox_SetClassColor",
			readFunction = "CheckBox_GetClassColor"
		},
		FriendlistConfigFramePg1HideNamesCheckBox = {
			tooltipText = FRIENDLIST_LOCALE_HiddenNameDisplayTooltipText,
			disabled = nil,
			checked = nil,
			text = FRIENDLIST_LOCALE_HiddenNameDisplay,
			
			writeFunction = "CheckBox_SetNameDisplay",
			readFunction = "CheckBox_GetNameDisplay"
		},
		FriendlistConfigFramePg1PVPRanksCheckBox = {
			tooltipText = FRIENDLIST_LOCALE_PVPRanksTooltipText,
			disabled = nil,
			checked = nil,
			text = FRIENDLIST_LOCALE_PVPRanks,
			
			writeFunction = "CheckBox_SetPVPRanks",
			readFunction = "CheckBox_GetPVPRanks"
		},
		FriendlistConfigFramePg1GuildRanksCheckBox = {
			tooltipText = FRIENDLIST_LOCALE_ShowGuildRanksTooltipText,
			disabled = nil,
			checked = nil,
			text = FRIENDLIST_LOCALE_ShowGuildRanks,
			
			writeFunction = "CheckBox_SetGuildRank",
			readFunction = "CheckBox_GetGuildRank"
		}
	};
	
	sliders = {
		FriendlistConfigFramePg1PositionSlider = {
			tooltipText = FRIENDLIST_LOCALE_PositionSliderTooltipText,
			minValue = 0,
			maxValue = 360,
			valueStep = 0.5,
			
			writeFunction = "Slider_SetButtonPosition",
			readFunction = "Slider_GetButtonPosition"
		}
	};

	rpTypeExplanations = {
		[0] = FRIENDLIST_LOCALE_DropDownRP0Expl,
		[1] = FRIENDLIST_LOCALE_DropDownRP1Expl,
		[2] = FRIENDLIST_LOCALE_DropDownRP2Expl,
		[3] = FRIENDLIST_LOCALE_DropDownRP3Expl,
		[4] = FRIENDLIST_LOCALE_DropDownRP4Expl
	};

	csExplanations = {
		["none"] = FRIENDLIST_LOCALE_DropDownCSNoneExpl,
		["ooc"] = FRIENDLIST_LOCALE_DropDownCSOOCExpl,
		["ic"] = FRIENDLIST_LOCALE_DropDownCSICExpl,
		["ffa-ic"] = FRIENDLIST_LOCALE_DropDownCSFFAICExpl;
		["st"] = FRIENDLIST_LOCALE_DropDownCSSTExpl;
	};

	currentTab = "FRIENDLISTFrame";

	--descBuffer = "";
	--descBoxHeight = 0;
	--descTick = 0;
	descBoxWarningSeen = false;
	nameBoxWarningSeen = false;

	updateInterval = 3;
	updateInfoBoxInterval = 1;
	resortInterval = 1;
	updateEntryInterval = 10;
	updateTick = 0;
	updateTickInfoBox = 0;
	resortTick = 0;
	updateEntryTick = 10;

	doubleClickTick = 0;
	soundTick = 0;

	friendsFrameOpened = 0;
	friendsFrameOpenedTick = 0;   
	
	initialized = false;
	settingsLoaded = false;
};

--***************************--
-- Setup Event Handling 
--***************************--

-------------------------------
-- Handle the OnLoad Event 
-------------------------------
function FRIENDLIST_OnLoad()

   -- Define a few Print functions for cleaner code
	if (not Print_Chat) then 
		Print_Chat = function(x) DEFAULT_CHAT_FRAME:AddMessage(x, 1.0, 1.0, 0.0); end
	end
	if (not Print_UI) then
		Print_UI = function(x) UIErrorsFrame:AddMessage(x, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME); end
	end

	FRIENDLISTMinimapButton:Raise();

	-- Update GUI and GUI settings
	FRIENDLISTFrame.selectedMember = 0;
end

function Friendlist_OnUpdate()
--~ 	if FriendlistFrame.friendsFrameOpened == 0 or FriendlistFrame.friendsFrameOpened == 1 then
--~ 		FriendsFrame:Show();
--~ 		--FriendlistMetaFrame:Show();

--~ 		if FriendsFrame:IsVisible() and FriendlistFrame.friendsFrameOpened ~= 1 then 
--~ 			--FlagRSP:print(GetTime() + 2500);
--~ 			FriendlistFrame.friendsFrameOpenedTick = GetTime() + 0.5;
--~ 			FriendlistFrame.friendsFrameOpened = 1;
--~ 		end
--~ 	end
--~ 	  
--~ 	if FriendlistFrame.friendsFrameOpened == 1 then
--~ 		if FriendlistFrame.friendsFrameOpenedTick < GetTime() and FriendlistFrame.friendsFrameOpened == 1 then
--~ 			FriendsFrame:Hide();
--~ 			--FriendlistMetaFrame:Hide();
--~ 			FriendlistFrame.friendsFrameOpened = 2;
--~ 		end
--~ 	end
end


--*************************--
--   Utility Functions
--*************************--

-----------------------------
-- Handle <slash> commands
-----------------------------
function FRIENDLIST_SlashHandler(msg)
	if ( (msg == "help") or (msg == "") or (msg == nil) ) then
		local t = 0;
		while FRIENDLIST_LOCALE_HELP[t] ~= nil do
			DEFAULT_CHAT_FRAME:AddMessage(FRIENDLIST_LOCALE_HELP[t],1.0, 1.0, 1.0);
			t = t + 1;
		end      
	elseif (msg == "show") then
		--FRIENDLISTFrame:Show();
		FRIENDLIST_ToggleGUI();
	elseif (msg == "hide") then
		FRIENDLISTFrame:Hide();
	elseif (msg == "print") then
		--PrintFRIENDLIST();
		Friendlist:PrintFriendlist();
	elseif (msg == "reset") then
		--ResetFRIENDLIST();
		Friendlist:ResetFriendlist();
	elseif(msg=="import") then
		-- TODO: Reimplement this method.
		--ImportFriendlist();
	elseif(msg=="export") then
		-- TODO: Reimplement this method.
		--ExportFriendlist();
	else
		local idIndex = 1;
		local word = nil;
		local name = nil;
		local cmd = nil;
		local noteString = "";
		local nachnameString ="";
      
		--Iterate over space separated command string		
		--<cmd> <name> <notes>*
		for word in string.gmatch(msg, "%S+") do
			if (idIndex == 1) then
				cmd = string.lower(word);
			elseif (idIndex == 2) then
				name = word;
			elseif (idIndex == 3) then
				nachnameString = word;
			elseif (idIndex > 3) then
				nachnameString = nachnameString .. " " .. word;
			end
			idIndex = idIndex + 1;
		end
      
		--User can enter just /FRIEND add <name> (with no notes)
		if ( (idIndex == 3) and (cmd == "add") ) then
			nachnameString = nil;
		end
      
		--Fire off appropriate command
		if(cmd ~= nil) then
			if(cmd == "add") then
				if (name ~= nil) then
--					if (nachnameString ~= nil) then
--						AddFRIEND(name, "", nachnameString);
--					else
--						AddFRIEND(name, "", "");
--					end
					local friend = { };
					
					friend.name = name;
					friend.surname = nachnameString;
					
					Friendlist:AddFriend(friend);
				end
			elseif (cmd == "del") then
				--DelFRIEND(name);
				Friendlist:DeleteFriend(name);
			elseif (cmd == "mm") then
				local switch = string.lower(name);
				if (switch == "an") then
					FRIENDLISTMinimapButton:Show();
					FlagRSPConfigure:SetButtonState(true);
				elseif (switch == "aus") then
					FRIENDLISTMinimapButton:Hide();
					FlagRSPConfigure:SetButtonState(false);
				end
			elseif (cmd == "addguild") then
				--Guilds can have spaces in their names
				if ( idIndex > 3) then
					--Guild had spaces in their name, string it together
					name = name .." "..noteString;
				end
				--AddFRIEND(name, "Gilde", "");
				local friend = { };
				
				friend.name = name;
				friend.type = "guild";
				
				Friendlist:AddFriend(friend);
			elseif cmd == "buttonpos" then
				if name ~= nil then
					local pos=tonumber(name);
					if pos >=0 and pos <= 360 then
						Friendlist:setButtonPosition(pos);
					end
				end
			end
		end
	end
end

function FRIENDLIST_ToggleGUI()
	--FRIENDLIST_Update(true);
	--FRIENDLIST_Update(resort)

	if (FriendlistMetaFrame:IsVisible()) then
		FriendlistMetaFrame:Hide();

		--FRIENDLISTFrame:Hide();
		local tab;
		for key, value in pairs(FriendlistFrame.tabs) do
			--tabbutton = getglobal("Friendlist_PageTab" .. i);
			--if not FriendlistFrame.tabs[i][4] then 
			--	FriendlistFrame.tabs[i][4] = true;
			--end

			-- save char frame changes.
			FriendlistCharFrame_Save();
			FriendlistConfigFrame_Save();
    
			if FriendlistFrame.tabs[key].name ~= "" then
				tab = getglobal(FriendlistFrame.tabs[key].name);
				tab:Hide();
				PlaySound("igSpellBookClose");
				--PlaySound("igMainMenuClose");
			end
		end
	else
		FriendlistCharFrame_Load();
		FriendlistConfigFrame_Load();

		FriendlistMetaFrame:Show();
		--ShowUIPanel(FriendlistMetaFrame);
		--FRIENDLISTFrame:Show();
		--PlaySound("igMainMenuOpen");
		PlaySound("igSpellBookOpen");
      
		Friendlist:updateTabs();
	end
end

------------------------------------------------------------------------------------------


--[[

FriendlistCharFrame_OnShow()

- OnShow function for character frame.

]]--
function FriendlistCharFrame_OnShow()
	FlagRSP:printDebug("Show Charframe!");
	Friendlist:updatePages("FriendlistCharFrameNextPageButton");
	SetPortraitTexture(FriendlistCharFramePortrait, "player");
	FriendlistCharFrameTitleText:SetText(TooltipHandler:ParseString(FRIENDLIST_LOCALE_CharFrameTitle, "player"));
	FriendlistCharFramePg1CertTitle:SetTextHeight(20);
	FriendlistCharFramePg1CertText1:SetText(TooltipHandler:ParseString(FRIENDLIST_LOCALE_CertText1, "player"));
	FriendlistCharFramePg1CertText1:SetWidth(283);
	FriendlistCharFramePg1CertText2:SetText(TooltipHandler:ParseString(FRIENDLIST_LOCALE_CertText2, "player"));
	FriendlistCharFramePg1CertText3:SetText(TooltipHandler:ParseString(FRIENDLIST_LOCALE_CertText3, "player"));
	FriendlistCharFramePg1CertText3:SetWidth(283);
	FriendlistCharFramePg1NameBox:SetPoint("TOPLEFT", "FriendlistCharFramePg1CertText1", "BOTTOMLEFT", 0, -5);
	FriendlistCharFramePg1NameBox:SetWidth(100);
	FriendlistCharFramePg1NameBoxDummyFrame:SetPoint("TOPLEFT", "FriendlistCharFramePg1CertText1", "BOTTOMLEFT", 0, -5);
	FriendlistCharFramePg1NameBoxDummyFrame:SetWidth(100);
	FriendlistCharFramePg1SurnameBox:SetPoint("TOPLEFT", "FriendlistCharFramePg1NameBox", "BOTTOMLEFT", 0, -5);
	FriendlistCharFramePg1SurnameBox:SetWidth(255);
	FriendlistCharFramePg1SurnameBoxDummyFrame:SetPoint("TOPLEFT", "FriendlistCharFramePg1NameBox", "BOTTOMLEFT", 0, -5);
	FriendlistCharFramePg1SurnameBoxDummyFrame:SetWidth(255);
	--FlagRSP:print( FriendlistCharFramePg1CertText1:GetHeight());
	FriendlistCharFramePg1ScrollFrame:SetHeight(150-FriendlistCharFramePg1CertText1:GetHeight());
	FriendlistCharFramePg1ScrollFrameDummyFrame:SetHeight(150-FriendlistCharFramePg1CertText1:GetHeight());
	--FriendlistCharFrameCertText4:SetPoint("TOPLEFT", "FriendlistCharFrameTitleBox", "BOTTOMLEFT", 0, 12);
	--FriendlistCharFrameCharDescBox:SetHeight(108);
	--FriendlistCharFrameCharDescBox:SetHeight(108);
	--FriendlistCharFramePg1ScrollFrameChildFrameEditBox:SetHeight(108);
	FriendlistCharFramePg1ScrollFrameChildFrameEditBox:SetHeight(150-FriendlistCharFramePg1CertText1:GetHeight());
	FriendlistCharFramePg1ScrollFrameChildFrameEditBox:Show();
	--FriendlistCharFrameScrollFrameChildFrameEditBox:SetFocus();
	FriendlistCharFrameNextPageButtonText:SetText(TooltipHandler:ParseString(FRIENDLIST_LOCALE_TurnPageButton, "player"));	
	
	-- page 2:
	--FriendlistCharFramePg2Text2:SetPoint("TOPLEFT", "FriendlistCharFramePg2RpDropDown", "BOTTOMRIGHT", -267, 15);
	--FriendlistCharFramePg2Text2:SetBackdropColor(0,0,0,0.2);
	FriendlistCharFramePg2Text1:SetTextHeight(14);
	FriendlistCharFramePg2Text2:SetTextHeight(14);
	FriendlistCharFramePg2Text4:SetTextHeight(14);
	FriendlistCharFramePg2Text5:SetTextHeight(14);
	--FriendlistCharFramePg2Text3:SetTextHeight(9.6);
	--FriendlistCharFramePg2Text6:SetTextHeight(9.6);
	FriendlistCharFramePg2Text3:SetTextHeight(9.5);
	FriendlistCharFramePg2Text6:SetTextHeight(9.5);
	FriendlistCharFramePg2Text3:SetWidth(283);
	FriendlistCharFramePg2Text3:SetText("a sample explanation...\nin two\nthree\nand four lines.");
	FriendlistCharFramePg2DummyFrame1:SetAlpha(0.05);
	--FriendlistCharFramePg2Text2:SetPoint("TOPLEFT", "FriendlistCharFramePg2RPDropDown", "BOTTOMLEFT", 0, -10);
	FriendlistCharFramePg2Text6:SetWidth(283);
	FriendlistCharFramePg2Text6:SetText("a sample explanation...\nin two\nthree\nand four lines.");
	FriendlistCharFramePg2DummyFrame2:SetAlpha(0.05);
	--Friendlist_DropDownHandler("FriendlistCharFramePg2RPDropDown");
	--Friendlist_DropDownHandler("FriendlistCharFramePg2CSDropDown");
	--UIDropDownMenu_JustifyText("LEFT", FriendlistCharFramePg2CSDropDown);
	FriendlistCharFrame:SetScale(2);
	FriendlistCharFrame:SetScale(1);
end


--[[

FriendlistCharFrame_OnUpdate()

- OnUpdate function for character frame.

]]--
function FriendlistCharFrame_OnUpdate()
	FriendlistCharFramePg2RPDropDown:SetPoint("TOPLEFT" , "FriendlistCharFramePg2Text1", "BOTTOMLEFT", -10, -8);
	FriendlistCharFramePg2CSDropDown:SetPoint("TOPLEFT" , "FriendlistCharFramePg2Text4", "BOTTOMLEFT", -10, -8);

	FriendlistCharFramePg2Text3:SetText(FriendlistFrame.rpTypeExplanations[FriendlistFrame.dropDowns["FriendlistCharFramePg2RPDropDown"].selectedValue]);
	FriendlistCharFramePg2Text6:SetText(FriendlistFrame.csExplanations[FriendlistFrame.dropDowns["FriendlistCharFramePg2CSDropDown"].selectedValue]);

	FriendlistCharFramePg2DummyFrame1:SetHeight(FriendlistCharFramePg2Text3:GetHeight());
	FriendlistCharFramePg2DummyFrame1:SetPoint("TOPLEFT", "FriendlistCharFramePg2Text3", "TOPLEFT", 0, 0);
	FriendlistCharFramePg2DummyFrame2:SetHeight(FriendlistCharFramePg2Text6:GetHeight());
	FriendlistCharFramePg2DummyFrame2:SetPoint("TOPLEFT", "FriendlistCharFramePg2Text6", "TOPLEFT", 0, 0);
end



--[[

FriendlistCharFramePg1ScrollFrameChildFrameEditBox_OnDescBoxFocus()

-- Function to assure description warning is being displayed once.

]]--
function FriendlistCharFramePg1ScrollFrameChildFrameEditBox_OnDescBoxFocus()
	if not FriendlistFrame.descBoxWarningSeen then
		FlagRSP:showEditBox();
	end
end

function FriendlistCharFramePg1NameBox_OnNameBoxFocus()
	if ( not FriendlistFrame.nameBoxWarningSeen ) then
		FlagRSP:showEditBox(FlagRSP_Locale_NameWarnText);
	end
end


--[[

FriendlistCharFramePg1ScrollFrameChildFrameEditBox_UpdateDescBox()

-- Update function for character's description edit box. Correct height and
   assure that player has read warning for the description.

]]--
function FriendlistCharFramePg1ScrollFrameChildFrameEditBox_UpdateDescBox()
	local theight = 150-FriendlistCharFramePg1CertText1:GetHeight();
   
	if not FriendlistFrame.descBoxWarningSeen then
		FriendlistCharFramePg1ScrollFrameChildFrameEditBox:SetText(FlagRSP:getOwnDesc());
	end
   
	local height = FriendlistCharFramePg1ScrollFrameChildFrameEditBox:GetHeight();
   
	if height < theight then
		height = theight;
	end
      
	FriendlistCharFramePg1ScrollFrameChildFrameEditBox:SetHeight(height);
end


--[[

FriendlistCharFrame_Load()

-- Loads options for Friendlist character frame.

]]--
function FriendlistCharFrame_Load()
--	if ( FlagRSP:GetPlayerName() ~= "" and FlagRSP:GetPlayerName() ~= nil ) then
		FriendlistCharFramePg1NameBox:SetText(FlagRSP:GetPlayerName());
--	else
--		FriendlistCharFramePg1NameBox:SetText(UnitName("player"));
--	end
	FriendlistCharFramePg1SurnameBox:SetText(FlagRSP:getOwnSurname());
	FriendlistCharFramePg1TitleBox:SetText(FlagRSP:getOwnTitle());
	FriendlistCharFramePg1ScrollFrameChildFrameEditBox:SetText(FlagRSP:getOwnDesc());
   
	Friendlist:dropDownRead("FriendlistCharFramePg2RPDropDown");   
	Friendlist:dropDownRead("FriendlistCharFramePg2CSDropDown");   
end


--[[

FriendlistCharFrame_Save()

-- Save options from Friendlist character frame.

]]--
function FriendlistCharFrame_Save()
	--FriendlistCharFramePg1SurnameBox:SetText(FlagRSP:getOwnSurname());
	--FriendlistCharFramePg1TitleBox:SetText(FlagRSP:getOwnTitle());
	--FriendlistCharFramePg1ScrollFrameChildFrameEditBox:SetText(FlagRSP:getOwnDesc());
	local nameChanged = FlagRSP:SetName(FriendlistCharFramePg1NameBox:GetText());
	local surnameChanged = FlagRSP:setSurname(FriendlistCharFramePg1SurnameBox:GetText());
	local titleChanged = FlagRSP:setTitle(FriendlistCharFramePg1TitleBox:GetText());
	local descChanged = FlagRSP:setDesc(FriendlistCharFramePg1ScrollFrameChildFrameEditBox:GetText());

	local rpChanged = Friendlist:dropDownWrite("FriendlistCharFramePg2RPDropDown");
	local csChanged = Friendlist:dropDownWrite("FriendlistCharFramePg2CSDropDown");

	--FlagRSP.newTickPost = FlagRSP.newTickPost - 60;
	local changed = false;

	if surnameChanged then
		changed = true;
	elseif ( nameChanged ) then
		changed = true;
	elseif titleChanged then
		changed = true;
	elseif descChanged then
		changed = true;
	elseif rpChanged then
		changed = true;
	elseif csChanged then
		changed = true;
	end
      
	if changed then
		--FlagRSP:printDebug("updating flags!");
		--xTooltip_Post("all", rpChanged, surnameChanged, titleChanged, descChanged, csChanged, nameChanged);
		FlagRSP:PostFlags();
	end
	if descChanged then
		FlagRSPInfo:PushDescription();
		--FlagHandler:UpdateSelf();
	end
end

function FriendlistConfigFrame_OnShow()
	FriendlistConfigFrameTitleText:SetText(TooltipHandler:ParseString(FRIENDLIST_LOCALE_ConfigFrameTitle, "player"));
	
	FriendlistConfigFramePg1ColorClassCheckBoxText:SetText(FRIENDLIST_LOCALE_ColorClass);
	FriendlistConfigFramePg1ColorClassCheckBoxText:SetFontObject(ItemTextFontNormal);
	FriendlistConfigFramePg1ColorClassCheckBoxText:SetShadowOffset(0, 0);
	
	FriendlistConfigFramePg1HideNamesCheckBoxText:SetText(FRIENDLIST_LOCALE_HiddenNameDisplay);
	FriendlistConfigFramePg1HideNamesCheckBoxText:SetFontObject(ItemTextFontNormal);
	FriendlistConfigFramePg1HideNamesCheckBoxText:SetShadowOffset(0, 0);
	
	FriendlistConfigFramePg1PVPRanksCheckBoxText:SetText(FRIENDLIST_LOCALE_PVPRanks);
	FriendlistConfigFramePg1PVPRanksCheckBoxText:SetFontObject(ItemTextFontNormal);
	FriendlistConfigFramePg1PVPRanksCheckBoxText:SetShadowOffset(0, 0);
	
	FriendlistConfigFramePg1GuildRanksCheckBoxText:SetText(FRIENDLIST_LOCALE_ShowGuildRanks);
	FriendlistConfigFramePg1GuildRanksCheckBoxText:SetFontObject(ItemTextFontNormal);
	FriendlistConfigFramePg1GuildRanksCheckBoxText:SetShadowOffset(0, 0);
	
	FriendlistConfigFramePg1PositionSliderText:SetText(FRIENDLIST_LOCALE_PositionSlider);
	FriendlistConfigFramePg1PositionSliderText:SetFontObject(ItemTextFontNormal);
	FriendlistConfigFramePg1PositionSliderText:SetShadowOffset(0, 0);
	FriendlistConfigFramePg1PositionSliderLow:SetText("");
	FriendlistConfigFramePg1PositionSliderLow:SetFontObject(ItemTextFontNormal);
	FriendlistConfigFramePg1PositionSliderLow:SetShadowOffset(0, 0);
	FriendlistConfigFramePg1PositionSliderHigh:SetText("");
	FriendlistConfigFramePg1PositionSliderHigh:SetFontObject(ItemTextFontNormal);
	FriendlistConfigFramePg1PositionSliderHigh:SetShadowOffset(0, 0);
	
	FriendlistConfigFrame:SetScale(2);
	FriendlistConfigFrame:SetScale(1);
end

function FriendlistConfigFrame_OnUpdate()
	Friendlist:WriteSlider("FriendlistConfigFramePg1PositionSlider");
end

function FriendlistConfigFrame_Load()
	Friendlist:dropDownRead("FriendlistConfigFramePg1AltLevelDropDown");   
	Friendlist:dropDownRead("FriendlistConfigFramePg1GuildDropDown");
	Friendlist:dropDownRead("FriendlistConfigFramePg1TooltipStyleDropDown");
	
	Friendlist:LoadSlider("FriendlistConfigFramePg1PositionSlider");
	
	Friendlist:LoadCheckBox("FriendlistConfigFramePg1ColorClassCheckBox");
	Friendlist:LoadCheckBox("FriendlistConfigFramePg1HideNamesCheckBox");
	Friendlist:LoadCheckBox("FriendlistConfigFramePg1PVPRanksCheckBox");
	Friendlist:LoadCheckBox("FriendlistConfigFramePg1GuildRanksCheckBox");
end

function FriendlistConfigFrame_Save()
	Friendlist:dropDownWrite("FriendlistConfigFramePg1AltLevelDropDown");
	Friendlist:dropDownWrite("FriendlistConfigFramePg1GuildDropDown");
	Friendlist:dropDownWrite("FriendlistConfigFramePg1TooltipStyleDropDown");
	
	Friendlist:WriteSlider("FriendlistConfigFramePg1PositionSlider");
	
	Friendlist:WriteCheckBox("FriendlistConfigFramePg1ColorClassCheckBox");
	Friendlist:WriteCheckBox("FriendlistConfigFramePg1HideNamesCheckBox");
	Friendlist:WriteCheckBox("FriendlistConfigFramePg1PVPRanksCheckBox");
	Friendlist:WriteCheckBox("FriendlistConfigFramePg1GuildRanksCheckBox");
end

function FRIENDLIST_OnShow()
	FRIENDLISTFrameTitleText:SetText(FRIENDLIST_TITLE);

	--DEFAULT_CHAT_FRAME:AddMessage("Before or after C?");

	--FRIENDLISTShowNotes_OnLoad();
	--FRIENDLISTPlaySound_OnLoad();
	--FRIENDLISTEverPvp_OnLoad();
	--FRIENDLISTRSP_OnLoad();
	FRIENDLIST_Update(true);
	FriendlistFrame.resortTick = 0;
	--FlagRSP.newTickRescaleBox = 0;   

	--PlaySound("igMainMenuOpen");
	--FRIENDLISTFrameTopLeft:Show();
   
	--getglobal("CT_CPTab" .. i):SetNormalTexture(CT_CPTabs[i][3]);

	local tabbutton;
	for i=1, 2 do
		tabbutton = getglobal("Friendlist_Tab" .. i);

		--tabbutton:Lower();
		--tabbutton:Lower();
		--tabbutton:Lower();
		--tabbutton:Lower();
		--tabbutton:Lower();
		--tabbutton:Lower();

		tabbutton:Hide();
	end
   
	Friendlist:updateTabs();

	--Friendlist_Tab2:SetPoint("LEFT", "Friendlist_Tab1", "RIGHT", 10, 0);
	Friendlist:dropDownRead("Friendlist_SortDropDown");
end

------------------------------------------------------------------------------------------			

function FRIENDLIST_OnHide()
	--PlaySound("igMainMenuClose");
	FRIENDLISTFrame.selectedMember = 0;
	--if FRIENDLISTStaticPopUpAdd:IsVisible() then 
		--FRIENDLISTStaticPopUpAdd:Hide();
	--end
	--if FRIENDLISTStaticPopUpAddNN:IsVisible() then 
		--FRIENDLISTStaticPopUpAddNN:Hide();
	--end

	local dialog;
	for name, value in pairs(FriendlistFrame.addEditDialogs) do
		--FlagRSP:printM(name);      
		local dialog = getglobal(name);
      
		if dialog ~= nil and dialog:IsVisible() then
			dialog:Hide();
		end
	end
end

------------------------------------------------------------------------------------------

function FriendlistAddEditDialog_OnMouseDown()
	if arg1 == "LeftButton" then
		this:StartMoving();
	end
end

function FriendlistAddEditDialog_OnMouseUp()
	if arg1 == "LeftButton" then
		this:StopMovingOrSizing();
	end
end

function FRIENDLISTButton_OnClick(arg1)
  
end

function FRIENDLISTButton_OnMouseDown(arg1)
   --FlagRSP:printDebug("arg1: " .. arg1);

	if arg1 == "RightButton" and FRIENDLISTFrame.selectedMember == this:GetID() then
		FlagRSP:printDebug("Right button clicked");
		if ( FlagRSPConfigure:GetFriendlistEntryBox() ) then
			FlagRSPConfigure:SetFriendlistEntryBox(false);
		else
			FlagRSPConfigure:SetFriendlistEntryBox(true);
		end

		FriendlistMain_Update(true);
	elseif arg1 == "LeftButton" then
		FRIENDLISTFrame.selectedMember = this:GetID();
		--FlagRSP:printM("Hey!");
		FRIENDLIST_Update();
		FriendlistMain_Update(true);
		if GetTime() < FriendlistFrame.doubleClickTick then 
			--FlagRSP:printM("Hey!");
			if (FRIENDLISTFrame.selectedMember > 0) then
				if FRIENDLISTStaticPopUpEdit:IsVisible() then
					FRIENDLISTStaticPopUpEdit:Hide();
				end
				FRIENDLISTStaticPopUpEdit:Show();
			end
			FriendlistFrame.doubleClickTick = 0; 
		else
			FriendlistFrame.doubleClickTick = GetTime() + 0.33; 
		end
	end
end

function FRIENDLISTButton_OnMouseUp(arg1)
	if arg1 == "RightButton" then
		FRIENDLISTButton_OnClick(arg1);
	end
end

function FRIENDLIST_Update(resort)

	FlagRSP:printDebug("called: FRIENDLIST_Update");

	if resort == nil then
		resort = false;
	end
   
	--Update Scrolling Frame
	local nameOffset = FauxScrollFrame_GetOffset(FRIENDLISTBFScrollFrame);
	local nameIndex;

	--if nameOffset ~= nil then
		--FlagRSP:printDebug("nameOffset for Scrollframe is" .. nameOffset);
	--end

	-- update friends frame to assure we get correct coordinates.
	if GetTime() > FriendlistFrame.updateEntryTick or resort then
		Friendlist:updateEntry("", "flist");
		Friendlist.updateEntryTick = GetTime() + FriendlistFrame.updateEntryInterval;
	end      

	if GetTime() > FriendlistFrame.resortTick or resort then
		buffTable = FLSorting.sortTable(Friendlist:GetFriendsTable());
		FriendlistFrame.resortTick = GetTime() + FriendlistFrame.resortInterval;
	end

	--FLSorting.test(friendData[realmName][playerName].FRIEND);

	local ticks = {};

	for i=1, FRIENDLIST_NAMES_TO_DISPLAY, 1 do
		--FlagRSP:printDebug("entry: " .. i .. ". It is: " .. GetTime());
		ticks[i] = GetTime();
		local listIndex = nameOffset + i;
      
		--FlagRSP:printM(i);

		local nameIndex = FLSorting.getRealEntry(buffTable, listIndex);
		local nameLine = getglobal("FRIENDLISTBFButton"..i.."ButtonTextName");
		local classLine = getglobal("FRIENDLISTBFButton"..i.."ButtonTextClass");
		local noteLine = getglobal("FRIENDLISTBFButton"..i.."ButtonTextNotes");
		local btn = getglobal("FRIENDLISTBFButton" .. i);
		local btnTex = getglobal("FRIENDLISTBFButton" .. i .. "NormalTexture");

		--lines = {};

		if Friendlist:isOnline(TooltipHandler:GetCharacterName("index" .. nameIndex, "unit")) == 1 then
			btnTex:SetTexture("Interface\\Addons\\flagRSP\\Art\\online-bg");
			btnTex:SetAlpha(0.25);
		else
			btnTex:SetTexture("");
			--btnTex:SetAlpha(0.5);
		end      

		nameLine:SetTextColor(1,1,1);
		local entryName;
		local altName;

		entryName, altName = Friendlist:GetName("index" .. nameIndex);
      
		local notesText = ""
		if ( Friendlist:GetNotes(entryName) ~= nil ) then
			notesText = Friendlist:GetNotes(entryName);
		end
		notesText = string.gsub(notesText, "\n", " ");
		if string.len(notesText) > 100 then
			notesText = string.sub(notesText,1,100) .. "...";
		end

		local nameText = "";
		local surname = TooltipHandler:getSurname(entryName);
		
		if ( altName ~= nil and altName ~= "" ) then
			nameText = altName .. " ";
			if ( surname ~= nil and surname ~= "" ) then
				if ( string.sub(surname, 1, 1) == "," ) then
					nameText = nameText .. entryName .. surname;
				else
					nameText = nameText .. entryName .. " " .. surname;
				end
			else
				nameText = entryName;
			end
		end
		
		if ( surname ~= nil and surname ~= "" ) then
			if ( string.sub(surname, 1, 1) == "," ) then
				nameText = entryName .. surname;
			else
				nameText = entryName .. " " .. surname;
			end
		else
			nameText = entryName;
		end
		nameText = TooltipHandler:BuildName("index" .. nameIndex);
		if nameText == nil then
			nameText = "";
		end
	 
		local titleText = TooltipHandler:getTitle(entryName);
		if titleText ~= "" then
			titleText = ", " .. titleText;
		end

		local raceText = "";
		if ( Friendlist:GetRace(entryName) ~= nil ) then
			raceText = Friendlist:GetRace(entryName);
		end
		--TooltipHandler:ParseString("%UnitRace ","index" .. nameIndex);
		if raceText ~= "" then
			raceText = raceText .. " ";
		end

		local classText = "";
		if ( Friendlist:GetClass(entryName) ~= nil ) then
			classText = Friendlist:GetClass(entryName);
		end
		--TooltipHandler:ParseString("%UnitClass","index" .. nameIndex);
         
		local levelText;   
		--TooltipHandler:ParseString(", %flagRSPLevel","index" .. nameIndex);
		if Friendlist:GetLevel(entryName) ~= 0 and Friendlist:GetLevel(entryName) ~= "" then
			levelText = ", " .. TooltipHandler:getLevelText("index" .. nameIndex);
		else
			levelText = "";
		end
      
		local guildText = "";
		if ( Friendlist:GetGuild(iname) ~= nil ) then
			guildText = ", <" .. Friendlist:GetGuild(iname) .. ">";
		end
		--TooltipHandler:ParseString(", <%UnitGuild>","index" .. nameIndex);
		if ( guildText == ", <>" or guildText == "" ) then
			guildText = "";
		end

		--local rankText = TooltipHandler:ParseString(", %UnitRank","index" .. nameIndex);
		--if rankText == ", " then
		local rankText = "";
		--end

		if notesText == "Gilde" then
			notesText = FRIENDLIST_LOCALE_GuildLine;
		end

		local onlineText = Friendlist:GetOnlineStatus(entryName, "index" .. nameIndex);

		-- (%FriendlistFriendstateText)
		--nameLine:SetText(TooltipHandler:ParseString("|cff%FriendlistFriendstateColour" .. nameText .. "|r" .. titleText .. " %FriendlistOnlineStatus","index" .. nameIndex));
		nameLine:SetText("|cff" .. Friendlist:GetFriendstateColour(entryName) .. nameText .. "|r" .. titleText .. " " .. onlineText);
      
		classLine:SetText(" " .. raceText .. classText .. levelText .. guildText .. rankText);
		noteLine:SetText(" " .. notesText);
      
		--nameLine:SetWidth(425);
		--classLine:SetWidth(425);
		--noteLine:SetWidth(425);
      
		local nameWidth = nameLine:GetWidth();
		local notesWidth = noteLine:GetWidth();

		local colourCode = Friendlist:GetFriendstateColour(entryName);
           
		while nameWidth > 415 do
			if string.len(nameText) <= string.len(titleText) then
				if string.sub(titleText,string.len(titleText)-2,string.len(titleText)) ~= "..." then
					titleText = titleText .. "...";
				end
				titleText = string.sub(titleText, 1, string.len(titleText)-4) .. "...";
			else
				if string.sub(nameText,string.len(nameText)-2,string.len(nameText)) ~= "..." then
					nameText = nameText .. "...";
				end
				nameText = string.sub(nameText, 1, string.len(nameText)-4) .. "...";
			end
			nameLine:SetText("|cff" .. colourCode .. nameText .. "|r" .. titleText .. " " .. onlineText);
			nameWidth = nameLine:GetWidth();
		end

		--FlagRSP:printDebug("nameLine height: line " .. i .. ", "  .. nameLine:GetWidth());

		--if notesWidth < 415 then
			--notesText = notesText .. "...";
		--end

		while notesWidth > 415 do
			if notesWidth > 450 then
				notesText = string.sub(notesText, 1, string.len(notesText)-8) .. "...";
			else
				notesText = string.sub(notesText, 1, string.len(notesText)-5) .. "...";
			end

			noteLine:SetText(" " .. notesText);
			notesWidth = noteLine:GetWidth();
		end
   
		local nameButton = getglobal("FRIENDLISTBFButton"..i);
		nameButton:SetID(nameIndex);
      
		-- Update the highlight
		if ( nameIndex == FRIENDLISTFrame.selectedMember ) then
			nameButton:LockHighlight();
		else
			nameButton:UnlockHighlight();
		end
      
		-- Turn off Lines not in use
		if ( nameIndex > Friendlist:GetFriends()) then
			nameButton:Hide();
		else
			nameButton:Show();
		end
	end

	ticks[FRIENDLIST_NAMES_TO_DISPLAY+1] = GetTime();

	for i=1, FRIENDLIST_NAMES_TO_DISPLAY, 1 do
		FlagRSP:printDebug("entry: " .. i .. ". It is: " .. ticks[i+1]-ticks[i]);
	end

	-- ScrollFrame stuff
	FauxScrollFrame_Update(FRIENDLISTBFScrollFrame, Friendlist:GetFriends(), FRIENDLIST_NAMES_TO_DISPLAY, FRIENDLIST_FRAME_HEIGHT );
end

--[[

FriendlistMain_Update()

-- Updates the Friendlist main frame

]]--
function FriendlistMain_Update(update)
	if update == nil then
		update = false;
	end

	if not FlagRSPConfigure:IsInitialized() then
		return "";
	end

	if GetTime() > FriendlistFrame.updateTickInfoBox or update then
		--FlagRSP:printDebug("called: FriendlistMain_Update");
      
		--DEFAULT_CHAT_FRAME:AddMessage("Before or after C?");
		--FRIENDLISTFrameInfoBox:Show();
      
		local index = FRIENDLISTFrame.selectedMember;
		local lines = {};
		if FRIENDLISTFrame.selectedMember > 0 and TooltipHandler:GetCharacterName("index" .. index, "unit") ~= "" and TooltipHandler:GetCharacterName("index" .. index, "unit") ~= nil then
			if ( FlagRSPConfigure:GetFriendlistEntryBox() ) then 
--[[				if TooltipHandler:ParseString("%flagRSPSurname","index" .. index) ~= "" then
					if ( string.sub(TooltipHandler:ParseString("%flagRSPSurname","index" .. index), 1, 1) == "," ) then
						lines[1] = TooltipHandler:ParseString("|cff%FriendlistFriendstateColour%UnitName%flagRSPSurname|r","index" .. index);
					else
						lines[1] = TooltipHandler:ParseString("|cff%FriendlistFriendstateColour%UnitName %flagRSPSurname|r","index" .. index);
					end
				else
					lines[1] = TooltipHandler:ParseString("|cff%FriendlistFriendstateColour%UnitName|r","index" .. index);
				end ]]--
				local playerID = "index" .. index;
				
				lines[1] = "|cFF" .. Friendlist:GetFriendstateColour(TooltipHandler:GetCharacterName(playerID, "unit")) .. TooltipHandler:BuildName(playerID) .. "|r";
	    
				-- (%FriendlistFriendstateText)
				lines[2] = TooltipHandler:ParseString("%FriendlistFriendstateText","index" .. index);
				lines[3] = TooltipHandler:ParseString("%UnitTitle","index" .. index);
				lines[4] = TooltipHandler:ParseString("<%UnitGuild>","index" .. index);
				if lines[4] == "<>" then
					lines[4] = "";
				end
	    
				if TooltipHandler:ParseString("%UnitRace","index" .. index) == "" then
					lines[5] = TooltipHandler:ParseString("%UnitClass","index" .. index);
				else
					lines[5] = TooltipHandler:ParseString("%UnitRace %UnitClass","index" .. index);
				end
	    
				--FlagRSP:printDebug("level of a guild: " .. TooltipHandler:getLevel("index" .. index));
		    
				if TooltipHandler:getLevel("index" .. index) ~= 0 and TooltipHandler:getLevel("index" .. index) ~= "" then
					lines[6] = TooltipHandler:ParseString("%flagRSPLevel","index" .. index);
				end
	    
				lines[7] = TooltipHandler:ParseString("%flagRSPRankLine","index" .. index);
				lines[8] = TooltipHandler:ParseString("%flagRSPRPLine","index" .. index);
				lines[9] = TooltipHandler:ParseString("%flagRSPCharStatusLine","index" .. index);
				
				local notesText, descText;
				if FlagRSPInfo.FLInfoIsExpanded then
					notesText = Friendlist:GetNotes(TooltipHandler:GetCharacterName(playerID, "unit"));
					descText = FlagRSPInfo:GetDescription(TooltipHandler:GetCharacterName(playerID, "unit"));
				else
					notesText = Friendlist:GetNotes(TooltipHandler:GetCharacterName(playerID, "unit"));
					if string.len(notesText) > FlagRSPInfo.maxCharsUnExpanded then
						notesText = string.sub(notesText, 1, FlagRSPInfo.maxCharsUnExpanded) .. "..."; 
					end

					descText = FlagRSPInfo:GetDescription(TooltipHandler:GetCharacterName(playerID, "unit"), playerID, FlagRSPInfo.maxCharsUnExpanded);
				end
	    
				if notesText == "Gilde" then
					notesText = FRIENDLIST_LOCALE_GuildLine;
				end
	    
				if notesText ~= "" and notesText ~= nil then
					lines[10] = "|cFFFFFF00" .. FlagRSP_Locale_InfoBoxNotes .. "|r |cFFFFFFFF" .. notesText .. "|r";
				end
				if descText ~= "" and descText ~= nil then
					lines[11] = "|cFFFFFF00" .. FlagRSP_Locale_InfoBoxDesc .. "|r |cFFFFFFFF" .. descText .. "|r";
				end
--[[				for i = 1, 11 do
					if ( lines[i] ~= nil and lines[i] ~= "" ) then
						ChatFrame4:AddMessage(tostring(lines[i]));
					end
				end]]--
			end
	 
			if not FlagRSPInfo.FLInfoIsMoving then
				FlagRSPInfo:updateBox("FRIENDLISTFrameInfoBox", lines, "FRIENDLISTFrame", false, FlagRSPInfo.FLInfoX, FlagRSPInfo.FLInfoY, 300, FlagRSPConfigure:GetFriendlistEntryBox());
			end
		else
			FlagRSPInfo:updateBox("FRIENDLISTFrameInfoBox", lines, "FRIENDLISTFrame", false, FlagRSPInfo.FLInfoX, FlagRSPInfo.FLInfoY, 300, false);
		end
      
		FriendlistFrame.updateTickInfoBox = GetTime() + FriendlistFrame.updateInfoBoxInterval;
	end
   
	if GetTime() > FriendlistFrame.updateTick then
		FRIENDLIST_Update();
		FriendlistFrame.updateTick = GetTime() + FriendlistFrame.updateInterval;
	end
end

function FRIENDLISTFrameInfoBoxCloseButton_OnClick()
	FlagRSP:printDebug("Close!");
	FlagRSPConfigure:SetFriendlistEntryBox(false);
end

function FRIENDLISTRemoveButton_OnClick()
	local friend;
   
	if (FRIENDLISTFrame.selectedMember > 0) then
		friend = Friendlist:GetFriend(FRIENDLISTFrame.selectedMember);
		--DelFRIEND(name);
		Friendlist:DeleteFriend(friend.name);
		FRIENDLISTFrameInfoBox:Hide();
		FRIENDLIST_Update();
	--else
		--Print_Chat("Keine Person/Gilde zum l\195\182schen ausgew\195\164hlt");
	end
end

function FRIENDLISTMiniMap_OnLoad()

	local state = FlagRSPConfigure:GetButtonState();
	if ( state == false or state == nil ) then
		FlagRSPConfigure:SetButtonState(false);
		FRIENDLISTMinimapButton:Hide();
	else
		FlagRSPConfigure:SetButtonState(true);
		FRIENDLISTMinimapButton:Show();
	end
end

------------------------------------------------------------------------------------------
--======================================================================================--
-- STATIC POPUP ADD -- STATIC POPUP ADD -- STATIC POPUP ADD -- STATIC POPUP ADD         -- 
--======================================================================================--
------------------------------------------------------------------------------------------

function FRIENDLISTStaticPopUpAdd_OnClick(index)
	local name = nil;
	local nachnameString = nil;
	local noteString = nil;
	if (index == 1) then
		-- ADD button
		local editbox1 = getglobal(this:GetParent():GetName().."EditBox1");
		local editbox2 = getglobal(this:GetParent():GetName().."EditBox2");
		local editbox3 = getglobal(this:GetParent():GetName().."ScrollFrameChildFrameEditBox");
		local checkbox = getglobal(this:GetParent():GetName().."FRIENDCheckButton");
      
      
		--getglobal(this:GetName().."EditBox1"):Insert(name);
		--name = "TestName";
		--EditBox1:Insert(name);
      
		name = editbox1:GetText();
		nachnameString = editbox2:GetText();
		noteString = editbox3:GetText();
		local checked;
      
		if (checkbox:GetChecked() == 1) then 
			checked = true;
		else
			checked = false;
		end

		--Edit Boxes do not return nil when there is no text
		if (editbox1:GetNumLetters() <= 0) then
			name = nil;
		end
		if (editbox2:GetNumLetters() <= 0) then
			nachnameString = "";
		end
		if (editbox3:GetNumLetters() <= 0) then
			noteString = "";
		end

		if ( (name ~= nil) and (name ~= "") ) then
--			if (noteString == nil) and (nachnameString == nil) then 
--				AddFRIEND(name, "", "");
--			else
--				AddFRIEND(name, noteString, nachnameString);
--			end
			
			local friend = { };
			friend.name = name;
			friend.surname = nachnameString;
			friend.notes = noteString;
			
			--Update friendly status based on checkbox value
			if (checked) then
				--Enemy flagged
				friend.friendstate = -10;
			else
				friend.friendstate = 10;
			end
			
			Friendlist:AddFriend(friend);
		end
      
		FRIENDLIST_Update();
		this:GetParent():Hide();
      
	elseif(index == 2) then
		-- CANCEL button
		this:GetParent():Hide();
	end
end

function FRIENDLISTStaticPopUpAdd_OnHide()
	getglobal(this:GetName().."EditBox1"):SetText("");
	getglobal(this:GetName().."EditBox2"):SetText("");
	getglobal(this:GetName().."EditBox3"):SetText("");
	getglobal(this:GetName().."EditBox4"):SetText("");
end

------------------------------------------------------------------------------------------	

function FriendlistAddEditDialog_getElements(base)
	local titleText = getglobal(base .. "Title");
	local texts = {
		getglobal(base .. "NameText"),
		getglobal(base .. "GivenNameText"),
		getglobal(base .. "SurnameText"),
		getglobal(base .. "TitleText"),
		getglobal(base .. "FriendstateText"),
		getglobal(base .. "NotesText"),
	}
	local boxes = {
		{ getglobal(base .. "EditBox1"), getglobal(base .. "EditBox1DummyFrame")},
		{ getglobal(base .. "EditBox4"), getglobal(base .. "EditBox4DummyFrame")},
		{ getglobal(base .. "EditBox2"), getglobal(base .. "EditBox2DummyFrame")},
		{ getglobal(base .. "EditBox3"), getglobal(base .. "EditBox3DummyFrame")},
		{},
		{ getglobal(base .. "ScrollFrame"), getglobal(base .. "ScrollFrameDummyFrame"),  getglobal(base .. "ScrollFrameChildFrame"), getglobal(base .. "ScrollFrameChildFrameEditBox")},
	}
	local dropDown = getglobal(base .. "DropDown");
	local buttons = {
		getglobal(base .. "Accept"),
		getglobal(base .. "CloseButton")
	}

	return titleText, texts, boxes, dropDown, buttons;
end


function FRIENDLISTStaticPopUpAdd_OnShow()
	local base = this:GetName();
	local titleText, texts, boxes, dropDown, buttons = FriendlistAddEditDialog_getElements(base);

	local tVis = FriendlistFrame.addEditDialogs[base].textsVisibility;
	local type = "char";

	if tVis == nil then
		--tVis = {};
		local name = TooltipHandler:GetCharacterName("index" .. FRIENDLISTFrame.selectedMember, "unit");
		getglobal(base .. "NameDummy"):SetText(name);
		FlagRSP:printDebug("editing " .. name);
      
		if Friendlist:GetType(name) == "guild" then
			FlagRSP:printDebug(name .. "is guild");
			if FriendlistFrame.addEditDialogs[base].guildTextsVisibility ~= nil then
				FlagRSP:printDebug("is nil");
			else
				FlagRSP:printDebug("is not nil");
			end
			tVis = FriendlistFrame.addEditDialogs[base].guildTextsVisibility;
			FriendlistFrame.dropDowns[dropDown:GetName()] = FriendlistFrame.dropDowns["FRIENDLISTStaticPopUpAddGuildDropDown"];
			type = "guild";
		elseif Friendlist:GetType(name) == "char" then
			FlagRSP:printDebug(name .. "is char");
			if FriendlistFrame.addEditDialogs[base].charTextsVisibility ~= nil then
				FlagRSP:printDebug("is nil");
			else
				FlagRSP:printDebug("is not nil");
			end
			tVis = FriendlistFrame.addEditDialogs[base].charTextsVisibility;

			FriendlistFrame.dropDowns[dropDown:GetName()] = FriendlistFrame.dropDowns["FRIENDLISTStaticPopUpAddDropDown"];
		end
	end

	titleText:SetText("Title text here");
	titleText:SetTextHeight(16);

	this:SetScale(2);
	this:SetScale(1);
   
	local maxwidth = 0;
	local sumheight = 0;
	local width = 0;

	local lastVisible = 1;
	for i=2, table.getn(texts) do
		if tVis[i] then
			FlagRSP:printDebug("show " .. i);

			texts[i]:SetPoint("TOPLEFT", texts[lastVisible]:GetName(), "BOTTOMLEFT", 0, -18);

			if boxes[i][1] ~= nil then
				boxes[i][1]:Show();
				boxes[i][2]:Show();
			end
			texts[i]:Show();
			lastVisible = i;
		else
			FlagRSP:printDebug("hide " .. i);
			if boxes[i][1] ~= nil then
				boxes[i][1]:Hide();
				boxes[i][2]:Hide();
			end
			texts[i]:Hide();
		end
	end

	for i=1, table.getn(texts) do
		if texts[i]:IsVisible() then
			width = texts[i]:GetWidth();
			sumheight = sumheight + texts[i]:GetHeight() + 18;
		else
			width = 0;
			FlagRSP:printDebug("text " .. i .. "is not visible");
		end
		if width > maxwidth then maxwidth = width; end
	end

	-- prepare window.   
	for i=1, FRIENDLIST_NOTES_BOX do
		if boxes[i][1] ~= nil then
			--FlagRSP:printDebug("attaching " .. boxes[i][1]:GetName() .. " to " .. texts[i]:GetName());
			--FlagRSP:printDebug("attaching " .. boxes[i][2]:GetName() .. " to " .. texts[i]:GetName());
			boxes[i][1]:SetPoint("TOPLEFT",texts[i]:GetName(),"TOPLEFT",maxwidth+10,3);
			boxes[i][2]:SetPoint("TOPLEFT",texts[i]:GetName(),"TOPLEFT",maxwidth+10,3);
			boxes[i][1]:SetWidth(this:GetWidth()-45-maxwidth);
			boxes[i][2]:SetWidth(this:GetWidth()-45-maxwidth);
			boxes[i][2]:SetTexture("Interface\\AddOns\\flagRSP\\BackDropWhite");
			if boxes[i][3] ~= nil then
				--FlagRSP:printDebug("scroll frame!");
				boxes[i][1]:SetWidth(this:GetWidth()-67-maxwidth);
				boxes[i][2]:SetWidth(this:GetWidth()-68-maxwidth);
				boxes[i][3]:SetWidth(this:GetWidth()-68-maxwidth);
				boxes[i][4]:SetWidth(this:GetWidth()-68-maxwidth);
				boxes[i][4]:SetTextColor(1,1,1);
				boxes[i][4]:SetText("");
			else
				boxes[i][1]:SetTextColor(1,1,1);
				boxes[i][1]:SetText("");
			end
	 
			--boxes[i][1]:Show();
		end
	end

	boxes[FRIENDLIST_NAME_BOX][1]:SetFocus();

	dropDown:SetPoint("TOPLEFT",texts[FRIENDLIST_FRIENDSTATE_DROPDOWN]:GetName(),"TOPLEFT",maxwidth-6,8);
	Friendlist_DropDownSetValue(dropDown:GetName(), 0);

	FriendlistFrame.dropDowns[dropDown:GetName()].width = this:GetWidth()-65-maxwidth;
	FlagRSP:printDebug(boxes[FRIENDLIST_NOTES_BOX][4]:GetName());
	FriendlistFrame.scrollFrames[boxes[FRIENDLIST_NOTES_BOX][4]:GetName()].height = this:GetHeight()-65-sumheight;

	dropDown:Hide();
	dropDown:Show();

	this:SetBackdropColor(0,0,0,0.9);
   
	titleText:SetText(FriendlistFrame.addEditDialogs[base].titleText);
	buttons[1]:SetText(FriendlistFrame.addEditDialogs[base].acceptText);
	buttons[2]:SetText(FriendlistFrame.addEditDialogs[base].closeText);

	FriendlistFrame.showFriendlistEntryBox = FlagRSPConfigure:GetFriendlistEntryBox();
	FlagRSPConfigure:SetFriendlistEntryBox(false);

	local dialog;
	for name, value in pairs(FriendlistFrame.addEditDialogs) do
		--FlagRSP:printM(name);
		dialog = getglobal(name);
		if dialog ~= nil and dialog:IsVisible() and dialog ~= this then
			dialog:Hide();
		end
	end
   
	--getglobal(this:GetName().."EditBox1"):SetFocus();

	local init = getglobal(FriendlistFrame.addEditDialogs[base].initialize);

	if init ~= nil then
		init(boxes, type, dropDown);
	else
		FlagRSP:printDebug("No init function for: " .. base);
	end
end

--[[

FriendlistAddEditDialog_OnButtonClick(state)

-- Handler function for clicked buttons in add/edit dialogs.

]]--
function FriendlistAddEditDialog_OnButtonClick(state)
	local base = this:GetParent():GetName();
	local returnLevel;

	FlagRSP:printDebug(base);
	local titleText, texts, boxes, dropDown = FriendlistAddEditDialog_getElements(base);
   
	if state == 1 then
		local onAccept = getglobal(FriendlistFrame.addEditDialogs[base].acceptClicked);
		if onAccept ~= nil then
			returnLevel = onAccept(boxes);
		else
			FlagRSP:printDebug("No onAccept function for: " .. base);
		end   
	elseif state == 0 then
		this:GetParent():Hide();
	end

	if returnLevel == 0 or state == 0 then
		FlagRSPConfigure:SetFriendlistEntryBox(FriendlistFrame.showFriendlistEntryBox);
	end
end

--[[

Friendlist_initAddFriendDialog(boxes)

-- initialization function for the add friend dialog.

]]--
function Friendlist_initAddFriendDialog(boxes)
	FlagRSP:printDebug("Initializing add friend frame");
   
	local targetName = UnitName("target");
      
	if targetName ~= nil then
		boxes[FRIENDLIST_SURNAME_BOX][1]:SetFocus();      

		boxes[FRIENDLIST_NAME_BOX][1]:SetText(targetName);
		local altName = TooltipHandler:GetCharacterName("target", "first");
		if ( altName ~= targetName ) then
			boxes[FRIENDLIST_GIVEN_NAME_BOX][1]:SetText(altName);
		end
		local surname = TooltipHandler:getSurname(targetName);
		boxes[FRIENDLIST_SURNAME_BOX][1]:SetText(surname);
		local title = TooltipHandler:getTitle(targetName);
		boxes[FRIENDLIST_TITLE_BOX][1]:SetText(title);
	end
end

--[[

Friendlist_initAddGuildDialog(boxes)

-- initialization function for the add guild dialog.

]]--
function Friendlist_initAddGuildDialog(boxes)
	FlagRSP:printDebug("Initializing add friend frame");
   
	local guildName = GetGuildInfo("target");
      
	if guildName ~= nil then
		boxes[FRIENDLIST_NAME_BOX][1]:SetText(guildName);
      
		boxes[FRIENDLIST_NOTES_BOX][4]:SetFocus();
	end
end

--[[

Friendlist_initEditEntryDialog(boxes,type)

-- initialization function for the edit dialog.

]]--
function Friendlist_initEditEntryDialog(boxes, type, dropDown)
	FlagRSP:printDebug("Initializing edit friend frame");
   
	local playerID = "index" .. FRIENDLISTFrame.selectedMember;
	local name = TooltipHandler:GetCharacterName(playerID, "unit");
	local notes = Friendlist:GetNotes(name);
	local friendstate = Friendlist:GetFriendstate(name);

	boxes[FRIENDLIST_NAME_BOX][1]:SetText(name);
	boxes[FRIENDLIST_NOTES_BOX][4]:SetText(notes);

	Friendlist_DropDownSetValue(dropDown:GetName(), friendstate);

	if type == "char" then
		local r, g, b, text = Friendlist:GetFriendstateInfo(friendstate);

		FriendlistFrame.dropDowns["FRIENDLISTStaticPopUpEditDropDown"].selectedText = text;
      
		FRIENDLISTStaticPopUpEditDropDown:Hide();
		FRIENDLISTStaticPopUpEditDropDown:Show();

		local surname = TooltipHandler:getSurname(name);
		local title = TooltipHandler:getTitle(name);
		local altName = TooltipHandler:GetCharacterName(playerID, "first");
		
		if ( altName ~= name ) then
			if ( altName == nil ) then
				altName = "";
			end
			boxes[FRIENDLIST_GIVEN_NAME_BOX][1]:SetText(altName);
		end
		boxes[FRIENDLIST_SURNAME_BOX][1]:SetText(surname);
		boxes[FRIENDLIST_TITLE_BOX][1]:SetText(title);
	elseif type == "guild" then
		local r, g, b, text = Friendlist:GetFriendstateGuildInfo(friendstate);
       
		FriendlistFrame.dropDowns["FRIENDLISTStaticPopUpEditDropDown"].selectedText = text;
      
		FRIENDLISTStaticPopUpEditDropDown:Hide();
		FRIENDLISTStaticPopUpEditDropDown:Show();
	else
		FlagRSP:printA(3);
	end
end

--[[

Friendlist_addFriendOnAccept(boxes)

-- function for add friend dialog after acccept click.

]]--
function Friendlist_addFriendOnAccept(boxes)
	FlagRSP:printDebug("Adding friend clicked.");

	local exitCode = 1;
	local friend = { };

	friend.name = boxes[FRIENDLIST_NAME_BOX][1]:GetText();
	friend.altName = boxes[FRIENDLIST_GIVEN_NAME_BOX][1]:GetText();
	friend.surname = boxes[FRIENDLIST_SURNAME_BOX][1]:GetText();
	friend.title = boxes[FRIENDLIST_TITLE_BOX][1]:GetText();
	friend.notes = boxes[FRIENDLIST_NOTES_BOX][4]:GetText();
	friend.friendstate = FriendlistFrame.dropDowns["FRIENDLISTStaticPopUpAddDropDown"].selectedValue;
   
	FlagRSP:printDebug("Adding " .. friend.name .. " " .. friend.surname .. ", title: " .. friend.title .. " and notes: " .. friend.notes .. ". Friendstate is: " .. friend.friendstate);

	if friend.name ~= nil and friend.name ~= "" and not Friendlist:isFriend(friend.name) then
		--AddFRIEND(name, notes, surname, title, friendstate, "char", nil, altName);
		Friendlist:AddFriend(friend);
		
		this:GetParent():Hide();
		exitCode = 0;
	elseif Friendlist:isFriend(friend.name) then
		FlagRSP:printE(string.gsub(FRIENDLIST_LOCALE_NameExistsMsg,"%%n",friend.name));
	end

	return exitCode;
end

--[[

Friendlist_addGuildOnAccept(boxes)

-- function for add guild dialog after acccept click.

]]--
function Friendlist_addGuildOnAccept(boxes)
	FlagRSP:printDebug("Adding guild clicked.");

	local exitCode = 1;
	local friend = { };

	friend.name = boxes[FRIENDLIST_NAME_BOX][1]:GetText();
	friend.notes = boxes[FRIENDLIST_NOTES_BOX][4]:GetText();
	friend.friendstate = FriendlistFrame.dropDowns["FRIENDLISTStaticPopUpAddGuildDropDown"].selectedValue;
	friend.type = "guild";
   
	FlagRSP:printDebug("Adding " .. friend.name .. " and notes: " .. friend.notes .. ". Friendstate is: " .. friend.friendstate);

	if friend.name ~= nil and friend.name ~= "" and not Friendlist:isFriend(friend.name) then
		--AddFRIEND(name, notes, "", "", friendstate, "guild");
		Friendlist:AddFriend(friend);
		
		this:GetParent():Hide();
		exitCode = 0;
	elseif Friendlist:isFriend(friend.name) then
		FlagRSP:printE(string.gsub(FRIENDLIST_LOCALE_NameExistsMsg,"%%n",friend.name));
	end
   
	return exitCode;
end

--[[

Friendlist_editEntryOnAccept(boxes, oldName)

-- function for edit entry dialog after acccept click.

]]--
function Friendlist_editEntryOnAccept(boxes, oldName)
	FlagRSP:printDebug("edit ok clicked.");

	local exitCode = 1;
	local friend = { };

	friend.name = FRIENDLISTStaticPopUpEditNameDummy:GetText();
	friend.newName = boxes[FRIENDLIST_NAME_BOX][1]:GetText();
	friend.altName = boxes[FRIENDLIST_GIVEN_NAME_BOX][1]:GetText();
	friend.surname = boxes[FRIENDLIST_SURNAME_BOX][1]:GetText();
	friend.title = boxes[FRIENDLIST_TITLE_BOX][1]:GetText();
	friend.notes = boxes[FRIENDLIST_NOTES_BOX][4]:GetText();
	friend.friendstate = FriendlistFrame.dropDowns["FRIENDLISTStaticPopUpEditDropDown"].selectedValue;
	friend.type = Friendlist:GetType(friend.name);
   
	FlagRSP:printDebug("Editing " .. friend.name .. " to " .. friend.newName .. " " .. friend.surname .. ", title: " .. friend.title .. " and notes: " .. friend.notes .. ". Friendstate is: " .. friend.friendstate);

	if friend.name ~= nil and friend.name ~= "" then
		if ( not Friendlist:isFriend(friend.newName) or friend.name == friend.newName ) then
			Friendlist:EditFriend(friend);
			this:GetParent():Hide();
			exitCode = 0;
		else
			FlagRSP:printE(string.gsub(FRIENDLIST_LOCALE_NameExistsMsg,"%%n",friend.name)); 
		end
	end
   
	return exitCode;
end

--[[

flagRSPCharPageMultilineEditBox_Update()

-- sets correct height for multiline edit boxes.

]]--
function flagRSPCharPageMultilineEditBox_Update()
	local height = FriendlistFrame.scrollFrames[this:GetName()].height;

	local scrollFrame = getglobal(string.sub(this:GetName(),1,string.len(this:GetName())-17));
	local dummyFrame = getglobal(string.sub(this:GetName(),1,string.len(this:GetName())-17) .. "DummyFrame");

	scrollFrame:SetHeight(height);
	this:SetHeight(height);
	dummyFrame:SetHeight(height);
end

------------------------------------------------------------------------------------------		
	
function FRIENDLISTStaticPopUpAdd_EditBoxOnEnterPressed()
	FRIENDLISTStaticPopUpAdd_OnClick(1);

	FRIENDLISTStaticPopUpAddEditBox1:SetText("");
	FRIENDLISTStaticPopUpAddEditBox2:SetText("");
	FRIENDLISTStaticPopUpAddEditBox3:SetText("");
	FRIENDLISTStaticPopUpAddEditBox4:SetText("");
	FRIENDLISTStaticPopUpAddEditBox1:SetFocus();
end

------------------------------------------------------------------------------------------		

function FRIENDLISTStaticPopUpAdd_EditBoxOnEscapePressed()
	FRIENDLISTStaticPopUpAdd_OnClick(2);
end


------------------------------------------------------------------------------------------
--======================================================================================--
-- STATIC POPUP GUILD -- STATIC POPUP GUILD -- STATIC POPUP GUILD -- STATIC POPUP GUILD -- 
--======================================================================================--
------------------------------------------------------------------------------------------	

function FRIENDLISTStaticPopUpAddGuild_OnHide()
	getglobal(this:GetName().."EditBox1"):SetText("");
end

------------------------------------------------------------------------------------------	

function FRIENDLISTStaticPopUpAddGuild_OnShow()
	if FRIENDLISTStaticPopUpAdd:IsVisible() then FRIENDLISTStaticPopUpAdd:Hide(); end
	if FRIENDLISTStaticPopUpEdit:IsVisible() then FRIENDLISTStaticPopUpEdit:Hide(); end
	if FRIENDLISTStaticPopUpAddNN:IsVisible() then FRIENDLISTStaticPopUpAddNN:Hide(); end
	
	getglobal(this:GetName().."EditBox1"):SetFocus();
	getglobal(this:GetName().."EditBox1"):Insert(GetGuildInfo("target"));
end
	
------------------------------------------------------------------------------------------		
	
function FRIENDLISTStaticPopUpAddGuild_EditBoxOnEnterPressed()
	FRIENDLISTStaticPopUpAddGuild_OnClick(1);

	FRIENDLISTStaticPopUpAddEditBox1:SetText("");
	FRIENDLISTStaticPopUpAddEditBox1:SetFocus();
end

------------------------------------------------------------------------------------------		

function FRIENDLISTStaticPopUpAddGuild_EditBoxOnEscapePressed()
	FRIENDLISTStaticPopUpAddGuild_OnClick(2);
end

function FRIENDLISTStaticPopUpAddGuild_OnClick(index)
	local guildName = nil;
	
		
	if (index == 1) then
		-- ADD button
		local editbox1 = getglobal(this:GetParent():GetName().."EditBox1");
		local checkbox = getglobal(this:GetParent():GetName().."FRIENDCheckButton");
				
		guildName = editbox1:GetText();
		local checked;

		if (checkbox:GetChecked() == 1) then 
			checked = true;
		else
			checked = false;
		end

		--Edit Boxes do not return nil when there is no text and "" won't catch it either
		if (editbox1:GetNumLetters() <= 0) then
			guildName = nil;
		end
		
		if ( (guildName ~= nil) and (guildName ~= "") ) then
			--AddFRIEND(guildName, "Gilde", "");
			
			local friend = { };
			friend.name = guildName;
			friend.type = "guild";
			
			--Update friendly status based on checkbox value
			if (checked) then
				--Enemy flagged
				friend.friendstate = -10;
			else
				friend.friendstate = 10;
			end	
			Friendlist:AddFriend(friend);
		end

		
		FRIENDLIST_Update();
		this:GetParent():Hide();
	elseif(index == 2) then
		-- CANCEL button
		this:GetParent():Hide();
	end
end

------------------------------------------------------------------------------------------
--======================================================================================--
-- STATIC POPUP EDIT -- STATIC POPUP EDIT -- STATIC POPUP EDIT -- STATIC POPUP EDIT -- 
--======================================================================================--
------------------------------------------------------------------------------------------	

function FRIENDLISTStaticPopUpEdit_OnHide()
	getglobal(this:GetName().."EditBox1"):SetText("");
	getglobal(this:GetName().."EditBox2"):SetText("");
	getglobal(this:GetName().."EditBox3"):SetText("");
	getglobal(this:GetName().."EditBox4"):SetText("");
end

function FRIENDLISTStaticPopUpEdit_OnShow()
	if FRIENDLISTStaticPopUpAdd:IsVisible() then FRIENDLISTStaticPopUpAdd:Hide(); end
	if FRIENDLISTStaticPopUpAddGuild:IsVisible() then FRIENDLISTStaticPopUpAddGuild:Hide(); end
	if FRIENDLISTStaticPopUpAddNN:IsVisible() then FRIENDLISTStaticPopUpAddNN:Hide(); end
	
	--local name, notes, class, guild, level, killCount, killedByCount, friendstate, nachname;
	local friend = { };
		
	if (FRIENDLISTFrame.selectedMember > 0) then
		--name, notes, class, guild, level, killCount, killedByCount, friendstate, nachname = GetFRIENDInfo(FRIENDLISTFrame.selectedMember);
		friend = Friendlist:GetFriend(FRIENDLISTFrame.selectedMember);

		getglobal(this:GetName().."EditBox1"):Insert(friend.name);
		getglobal(this:GetName().."EditBox2"):Insert(friend.surname);
		getglobal(this:GetName().."EditBox3"):Insert(friend.notes);

		
		if (friendstate <= -10) then
			--Enemy
			getglobal(this:GetName().."FRIENDCheckButton"):SetChecked(1);
		else
			getglobal(this:GetName().."FRIENDCheckButton"):SetChecked(0);
		end
		
		FRIENDLIST_Update();
	end
	
	--Set global
	Friendlist.originalName = name;
	local originalNachname = nachname;
	local originalNotes = notes;
	
	-- catch error
	if originalNachname == NIL then originalNachname = ""; end
	if originalNotes == NIL then originalNotes = ""; end
	
	--Can't edit Guild Field
	if (string.lower(originalNotes) == "gilde") then
		getglobal(this:GetName().."EditBox2"):Hide();
		getglobal(this:GetName().."EditBox3"):Hide();
		getglobal(this:GetName().."NachnameFont"):Hide();
		getglobal(this:GetName().."NotesFont"):Hide();
		getglobal(this:GetName().."FRIENDCheckButton"):Show();
	else
		getglobal(this:GetName().."EditBox2"):Show();
		getglobal(this:GetName().."EditBox3"):Show();
		getglobal(this:GetName().."NachnameFont"):Show();
		getglobal(this:GetName().."NotesFont"):Show();
		getglobal(this:GetName().."FRIENDCheckButton"):Show();
	end
	getglobal(this:GetName().."EditBox1"):SetFocus();
end

function FRIENDLISTStaticPopUpEdit_EditBoxOnEnterPressed()
	FRIENDLISTStaticPopUpEdit_OnClick(1);

	FRIENDLISTStaticPopUpEditEditBox1:SetText("");
	FRIENDLISTStaticPopUpEditEditBox1:SetFocus();
end

function FRIENDLISTStaticPopUpEdit_EditBoxOnEscapePressed()
	FRIENDLISTStaticPopUpEdit_OnClick(2);
end

function FRIENDLISTStaticPopUpEdit_OnClick(index)
	local updatedName = nil;
	local updatedNachname = nil;
	local updatedNotes = nil;
	local updatedfriendstate = nil;
	
	if (index == 1) then
		local friend = { };
		
		-- Update button
		local editbox1 = getglobal(this:GetParent():GetName().."EditBox1");
		local editbox2 = getglobal(this:GetParent():GetName().."EditBox2");
		local editbox3 = getglobal(this:GetParent():GetName().."EditBox3");
		local checkbox = getglobal(this:GetParent():GetName().."FRIENDCheckButton");
		
		friend.newName = editbox1:GetText();
		friend.surname = editbox2:GetText();
		friend.notes = editbox3:GetText();
		if (checkbox:GetChecked() == 1) then 
			--Checked means its an enemy
			friend.friendstate = -10;
		else
			friend.friendstate = 10;
		end
		
		--Edit Boxes do not return nil when there is no text and "" won't catch it either
		if (editbox1:GetNumLetters() <= 0) then
			friend.newName = nil;
		end
		
		if (editbox2:GetNumLetters() <= 0) then
			friend.surname = "";
		end
		
		if (editbox3:GetNumLetters() <= 0) then
			friend.notes = "";
		end
		
		-- TODO: Hide the old name so that it'll still exist and I won't have to do this.
		friend.name = Friendlist.originalName;
		
		if ( friend.newName ~= nil or friend.newName ~= "" ) then
			Friendlist:EditFriend(friend);
		end
		FRIENDLIST_Update();
		this:GetParent():Hide();
	elseif(index == 2) then
		-- CANCEL button
		this:GetParent():Hide();
	end
end

------------------------------------------------------------------------------------------
--======================================================================================--
-- STATIC POPUP ADD -- STATIC POPUP ADD -- LASTNAME & TITLES FOR YOU CHARACTER          -- 
--======================================================================================--
------------------------------------------------------------------------------------------

function FRIENDLISTStaticPopUpAddNN_OnClick(index)
	local name = nil;
	local noteString = nil;
   
	if (index == 1) then
		-- ADD button
		local editbox1 = getglobal(this:GetParent():GetName().."EditBox1");
		local editbox2 = getglobal(this:GetParent():GetName().."EditBox2");
      
		name = editbox1:GetText();
		noteString = editbox2:GetText();
      
		--Edit Boxes do not return nil when there is no text
		if (editbox1:GetNumLetters() <= 0) then
			name = "";
		end
		if (editbox2:GetNumLetters() <= 0) then
			noteString = "";
		end

		FlagRSP:setSurname(name);
		FlagRSP:setTitle(noteString);

		FRIENDLIST_Update();
		this:GetParent():Hide();
	elseif(index == 2) then
		-- CANCEL button
		this:GetParent():Hide();
	end
end

function FRIENDLISTStaticPopUpAddNN_OnHide()
	getglobal(this:GetName().."EditBox1"):SetText("");
	getglobal(this:GetName().."EditBox2"):SetText("");
end

function FRIENDLISTStaticPopUpAddNN_OnShow()
	if FRIENDLISTStaticPopUpAddGuild:IsVisible() then FRIENDLISTStaticPopUpAddGuild:Hide(); end
	if FRIENDLISTStaticPopUpEdit:IsVisible() then FRIENDLISTStaticPopUpEdit:Hide(); end
	if FRIENDLISTStaticPopUpAdd:IsVisible() then FRIENDLISTStaticPopUpAdd:Hide(); end
	--UIErrorsFrame:AddMessage("Spielt ihr ein Rollenspiel, so w\195\164hlt weise.", 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME);

	getglobal(this:GetName().."EditBox1"):Insert(FlagRSP:getOwnSurname());
	getglobal(this:GetName().."EditBox2"):Insert(FlagRSP:getOwnTitle());
	getglobal(this:GetName().."EditBox1"):SetFocus();
end

function FRIENDLISTStaticPopUpAddNN_EditBoxOnEnterPressed()
	FRIENDLISTStaticPopUpAddNN_OnClick(1);

	FRIENDLISTStaticPopUpAddNNEditBox1:SetText("");
	FRIENDLISTStaticPopUpAddNNEditBox2:SetText("");
	FRIENDLISTStaticPopUpAddNNEditBox1:SetFocus();
end

function FRIENDLISTStaticPopUpAddNN_EditBoxOnEscapePressed()
	FRIENDLISTStaticPopUpAddNN_OnClick(2);
end

--[[

Friendlist_TabHandler(id)

- Handler to change pages on Friendlist.

]]--
function Friendlist_TabHandler(id)
	if id == nil then
		id = this:GetID();
	end

	FlagRSP:printDebug("id is: " .. id);
  
	local tab, x, y;
	if FriendlistFrame.tabs[FriendlistFrame.currentTab].name ~= "" then
		tab = getglobal(FriendlistFrame.tabs[FriendlistFrame.currentTab].name);
		x = tab:GetLeft();
		y = tab:GetTop();
	end

	FriendlistFrame.currentTab = id;
	Friendlist:updateTabs(x,y);
end

--[[

Friendlist_PageHandler(id)

- Handler to turn over pages on Friendlist sub frames.

]]--
function Friendlist_PageHandler(id)
	FlagRSP:printDebug("id is: " .. id)

	if FriendlistFrame.pageButtons[id] ~= nil then
		FlagRSP:printDebug("Type is: " .. FriendlistFrame.pageButtons[id].type);
		FlagRSP:printDebug("ActivePage is: " .. FriendlistFrame.pageButtons[id].activePage);
		FlagRSP:printDebug("Page1 is: " .. FriendlistFrame.pageButtons[id].pages[1]);
		FlagRSP:printDebug("Page2 is: " .. FriendlistFrame.pageButtons[id].pages[2]);

		local numPages = table.getn(FriendlistFrame.pageButtons[id].pages);
		local activePage = FriendlistFrame.pageButtons[id].activePage;

		if activePage < numPages and (FriendlistFrame.pageButtons[id].type == "turn" or FriendlistFrame.pageButtons[id].type == "turnup") then
			activePage = activePage + 1;
		elseif activePage == numPages and FriendlistFrame.pageButtons[id].type == "turn" then
			activePage = 1;
		elseif activePage > 1 and FriendlistFrame.pageButtons[id].type == "turndown" then
			activePage = activePage - 1;
		end

		FriendlistFrame.pageButtons[id].activePage = activePage;

		FlagRSP:printDebug("New page is: " .. activePage);

		Friendlist:updatePages(id);
	end
end

--[[

Friendlist:updatePages(id)

-- Updates the subframe pages for page handler (i.e. button) id

]]--
function Friendlist:updatePages(id)
	if FriendlistFrame.pageButtons[id] ~= nil then
		local numPages = table.getn(FriendlistFrame.pageButtons[id].pages);
		local activePage = FriendlistFrame.pageButtons[id].activePage;
		local page;
      
		for i=1, numPages do
			page = getglobal(FriendlistFrame.pageButtons[id].pages[i]);
			if i == activePage then
				page:Show();
			else
				page:Hide();
			end
		end
	end
end

--[[

FriendlistMetaFrame_OnUpdate()

-- Update function for Metaframe. Checks if window should be hidden (after Escape e.g.)

]]--
function FriendlistMetaFrame_OnUpdate()
	local anythingVisible = false;
	local tab, tabbutton;

	for key, value in pairs(FriendlistFrame.tabs) do
		tab = getglobal(FriendlistFrame.tabs[key].name);
		if tab:IsVisible() then 
			anythingVisible = true;
		end
	end
	
	--FlagRSP:printDebug("Updating FL!");

	if not anythingVisible then
		FRIENDLIST_ToggleGUI();
	end
end

--[[

Friendlist:updateTabs()

- Updates the tab buttons (sets checked, ...).

]]--
function Friendlist:updateTabs(x, y)
	local tabbutton;
	local tab;
	--local x=0;
	--local y=0;

	if FriendlistFrame.tabs[FriendlistFrame.currentTab] == nil then
		FriendlistFrame.currentTab = "FRIENDLISTFrame";
	end

	if x == nil or y == nil then
		if FriendlistFrame.tabs[FriendlistFrame.currentTab].name ~= "" then
			tab = getglobal(FriendlistFrame.tabs[FriendlistFrame.currentTab].name);
			x = tab:GetLeft();
			y = tab:GetTop();
		end
	end
   
	FlagRSP:printDebug(x);
	FlagRSP:printDebug(y);

	--x=400;
	--y=400;


	--for i=1, 4 do
		--tabbutton = getglobal("Friendlist_PageTab" .. i);
	--end


	for key, value in pairs(FriendlistFrame.tabs) do
		tabbutton = getglobal(key .. "Tab");
      
		tabbutton:SetNormalTexture(FriendlistFrame.tabs[key].icon);
      
		tabbutton:SetWidth(32);
		tabbutton:SetHeight(32);
      
		if key == FriendlistFrame.currentTab then 
			tabbutton:SetChecked(1);
			if FriendlistFrame.tabs[key].name ~= "" then
				if i == "FRIENDLISTFrame" then
					FRIENDLISTFrameTab:SetPoint("TOPLEFT", FriendlistFrame.tabs[key].name, "TOPRIGHT", -33, -65);
				else
					FRIENDLISTFrameTab:SetPoint("TOPLEFT", FriendlistFrame.tabs[key].name, "TOPRIGHT", -31, -65);
				end

				tab = getglobal(FriendlistFrame.tabs[key].name);

				tab:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", x, y);

				--UIPanelWindows[tab:GetName()] = { area = "left", pushable = 0 };
				--UIPanelWindows[tab:GetName()] = nil;
    
				tab:Show();
				--ShowUIPanel(tab);
			end
		else
			tabbutton:SetChecked(0);
			if FriendlistFrame.tabs[key].name ~= "" then
				tab = getglobal(FriendlistFrame.tabs[key].name);

				tab:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", x, y);

				tab:Hide();
			end
		end
 
		tabbutton:SetScale(1);
 
		tabbutton:Show();
	end
end

--[[

Friendlist_DropDownHandler(id)

-- Handler to initialize drop down boxes.

]]--
function Friendlist_DropDownHandler(frame, name)
   --dropDowns = {
   --FriendlistCharFrameRPDropDown = {initialize=FriendlistCharFrameRPDropDown_Initialize},
   --};

	if FlagRSP ~= nil and Friendlist ~= nil then
		if FriendlistFrame.dropDowns[name] ~= nil then
			UIDropDownMenu_Initialize(frame, getglobal(FriendlistFrame.dropDowns[name].initialize));
			UIDropDownMenu_SetSelectedValue(frame, FriendlistFrame.dropDowns[name].selectedValue);
			UIDropDownMenu_SetText(FriendlistFrame.dropDowns[name].selectedText, frame);
			UIDropDownMenu_SetWidth(FriendlistFrame.dropDowns[name].width, frame);
			frame.tooltip = FriendlistFrame.dropDowns[name].buttons[UIDropDownMenu_GetSelectedID(frame)].tooltipText;
		end
	end
end

--[[

Friendlist_DropDownInitializer()

-- Function to initialize drop down box and buttons.

]]--
function Friendlist_DropDownInitializer(dropDown)
	local id = this:GetName();

	if dropDown ~= nil and getglobal(dropDown) ~= nil then
		--FlagRSP:printDebug("our id is: " .. dropDown);
		id = dropDown;
	end

	--FlagRSP:printDebug("we are initializing dropdown box: " .. id);

	if FriendlistFrame.dropDowns[id] == nil and string.sub(id, string.len(id)-5, string.len(id)) == "Button" then
		--FlagRSP:printDebug("...but we get a button.");
		id = string.sub(id, 1, string.len(id)-6);
		--FlagRSP:printDebug("we are now initializing dropdown box: " .. id);
	end

	UIDropDownMenu_SetText(FriendlistFrame.dropDowns[id].selectedText, getglobal(id));

	for i=1, table.getn(FriendlistFrame.dropDowns[id].buttons) do
		local btab = FriendlistFrame.dropDowns[id].buttons[i];
		--FlagRSP:printDebug("we are now adding button: " .. btab.text);
		local info = UIDropDownMenu_CreateInfo();
		info.text = btab.text;
		info.value = btab.value;
		info.checked = btab.checked;
		info.func = Friendlist_DropDownClicked;
		
		info.tooltipTitle = btab.tooltipTitle;
		info.tooltipText = btab.tooltipText;

		UIDropDownMenu_AddButton(info);
	end
end

--[[

Friendlist_DropDownClicked()

-- Function to handle clicked drop down elements.

]]--
function Friendlist_DropDownClicked()
	--id = this:GetParent():GetName();

	--FlagRSP:printDebug("clicked box: " .. id);

	--posxx = string.find(id, "Button..$");
	--posx = string.find(id, "Button.$");

	--if posxx ~= nil then
		--FlagRSP:printDebug("xx: " .. posxx);
		--id = string.sub(id,1,posxx-1);
	--elseif posx ~= nil then
		--FlagRSP:printDebug("x: " .. posx);
		--id = string.sub(id,1,posx-1);
	--end

	--FlagRSP:printDebug("clicked box: " .. id);
  
	FlagRSP:printDebug("Open Menu: " .. UIDROPDOWNMENU_OPEN_MENU);

	local id = UIDROPDOWNMENU_OPEN_MENU;

	Friendlist_DropDownSetValue(id, this.value);

	UIDropDownMenu_SetText(FriendlistFrame.dropDowns[id].selectedText, getglobal(id));

	-- instantly save option?
	if FriendlistFrame.dropDowns[id].instantSave ~= nil and FriendlistFrame.dropDowns[id].instantSave then
		FlagRSP:printDebug("saving option instantly.");
		Friendlist:dropDownWrite(id);
	end
end

--[[

Friendlist:dropDownRead(id)

-- Function to read out settings for a drop down box id.

]]--
function Friendlist:dropDownRead(id)
	local func = getglobal(FriendlistFrame.dropDowns[id].readFunction);

	if func ~= nil then
		Friendlist_DropDownSetValue(id, func());
	else
		--FlagRSP:printDebug("Something broke.");
	end

	UIDropDownMenu_SetText(FriendlistFrame.dropDowns[id].selectedText, getglobal(id));
end

--[[

Friendlist:dropDownWrite(id)

-- Function to write settings for a drop down box id.

]]--
function Friendlist:dropDownWrite(id)
	local func = getglobal(FriendlistFrame.dropDowns[id].writeFunction);
	local changed = false;

	if func ~= nil then
		changed = func(FriendlistFrame.dropDowns[id].selectedValue);
	else
		--FlagRSP:printDebug("Something broke..");
	end

	return changed;
end

--[[

Friendlist_DropDownSetValue(id, value)

-- Function to set a selected value for a drop down box id.

]]--
function Friendlist_DropDownSetValue(id, value)
	local btab;
   
	for i=1, table.getn(FriendlistFrame.dropDowns[id].buttons) do
		btab = FriendlistFrame.dropDowns[id].buttons[i];
      
		if btab.value == value then
			btab.checked = true;
			
			FriendlistFrame.dropDowns[id].selectedValue = value;
			FriendlistFrame.dropDowns[id].selectedText = btab.text;
			
			local frame = getglobal(id);
			UIDropDownMenu_SetSelectedValue(frame, FriendlistFrame.dropDowns[id].selectedValue);
			frame.tooltip = btab.tooltipText;
		else
			btab.checked = false;
		end
	end
end

function Friendlist:LoadCheckBox(id)
	local func, frame;
	
	func = getglobal(FriendlistFrame.checkBoxes[id].readFunction);
	frame = getglobal(id);
	
	if ( func ~= nil and frame ~= nil ) then
		local checked = func();
		
		frame:SetChecked(checked);
		frame.tooltipText = FriendlistFrame.checkBoxes[id].tooltipText;
	end
end

function Friendlist:WriteCheckBox(id)
	local func, frame;
	
	func = getglobal(FriendlistFrame.checkBoxes[id].writeFunction);
	frame = getglobal(id);
	
	if ( func ~= nil and frame ~= nil ) then
		local checked = frame:GetChecked();
		
		func(checked);
	end
end

function Friendlist:LoadSlider(id)
	local func, frame;
	
	func = getglobal(FriendlistFrame.sliders[id].readFunction);
	frame = getglobal(id);
	
	if ( func ~= nil and frame ~= nil ) then
		local value = func();
		
		--OptionsFrame_EnableSlider(frame);
		getglobal(id .. "Thumb"):Show();
		frame:SetMinMaxValues(FriendlistFrame.sliders[id].minValue, FriendlistFrame.sliders[id].maxValue);
		frame:SetValue(value);
		frame.tooltipText = FriendlistFrame.sliders[id].tooltipText;
	end
end

function Friendlist:WriteSlider(id)
	local func, frame;
	
	func = getglobal(FriendlistFrame.sliders[id].writeFunction);
	frame = getglobal(id);
	
	if ( func ~= nil and frame ~= nil ) then
		local value = frame:GetValue();
		
		func(value);
	end
end

--[[

Friendlist:editBoxTabHandler(name, shift)

-- Function to handle tab events in edit boxes.

]]--
function Friendlist:editBoxTabHandler(name, shift)
	if shift then
		local box = getglobal(FriendlistFrame.editBoxes[name][1]);
		if box:IsVisible() then
			box:SetFocus();
		else
			FlagRSP:printDebug("problem, not visible.");
			FriendlistFrame.editBoxTabHandler(box:GetName(), shift);
		end
	else
		local box = getglobal(FriendlistFrame.editBoxes[name][2]);
		if box:IsVisible() then
			box:SetFocus();
		else
			FlagRSP:printDebug("problem, not visible.");
			FriendlistFrame.editBoxTabHandler(box:GetName(), shift);
		end
	end
end

-- See if it's possible to get rid of these.

----
-- Dropdown Set and Get functions.
----

function DropDown_getRPFlag()
	return FlagRSP:getRPFlag();
end

function DropDown_setRPFlag(val)
	return FlagRSP:setRPFlag(val);
end

function DropDown_getCStatus()
	return FlagRSP:getCharStatus();
end

function DropDown_setCStatus(val)
	return FlagRSP:setCharStatus(val);
end

function DropDown_GetAltLevelState()
	return FlagRSPConfigure:GetLevelDisplay();
end

function DropDown_SetAltLevelState(state)
	return FlagRSPConfigure:SetLevelDisplay(state);
end

function DropDown_GetGuildState()
	return FlagRSPConfigure:GetGuildDisplay();
end

function DropDown_SetGuildState(state)
	return FlagRSPConfigure:SetGuildDisplay(state);
end

function DropDown_GetTooltipStyleState()
	return FlagRSPConfigure:GetTooltipStyle();
end

function DropDown_SetTooltipStyleState(state)
	return FlagRSPConfigure:SetTooltipStyle(state);
end

function DropDown_getSortSettings()
	return FlagRSPConfigure:GetSortOrder();
end

function DropDown_setSortSettings(val)
	local changed = false;

	if FlagRSPConfigure:GetSortOrder() ~= val then
		FlagRSPConfigure:SetSortOrder(val);
		changed = true;
	end

	return changed;
end

----
-- CheckBox Get and Set functions
----

function CheckBox_SetNameDisplay(state)
	FlagRSPConfigure:SetNameDisplay(state);
end

function CheckBox_GetNameDisplay()
	return FlagRSPConfigure:GetNameDisplay();
end

function CheckBox_SetClassColor(state)
	FlagRSPConfigure:SetClassColor(state);
end

function CheckBox_GetClassColor()
	return FlagRSPConfigure:GetClassColor();
end

function CheckBox_SetPVPRanks(state)
	FlagRSPConfigure:SetPVPRanks(state);
end

function CheckBox_GetPVPRanks()
	return FlagRSPConfigure:GetPVPRanks();
end

function CheckBox_SetGuildRank(state)
	FlagRSPConfigure:SetGuildRank(state);
end

function CheckBox_GetGuildRank()
	return FlagRSPConfigure:GetGuildRank();
end

----
-- Slider Get and Set functions
----

function Slider_SetButtonPosition(state)
	FlagRSPConfigure:SetButtonPosition(state);
end

function Slider_GetButtonPosition()
	return FlagRSPConfigure:GetButtonPosition();
end