FlagRSPInfo = {
	isMoving = false;
	isExpanded = false; 

	FLInfoIsExpanded = false;
	FLInfoIsMoving = false;

	FLInfoBtnIsMoving = false;

	FLInfoX = 520;
	FLInfoY = 300;
  
	buttonIsBlinking = false;
	pullInterval = 70;
	pushInterval = 300; -- Five minutes.
	postInterval = 1;

	pullTick = {};
	pushTick = 0;
	postTick = 0;
	
	nextPushTick = 0;
	lastPushTick = 0;

	charPerPost = 240;
	maxDescChars = 1600;
	maxDesc = 7;
	partToPost = 1;
	--maxCharsExpanded = 7*240;

	maxCharsUnExpanded = 100;

	boxPurgeInterval = 2592000;

	buttonBlinkInterval = 0.5;
	buttonBlinkState = true;
	buttonBlinkTick = 0;

	descList = {};
	descPos = 1;

	targetChanged = false;
};

FlagRSPInfoBoxList = {};

function FlagRSPInfo:FrameOnMouseDown(arg1, id)
	--FlagRSP:print(arg1);

	if id:GetName() == "FlagRSPInfoBox" then
		if arg1 == "RightButton" and not FlagRSPConfigure:GetInfoBoxState() then
			self.isMoving = true;
			id:StartMoving();
		elseif arg1 == "LeftButton" then
			if self.isExpanded then
				self.isExpanded = false;
			else
				self.isExpanded = true;
			end
	 
			self:displayBox("target");
		end
	elseif id:GetName() == "FRIENDLISTFrameInfoBox" then
		if arg1 == "RightButton" and not FlagRSPConfigure:GetFriendlistEntryBoxLocked() then
			self.FLInfoIsMoving = true;
			id:StartMoving();
		elseif arg1 == "LeftButton" then
			if self.FLInfoIsExpanded then
				self.FLInfoIsExpanded = false;
			else
				self.FLInfoIsExpanded = true;
			end
		end
		FriendlistMain_Update(true);
	elseif id:GetName() == "FlagRSPInfoBoxButton" then
		if arg1 == "RightButton" then
			self.FLInfoBtnIsMoving = true;
			id:StartMoving();
		end
	end
end

function FlagRSPInfo:FrameOnMouseUp(arg1, id)

	if arg1 == "RightButton" then
		id:StopMovingOrSizing();

		if id:GetName() == "FlagRSPInfoBox" then
			if FlagRSPConfigure:GetInfoBoxExpandUpwards() then
				FlagRSPConfigure:SetInfoBoxCoords(FlagRSPInfoBox:GetLeft(), FlagRSPInfoBox:GetBottom());
			else
				FlagRSPConfigure:SetInfoBoxCoords(FlagRSPInfoBox:GetLeft(), FlagRSPInfoBox:GetTop());
			end
	 
			self.isMoving = false;
		elseif id:GetName() == "FRIENDLISTFrameInfoBox" then
			FlagRSP:printDebug("FL left: " .. FRIENDLISTFrame:GetLeft());
			FlagRSP:printDebug("FL top: " .. FRIENDLISTFrame:GetBottom());
			FlagRSP:printDebug("Box left: " .. id:GetLeft());
			FlagRSP:printDebug("Box top: " .. id:GetTop());

			self.FLInfoX = id:GetLeft() - FRIENDLISTFrame:GetLeft();
			self.FLInfoY = id:GetTop() - FRIENDLISTFrame:GetBottom();

			self.FLInfoIsMoving = false;
		elseif id:GetName() == "FlagRSPInfoBoxButton" then
			x,y = FlagRSPInfoBoxButton:GetCenter();
		 
			FlagRSP:printDebug("x: " .. x);
			FlagRSP:printDebug("y: " .. y);

			FlagRSPConfigure:SetInfoBoxButtonCoords(x, y);

			self.FLInfoBtnIsMoving = false;
		end
	end
end

function FlagRSPInfo:test()
end


--[[

FlagRSPInfo:hideBox()

- Hide InfoBox.

]]--
function FlagRSPInfo:hideBox()
	self.isExpanded = false;
	FlagRSPInfoBox:Hide();
end


--[[

FlagRSPInfo:getBoxLines(playerID)

- Get lines for InfoBox.

]]--
function FlagRSPInfo:getBoxLines(playerID)
	local lines = {};

	local nameText = "";
	local notesText = "";
	local descText = "";
	local titleText = "";
	local rpText = "";
	local rp2Text = "";
	local csText = "";
   
	local targetName = UnitName(playerID);

	if UnitExists(playerID) and targetName ~= nil then
		if self.isExpanded then
			notesText = Friendlist:GetNotes(targetName);
			descText = self:GetDescription(targetName, playerID);
		else
			notesText = Friendlist:GetNotes(targetName);
			
			if ( notesText == nil ) then
				notesText = "";
			end
	 
			if string.len(notesText) > self.maxCharsUnExpanded then
				notesText = string.sub(notesText, 1, self.maxCharsUnExpanded) .. "..."; 
			end
			
			descText = self:GetDescription(targetName, playerID, self.maxCharsUnExpanded);
		end
      
		--local surname = TooltipHandler:getSurname(targetName);
		--if surname ~= nil and surname ~= "" then
			--nameText = targetName .. " " .. surname;
		--else
			--nameText = targetName;
		--end

		nameText = TooltipHandler:getNameTooltipText(playerID);
      
		--FlagRSP:printDebug(xTP_RPList[UnitName("target")]);

		if not FlagRSP:getNameDisp() or TooltipHandler:playerIsKnown(targetName) then
			titleText = TooltipHandler:getTitle(targetName);
		end

		--rpText = TooltipHandler:ParseString("%flagRSPRPLine", playerID);
		rpText = TooltipHandler:getRPTooltipText(targetName, playerID);
		--rp2Text = TooltipHandler:ParseString("%flagRSPRP2Line", playerID);
		rp2Text = "";
		--csText = TooltipHandler:ParseString("%flagRSPCharStatusLine", playerID);
		csText = TooltipHandler:getCharStatusTooltipText(targetName, playerID);
	else
		nameText = "";
		titleText = "";
		rpText = "";
		rp2Text = "";
		csText = "";
	end
      
	local lines = {};
   
	for i=1, 10 do
		lines[i] = "";
	end
   
	lines[1] = nameText;
	lines[2] = titleText;
	
	lines[3] = rpText;
	lines[4] = rp2Text;
	lines[5] = csText;
   
	if notesText ~= "" and notesText ~= nil then
		lines[6] = "|cFFFFFF00" .. FlagRSP_Locale_InfoBoxNotes .. "|r |cFFFFFFFF" .. notesText .. "|r";
	end
	if descText ~= "" and descText ~= nil then
		lines[7] = "|cFFFFFF00" .. FlagRSP_Locale_InfoBoxDesc .. "|r |cFFFFFFFF" .. descText .. "|r";
	end

	if UnitExists(playerID) and targetName ~= nil and not UnitIsPlayer(playerID) then
		local r, g, b = TooltipHandler:getTooltipNameColor(playerID);
		local prefix;
		
		prefix = "|cFF" .. FlagRSP:getHexString(r*255,2) .. FlagRSP:getHexString(g*255,2) .. FlagRSP:getHexString(b*255,2);
		lines[1] = prefix ..targetName .. "|r";
		lines[2] = "";
		lines[3] = "";
		lines[4] = "";
		lines[5] = "";
		lines[7] = "";      
	end

	return lines;
end


--[[

FlagRSPInfo:checkShowBox(playerID)

- Check if user wants to see InfoBox.

]]--
function FlagRSPInfo:checkShowBox(playerID)
	local showBox = 0;
	local name = UnitName(playerID);
	
	if ( FlagRSPInfoBoxList == nil ) then
		FlagRSPInfoBoxList = { };
	end
	
	if ( name ~= nil and name ~= "" and FlagRSPInfoBoxList[name] == nil and FlagHandler:IsEntry(name) ) then
		FlagRSPInfoBoxList[name] = { };
	end
   
	if name ~= nil and name ~= "" and FlagRSPInfoBoxList[name] ~= nil then
		if FlagRSPInfoBoxList[name].showBox then
			showBox = 1;
			self.buttonIsBlinking = false;
			FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Up");
		else 
			showBox = -1;

			local savedRev = FlagHandler:getDescRev("A", name);

			if savedRev == nil then
				savedRev = -1;
			end
			
			-- If seenRev is nil, set it to savedRev just for convenience.
			if ( FlagRSPInfoBoxList[name].seenRev == nil ) then
				FlagRSPInfoBoxList[name].seenRev = savedRev;
			end

			if FlagRSPInfoBoxList[name].seenRev ~= savedRev then
				if FlagRSPConfigure.GetInfoBoxAutoPopUp then
					showBox = 1;
				else
					self.buttonIsBlinking = true;
				end
			else
				self.buttonIsBlinking = false;
				FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Up");
			end
		end
	else
		self.buttonIsBlinking = false;
		FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Up");
	end

	return showBox;
end


--[[

FlagRSPInfoBoxButton_OnClick(playerID)

- InfoBox button at targetframe clicked.

]]--
function FlagRSPInfoBoxButton_OnClick(playerID)
	local name = UnitName(playerID);
   
	--FlagRSP:printDebug("Toggle box!");

	FlagRSPInfo.targetChanged = false;
	
	if ( FlagRSPInfoBoxList == nil ) then
		FlagRSPInfoBoxList = { }
	end

	if FlagRSPInfoBoxList[name] == nil then
		FlagRSPInfoBoxList[name] = {};
	end

	if FlagRSPInfoBoxButton:GetChecked() == nil then
		FlagRSP:printDebug("not checked!");

		FlagRSPInfoBoxList[name].showBox = false;
	else
		FlagRSP:printDebug("checked!");

		FlagRSPInfoBoxList[name].showBox = true;
	end
	
	FlagRSPInfoBoxList[name].seenRev = FlagHandler:GetRevision(name);
	FlagRSPInfoBoxList[name].timeStamp = time();

	FlagRSPInfo:displayBox("target");
end


--[[

FlagRSPInfoCloseButton_OnClick()

- Close button on InfoBox clicked.

]]--
function FlagRSPInfoBoxCloseButton_OnClick()
	--FlagRSP:print("Hey Ya!");
	FlagRSPInfoBoxButton:SetChecked(0);
	FlagRSPInfoBoxButton_OnClick("target");
end


function FlagRSPInfo:toggleBox()
	if FlagRSPInfoBoxButton:IsVisible() then
		if FlagRSPInfoBoxButton:GetChecked() == nil then
			FlagRSPInfoBoxButton:SetChecked(1);
			FlagRSPInfoBoxButton_OnClick("target");
		else
			FlagRSPInfoBoxButton:SetChecked(0);
			FlagRSPInfoBoxButton_OnClick("target");
		end
	end
end


--[[

FlagRSPInfo:updateTimestamp(name)

- Update timestamp in InfoBox list for object name.

]]--
function FlagRSPInfo:updateTimestamp(name)
	if ( FlagRSPInfoBoxList == nil ) then
		FlagRSPInfoBoxList = { }
	end

	if FlagRSPInfoBoxList[name] ~= nil then
		FlagRSPInfoBoxList[name].timeStamp = time();
	end
end


--[[

FlagRSPInfo:displayBox(playerID)

- Display info box.
-- TODO: Rewrite this.  It stores information for every character clicked.  Resource hog.

]]--
function FlagRSPInfo:displayBox(playerID)
	if not FlagRSPConfigure:isInitialized() or self.isMoving then
		return "";
	end

	local ticks = {};
   
	--ticks[0] = GetTime();

	local targetName = UnitName(playerID);
   
	--if UIParent:IsVisible() then
		--FlagRSP:printM("Visible!");
	--else
		--FlagRSP:printM("Invisible!");
	--end

	if not FlagRSPConfigure:GetDisplayInfoBox() then
		self:hideBox();
		FlagRSPInfoBoxButton:Hide();
	else
--~ 		if GetTime() > FlagRSP.newTickRescaleBoxBtn then
--~ 			FlagRSPInfoBoxButton:SetScale(2);
--~ 			FlagRSPInfoBoxButton:SetScale(1);
--~ 			FlagRSP.newTickRescaleBoxBtn = GetTime() + FlagRSP.rescaleBoxBtnInterval;
--~ 		end

		if self.buttonIsBlinking then
			if GetTime() > self.buttonBlinkTick then
				if self.buttonBlinkState then
					FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Blink");
					self.buttonBlinkState = false;
				else
					FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Up");
					self.buttonBlinkState = true;
				end
	    
				self.buttonBlinkTick = GetTime() + self.buttonBlinkInterval;
			end
		end
      
		if UIParent:IsVisible() then
			if not self.FLInfoBtnIsMoving then
				local compX, compY = FlagRSPConfigure:GetInfoBoxButtonCoords()
				if compX ~= -1 and compY ~= -1 then
					FlagRSPInfoBoxButton:ClearAllPoints();
					FlagRSPInfoBoxButton:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", compX-12, compY+12);
					--FlagRSPInfoBoxButton:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMLEFT", FlagRSPSettings[FlagRSP.rName][FlagRSP.pName].InfoBoxButtonX+12, FlagRSPSettings[FlagRSP.rName][FlagRSP.pName].InfoBoxButtonY-12);
				else
					local anchorFrame = "TargetFrame";
					local x = 0;	-- x anchor for the Blizzard TargetFrame.
					local y = 44;	-- y anchor for the Blizzard TargetFrame.
					if ( ClickCastFrames ) then
						for key, value in pairs(ClickCastFrames) do
							if ( key:GetAttribute("unit") == "target" ) then
								anchorFrame = key:GetName();
								x = key:GetWidth() / 3;
								y = key:GetHeight() / 2;
								break;
							end
						end
					end
					
					FlagRSPInfoBoxButton:ClearAllPoints();
					FlagRSPInfoBoxButton:SetPoint("TOPLEFT", anchorFrame, "CENTER", x, y);
					--FlagRSPInfoBoxButton:SetPoint("BOTTOMRIGHT", "TargetFrame", "CENTER", 12+12, 32-12);
				end
			end
	 
			FlagRSPInfoBoxButton:Show();
			FlagRSPInfoBoxButton:Raise();
		else
			--FlagRSP:printDebug("Targetframe is invisible.");
			--FlagRSPInfoBoxButton:Hide();
			--FlagRSPInfoBox:Hide();
	 
			return;
		end	    

		--ticks[1] = GetTime();

		local check = self:checkShowBox(playerID);
		if ( FlagHandler:IsEntry(targetName) ) then
			self:updateTimestamp(targetName);
		end
      
		--FlagRSP:printDebug("check for InfoBox is: " .. check);
		local showBox = true;

		if check == 1 then 
			showBox = true; 
		elseif check == -1 then
			showBox = false; 
		end

		if check == -1 and FlagRSPConfigure:GetAlwaysShowInfoBox() and self.targetChanged then
			self.targetChanged = false;
			FlagRSPInfoBoxList[targetName].showBox = true;
			showBox = true;
		end

		--ticks[2] = GetTime();

		local lines = {};
		if showBox then
			lines = self:getBoxLines(playerID);
 
			if lines[2] == "" and lines[3] == "" and lines[4] == "" and lines[5] == "" and lines[6] == "" and lines[7] == "" and lines[8] == "" and lines[9] == "" and lines[10] == "" then
		 
				-- find reasons to hide the box because of no information inside.
				if not UnitIsPlayer(playerID) then
					-- obviously a NPC or pet.
					showBox = false;
				elseif TooltipHandler:getSurname(UnitName(playerID)) == "" then
					showBox = false;
				end
			end
		end      

		if UnitAffectingCombat("player") or not showBox then
			self:hideBox();
			FlagRSPInfoBoxButton:SetChecked(0);
	 
			if UnitExists(playerID) and targetName ~= nil and (Friendlist:isFriend(UnitName(playerID)) or FlagHandler:getFlag("RPFlag", UnitName(playerID)) ~= "") then
			else
				--FlagRSP:printDebug("dont show button");
				FlagRSPInfoBoxButton:Hide();
			end
		else

			local x, y = FlagRSPConfigure:GetInfoBoxCoords();
			--FlagRSP:printDebug("Box is still visible.");

			FlagRSPInfoBoxButton:SetChecked(1);

			--ticks[3] = GetTime();

			self:updateBox("FlagRSPInfoBox", lines, "UIParent", FlagRSPConfigure:GetInfoBoxExpandUpwards(), x, y, FlagRSPConfigure:GetInfoBoxWidth(), showBox);
		 
		end
	end

	--ticks[4] = GetTime();

	--FlagRSP:printDebug("showBox. Time needed 0-1: " .. ticks[1]-ticks[0]);
	--FlagRSP:printDebug("showBox. Time needed 1-2: " .. ticks[2]-ticks[1]);
	--FlagRSP:printDebug("showBox. Time needed 2-3: " .. ticks[3]-ticks[2]);
	--FlagRSP:printDebug("showBox. Time needed 3-4: " .. ticks[4]-ticks[3]);
	--FlagRSP:printDebug("showBox. Time needed 0-4: " .. ticks[4]-ticks[0]);
end


function FlagRSPInfo:updateBox(boxS,lines,parent,expandDir,x,y,width,showBox)
	local box = getglobal(boxS);
	local height = 0;  
	local bText, bText2;

	if box ~= nil then
		if not showBox then
			box:Hide();
		else
			box:Show();
			box:SetWidth(width);
			box:SetAlpha(1);
			box:SetBackdropColor(0,0,0,FlagRSPConfigure:GetInfoBoxAlphaBackdrop());
			height = 22;
			local ii = 1;

			for i=1, 12 do
				bText = getglobal(boxS .. "Text" .. i);

				if i == 1 then 
					bText:SetWidth(width - 32);
					bText:SetTextHeight(FlagRSPConfigure:GetInfoBoxTextSize()*1.5);
				else
					bText:SetWidth(width - 22);
					bText:SetTextHeight(FlagRSPConfigure:GetInfoBoxTextSize());
				end

				while ((lines[ii] == "" or lines[ii] == nil) and ii <= 12) do
					ii = ii + 1;
				end
				
				if ii <= 12 then
					bText:SetText(lines[ii]);
					bText:Show();

					height = height + bText:GetHeight();

					ii = ii + 1;
				else
					bText:SetText("");
					bText:SetHeight(0);
					bText:Hide();
				end
			end
	 
			box:SetHeight(height);

			if expandDir then
				box:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", x, y);
				box:SetPoint("TOPLEFT", parent, "BOTTOMLEFT", x, y+height);
			else
				box:SetPoint("TOPLEFT", parent, "BOTTOMLEFT", x, y);
				box:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", x, y-height);
			end
	 
			if GetTime() > FlagRSP.newTickRescaleBox[boxS] then
				box:SetScale(2);
				box:SetScale(1);
				FlagRSP.newTickRescaleBox[boxS] = GetTime() + FlagRSP.rescaleBoxInterval;
			end
		end
	end
end

--[[

FlagRSPInfo:GetDescription(name, playerID, limit)

-- Returns the stored description of a character as a string rather than an array.

]]--

function FlagRSPInfo:GetDescription(name, playerID, limit)
	if ( limit == nil ) then
		limit = -1;
	end
	
	-- Test to make sure we have some value with which to get a description from.
	if ( name ~= "" or name ~= nil or playerID ~= nil or playerID ~= "" ) then
		if ( name == nil or name == "" ) then
			name = UnitName(playerID);
		end
		
		local rev, complete, descLines;
		
		rev = FlagHandler:GetRevision(name);
		complete = FlagHandler:IsComplete(name);
		descLines = FlagHandler:GetDescription(name);
		
		local desc = "";
		
		local i = 1;
		
		while ( descLines[i] ~= nil ) do
			desc = desc .. descLines[i];
			i = i + 1;
		end
		
		if ( limit > 0 and string.len(desc) > limit ) then
			desc = string.sub(desc, 1, limit) .. "...";
		end
		
		return desc;
	end
end

--[[

FlagRSPInfo:pullDescription(name)

- Pulls the character description for player name.

]]--
function FlagRSPInfo:pullDescription(name)
	if FlagRSP.isInitialized then

		--FlagRSP:printM("Pulling description for: " .. name);

		if self.pullTick[name] == nil then
			self.pullTick[name] = 0;
		end
      
		--FlagRSP:printDebug("flagRSP: DEBUG: Time: " ..  GetTime());	 
		--FlagRSP:printDebug("flagRSP: DEBUG: Next pull: " ..  self.pullTick[name]);	 
      
		if GetTime() > self.pullTick[name] then
			--FlagRSP:printDebug("flagRSP: DEBUG: We WILL pull for: " ..  name);	 

			local id;
			--FlagRSP:printM("Pulling description from: " .. xTP_ChannelName);
			id = GetChannelName(xTP_ChannelName);
			--SendChatMessage("<DPULL>" .. name, "CHANNEL", FlagRSP_Locale_CLanguage, id); 
			ChatHandler:sendMessage("<DP>" .. name);
	 
			self.pullTick[name] = GetTime() + self.pullInterval;
		end
	end
end


--[[

FlagRSPInfo:pushDescription()

- Prepare posting of character description for self.

]]--
function FlagRSPInfo:pushDescription(partial)
	--FlagRSP:printDebug("flagRSP: DEBUG: Someone wants our description!");
   
	if partial == nil then
		partial = false;
	end

	if FlagRSPConfigure:GetRevision() >= 0 and FlagRSPConfigure:GetDescription() ~= nil and FlagRSPConfigure:GetDescription() ~= "" then
      
		local desc = string.gsub(FlagRSPConfigure:GetDescription(), "\n", "\\l");

		if partial then
			if 1 == 0 then
				local partsNeeded = math.ceil(string.len(desc)/(self.charPerPost));
				if partsNeeded > self.maxDesc then
					partsNeeded = self.maxDesc;
				end
	    
				local partToPost = self.partToPost;
	    
				self.partToPost = self.partToPost + 1;
				if self.partToPost > partsNeeded then
					self.partToPost = 1;
				end
	    
				FlagRSP:printDebug("maximum: " .. (self.maxDesc*self.charPerPost) .. ", length " .. string.len(desc) .. ". posting part of description. How many parts needed: " .. partsNeeded .. ". Posting part: " .. partToPost);
	    
				local line = string.sub(desc, (partToPost-1)*self.charPerPost+1, partToPost*self.charPerPost);
				FlagRSP:printDebug("line length: " .. string.len(line) .. ", line is: " .. line);
	    
				if self.partToPost == partsNeeded then
					line = line .. "\\eod";
				end
	    
				local n;
				if self.descPos < 10 then
					n = "0" .. partToPost;
				else
					n = partToPost;
				end
	    
				ChatHandler:sendMessage("<P" .. n .. ">" .. line);
			end
		else
			--FlagRSP:printDebug("we shall push");
			if GetTime() > self.pushTick then
				--FlagRSP:printDebug("we will push");
				--local descList = {};
				local p = 1;
				local n = "";
				self.descList = {};
				self.descPos = 1;
				FlagRSP.newTickDesc = 0;
				--self.postDesc = false;
	       
				local parts = 0;
				for i=1, self.maxDesc do
					self.descList[i] = string.sub(desc, p, p+self.charPerPost-1);
					p = p + self.charPerPost;
	       
					if self.descList[i] ~= nil and self.descList[i] ~= "" then
						if i < 10 then
							n = "0" .. i;
						else
							n = i;
						end
		  
						self.descList[i] = string.gsub(self.descList[i], "<", "\\(");
						self.descList[i] = string.gsub(self.descList[i], ">", "\\)");
		  
		  
						--FlagRSP:printDebug(self.maxDesc);
		  
						--FlagRSP:printDebug("Desc: " .. i .. ": " .. self.descList[i]);
						--SendChatMessage("<D" .. n .. ">" .. self.descList[i], "CHANNEL", FlagRSP_Locale_CLanguage, id); 	 
						--self.descList[i] = "";
						--self.postTick = GetTime() + self.postInterval;

						parts = i;
					end
				end
	    
	    
				if parts > 0 then
					self.descList[parts] = self.descList[parts] .. "\\eod";
				end

				--self.postDesc = true;
	    
				self.pushTick = GetTime() + self.pushInterval;
				FlagRSP.ownDescriptionSent = FlagRSP.ownDescriptionSent + 1;
			end
			FlagRSP.ownDescriptionRequested = FlagRSP.ownDescriptionRequested + 1;
		end
	end
end

--[[

FlagRSPInfo:PushDescription()

-- Pushes the character's description in response to a request.

]]--

function FlagRSPInfo:PushDescription()
	if ( FlagRSP.isInitialized ) then
		local desc = FlagRSPConfigure:GetDescription();
		
		if ( desc == "" or desc == nil ) then
			return;
		end
		
		if ( GetTime() > self.nextPushTick ) then
			self.lastPushTick = GetTime();
			self.nextPushTick = self.lastPushTick + self.pushInterval;
			
			-- Format the description to be sent in chat.
			desc = string.gsub(desc, "\n", "\\l");
			desc = string.gsub(desc, "<", "\\(");
			desc = string.gsub(desc, ">", "\\)");
			
			local pos = 1;
			
			local descParts = { };
			
			for i = 1, ( ceil(string.len(desc) / self.charPerPost) ) do
				descParts[i] = string.sub(desc, pos, pos+self.charPerPost-1);
				pos = pos + self.charPerPost;
			end
			
			local max = table.getn(descParts);
			descParts[max] = descParts[max] .. "\\eod";
			
			for i = 1, max do
				local number = "";
				
				if ( i < 10 ) then
					number = "0" .. i;
				else
					number = i;
				end
				
				ChatHandler:sendMessage("<D" .. number .. ">" .. descParts[i]);
			end
			
			FlagRSP.ownDescriptionSent = FlagRSP.ownDescriptionSent + 1;
			
			--Print_UI("Description Sent");
		end
	end
end


--[[

FlagRSPInfo:postDescription()

- Posts the character description for self.

]]--
function FlagRSPInfo:postDescription()
	--FlagRSP:printDebug("Test");
	--FlagRSP:printDebug(self.descPos);
	local n;

	if self.descList[self.descPos] ~= nil and self.descList[self.descPos] ~= "" and self.descPos <= self.maxDesc then

		if self.descPos < 10 then
			n = "0" .. self.descPos;
		else
			n = self.descPos;
		end

		local id;
		FlagRSP_JoinChannel();
		id = GetChannelName(xTP_ChannelName);
		--SendChatMessage("<D" .. n .. ">" .. self.descList[self.descPos], "CHANNEL", FlagRSP_Locale_CLanguage, id); 	 
		ChatHandler:sendMessage("<D" .. n .. ">" .. self.descList[self.descPos]);
		self.descPos = self.descPos + 1;
	--elseif FlagRSP.descPos > self.maxDesc then
	end      
end
   

--[[

FlagRSPInfo:saveDescription()

- Saves the character description for player name.

]]--
function FlagRSPInfo:saveDescription(num, text, name, partial)
	if partial == nil then
		partial = false;
	end

	local no = tonumber(num);

	--FlagRSP:printDebug(num);   

	if no ~= nil then
		--FlagRSP:printDebug("Recieved description line number " .. no .. " by " .. name .. ". Text is: " .. text);
--~ 		if FlagRSP_CharDesc[name] == nil then
--~ 			FlagRSP_CharDesc[name] = {};
--~ 		end
--~       
--~ 		FlagRSP_CharDesc[name][no] = string.gsub(text, "\\l", "\n");
--~       
--~ 		if FlagRSP_CharDesc.availRev[name] == nil then
--~ 			FlagRSP_CharDesc.availRev[name] = FlagHandler:getDescRev("A", name);
--~ 		end

--~ 		--if not partial then
--~ 		--FlagRSP:printDebug("save new");
--~ 		FlagRSP_CharDesc.savedRev[name] = FlagRSP_CharDesc.availRev[name];
--~ 		--end

		local revision = FlagHandler:GetRevision(name);

		FlagHandler:addDesc("A", no, string.gsub(text, "\\l", "\n"), name, revision, partial);
	end
end


--[[

FlagRSPInfo:saveEditDescription()

- Saves the own character description from the edit box.

]]--
function FlagRSPInfo:saveEditDescription()
	FlagRSPConfigure:SetRevision(FlagRSPConfigure:GetRevision() + 1);
   
	FlagRSPConfigure:SetDescription(FlagRSPDescEditorEditBox:GetText());

	FlagRSPDescEditor:Hide();
	xTooltip_Post();
end


--[[

FlagRSPInfo:purgeBoxList()

- Purges the InfoBox list.

]]--
function FlagRSPInfo:purgeBoxList()
	local delTime = time() - self.boxPurgeInterval;

	--FlagRSP:print("delTime is: " .. delTime);
	--FlagRSP:print("nowTime is: " .. time());
	
	if ( FlagRSPInfoBoxList == nil ) then
		FlagRSPInfoBoxList = { };
	end

	for name, value in pairs(FlagRSPInfoBoxList) do
		--FlagRSP:print(name);
		--FlagRSP:print(value.timeStamp);

		if ( value.timeStamp ~= nil ) then
			if value.timeStamp < delTime then
				--FlagRSP:print("Delete entry for: " .. name);
				--value = nil;
				FlagRSPInfoBoxList[name] = nil;
			end
		end
	end
end
