--[[

TODO: Rewrite most of the functions that pull information out of the tooltip.
REQS: 1) Faction Tooltip extractor.
      2) NPC Title extractor.
	 3) One function to create a pet owner line, not five.

]]--

TooltipHandler = {
	skinnableTableBuild = false;
	skinnableTable = {};

	skinnableColours = {};

	guildMembers = {};
	friendEntries = {};
	ignoredList = {};
};


--[[

TooltipHandler:compileTooltip(tooltipLinesLeft, tooltipLinesRight, modifier)

- Reorders and replaces tooltip lines <tooltipLinesLeft/Right> for tooltipModifier <modifier>.

]]--
function TooltipHandler:compileTooltip(tooltipLinesLeft, tooltipLinesRight, modifier, tooltipString, playerID, numLines)
   
	if numLines == nil then 
		numLines = 30;
	end

	--self:getSkinningSkill()

	--FlagRSP:printDebug("Compiling tooltip");

	--local linesBefore = {};

	if tooltipString == "" or tooltipString == nil then 
		tooltipString = "GameTooltip";
	end
	if playerID == "" or playerID == nil then 
		playerID = "mouseover"; 
	end
   
	local tt = getglobal(tooltipString);
	
--[[	for x = 1, tt:NumLines() do
		--local ttLeft = getglobal(tooltipString .. "TextLeft" .. x);
		
		if ( tooltipLinesLeft[x] ~= nil ) then
			ChatFrame4:AddMessage(tooltipLinesLeft[x]);
		end
	end]]

	local i = 0;
	local j = 0;
	local t = 1;

	while modifier[i] ~= nil do
		t = 1;
      
		--FlagRSP:printDebug(numLines);

		while t <= numLines do
	 
			--ChatFrame1:AddMessage("t" .. t);
			if self:checkCondition(modifier[i].conditionType, modifier[i].conditionValue, modifier[i].conditionValue2, "l", t, tooltipLinesLeft[t], playerID) then
				j = 0;
				while modifier[i].modifierType[j] ~= nil do
					tooltipLinesLeft, tooltipLinesRight = self:modifyLine(modifier[i].modifierType[j], modifier[i].modifierValue[j], t, tooltipLinesLeft, tooltipLinesRight, playerID);
					
					j = j + 1;
				end
			end
			t = t + 1;
		end
		i = i + 1;
	end

	--tt:ClearLines();
	for i = 1, tt:NumLines() do
		getglobal(tooltipString .. "TextLeft" .. i):SetText(nil);
	end
	tt:SetHeight(0);

	local original_lines = tt:NumLines();
	local current_line = 1;
	
	for t = 1, 30 do
		local ttLeft = getglobal(tooltipString .. "TextLeft" .. current_line);
		
		if ( tooltipLinesLeft[t] ~= nil and tooltipLinesLeft[t] ~= "" ) then
			--ChatFrame1:AddMessage(tooltipLinesLeft[t]);
			if ( current_line <= original_lines ) then
				ttLeft:SetText(tooltipLinesLeft[t]);
			else
				tt:AddLine(tooltipLinesLeft[t], 1, 1, 1);
			end

			current_line = current_line + 1;
		end
	end
	
--[[	for x = 1, tt:NumLines() do
		--local ttLeft = getglobal(tooltipString .. "TextLeft" .. x);
		
		if ( tooltipLinesLeft[x] ~= nil ) then
			ChatFrame4:AddMessage(x .. ": " .. tooltipLinesLeft[x]);
		end
	end]]--

	-- Add MonkeyQuest support because MonkeyQuest does not understand coloured tooltips.
	if MonkeyQuest_SearchQuestListItem ~= nil and (playerID == "target" or playerID == "mouseover") then
		MonkeyQuest_SearchQuestListItem(UnitName(playerID));
	end

	tt:Show();
end

--[[

TooltipHandler:BuildTooltip(status, tooltipBase, tooltipUnit)

-- Builds and shows a tooltip for a known player, unknown player, ignored player, npc, or pet.

]]--

function TooltipHandler:BuildTooltip(status, tooltipBase, tooltipUnit)
	if tooltipBase == "" or tooltipBase == nil then 
		tooltipBase = "GameTooltip";
	end
	if tooltipUnit == "" or tooltipUnit == nil then 
		tooltipUnit = "mouseover"; 
	end

	local tt = getglobal(tooltipBase);
	
	for i = 1, tt:NumLines() do
		getglobal(tooltipBase .. "TextLeft" .. i):SetText(nil);
	end
	tt:SetHeight(0);
	
	local tooltipLines = { };
	local original_lines = tt:NumLines();
	
	for i = 1, table.getn(PlayerTooltip[status]) do
		tooltipLines[i] = self:ParseString(PlayerTooltip[status][i], tooltipUnit);
	end
	
	local current_line = 1;
	for t = 1, table.getn(tooltipLines) do
		local ttLeft = getglobal(tooltipBase .. "TextLeft" .. current_line);
		
		if ( tooltipLines[t] ~= nil and tooltipLines[t] ~= "" ) then
			--ChatFrame1:AddMessage(tooltipLinesLeft[t]);
			if ( current_line <= original_lines ) then
				ttLeft:SetText(tooltipLines[t]);
			else
				tt:AddLine(tooltipLines[t], 1, 1, 1);
			end

			current_line = current_line + 1;
		end
	end
	
	tt:Show();
end


--[[

TooltipHandler:checkCondition(type, value, value2, side, linenum, line)

- checks modifier condition <type, value, value2> for line <side, linenum, line>.

]]--
function TooltipHandler:checkCondition(type, value, value2, side, linenum, line, playerID)
	local condition = false;

	if type == "true" then 
		condition = true;
	elseif type == "matchString" then
		if line ~= nil and value ~= "" and line ~= "" then
			value = self:ParseString(value, playerID);
			value = self:removeColourCode(value);
			line = self:removeColourCode(line);
	 
			if value ~= "" then
				if string.find(string.lower(line), string.lower(value)) ~= nil then 
					condition = true; 
				end
			end
		end
	elseif type == "matchExactString" then
		if line ~= nil and value ~= "" and line ~= "" then
			value = self:ParseString(value, playerID);
			value = self:removeColourCode(value);
			line = self:removeColourCode(line);
			
			if value ~= "" then
				if string.lower(line) == string.lower(value) then 
					condition = true; 
				end
			end
		end
	elseif type == "lineNumber" then
		--FlagRSP:printDebug(type);
		--FlagRSP:printDebug(value);
		
		if string.lower(value) ~= "last" then
			local vside = string.sub(string.lower(value), 1, 1);
			local vnum = tonumber(string.sub(string.lower(value), 2));
			
			if side == vside and linenum == vnum then
				condition = true;
			end
			--ChatFrame1:AddMessage(side .. " " .. vside .. " " .. linenum .. " " .. vnum .. " " .. tostring(condition));
		end
	end
	
	return condition;
end


--[[

TooltipHandler:modifyLine(type, value, linenum, lines)

- modifies <type, value> for line <linenum> in <lines>.

]]--
function TooltipHandler:modifyLine(type, value, linenum, lines, linesRight, playerID)
	local tline = "";

	--FlagRSP:printDebug("running modifier... " .. type .. ", " .. value .. ", " .. linenum);
	--ChatFrame1:AddMessage("running modifier: " .. type .. ", " .. value .. ", " .. linenum);

	if type == "delete" then
		lines[linenum] = "";
		linesRight[linenum] = "";
	elseif type == "replace" then
		tline = self:ParseString(value, playerID);
		if tline ~= "" then 
			lines[linenum] = tline; 
		end
	elseif type == "insertLine" then
		table.insert(lines, linenum, self:ParseString(value, playerID));
		table.insert(linesRight, linenum, " ");
	elseif type == "appendLine" then
		table.insert(lines, linenum+1, self:ParseString(value, playerID));
		table.insert(linesRight, linenum+1, " ");
		--ChatFrame4:AddMessage(tostring(linenum) .. " " .. self:ParseString(value, playerID))
		--table.insert(lines, self:ParseString(value, playerID));
		--table.insert(linesRight, " ");
	elseif type == "colorLine" then
		lines[linenum] = "|cFF" .. value .. lines[linenum] .. "|r" ;
	end

	return lines, linesRight;
end

--[[

TooltipHandler:ParseString(str, playerID)

- Searches the string for tokens and then replaces them.

]]--
function TooltipHandler:ParseString(str, playerID)
	-- Loops through str for tokens and then replaces them with a corresponding function.
	if ( playerID == "" or playerID == nil ) then
		playerID = "mouseover";
	end
	
	--Print_Chat("Starting string: " .. str);
	
	for w in string.gmatch(str, "(%%%a+)") do
		local func = TooltipLookup[w];
		local replace = "%" .. w;
		
		-- If a token has no corresponding function, print an error and returns what we've got.
		if ( func == nil ) then
			Print_Chat("Error: Unknown token: " .. w);
			Print_Chat("In string: " .. str);
			return str;
		end
		
		local result = func(playerID);
		
		if ( result == nil ) then
			result = "";
		end
		str = string.gsub(str, replace, result);
	end
	
	return str;
end

--[[

TooltipHandler:ExtractStrings(tooltipBase)

-- Iterates through the lines of a tooltip and extracts them.

]]--

function TooltipHandler:ExtractStrings(tooltipBase)
	if ( tooltipBase == nil or tooltipBase == "" ) then
		tooltipBase = "GameTooltip";
	end
	
	local linesLeft = {};
	local linesRight = {};
	local tlineL;
	local tlineR;
	local i = 1;
	
	for t=1, getglobal(tooltipBase):NumLines() do
		ttextL = getglobal(tooltipBase .. "TextLeft" .. t);
		ttextR = getglobal(tooltipBase .. "TextRight" .. t);
		tlineL = ttextL:GetText();
		tlineR = ttextR:GetText();

		if tlineL == nil or not ttextL:IsVisible() then tlineL = ""; end
		if tlineR == nil or not ttextR:IsVisible() then tlineR = ""; end

		if tlineL ~= "" or tlineR ~= "" then
			linesLeft[i] = tlineL;
			linesRight[i] = tlineR;
			i = i + 1;
		end
	end 
	
	return linesLeft, linesRight;
end


--[[

TooltipHandler:compileString(str)

- Replaces all % values or variables in string str.

]]--
function TooltipHandler:compileString(str, playerID, name)
	local compiledString = str;
	local realm;

	if ( playerID == "" or playerID == nil ) then 
		playerID = "mouseover"; 
	end
   
	if ( name == nil ) then
		name = self:GetCharacterName(playerID, "unit");
	end
   
	--FlagRSP:printDebug("compiling... " .. str .. " for " .. playerID);
	--ChatFrame1:AddMessage("compiling: " .. str .. " for " .. playerID);

	if string.find(compiledString, "%%flagRSPVersion") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPVersion", FlagRSP.VERSION);
	end
	if string.find(compiledString, "%%flagRSPAltLevelEnemy") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPAltLevelEnemy", self:getAlternativeEnemyLevelText(playerID));
	end
	if string.find(compiledString, "%%UnitClass") ~= nil then
		compiledString = string.gsub(compiledString, "%%UnitClass", self:getClass(playerID));
	end
	if string.find(compiledString, "%%UnitRace") ~= nil then
		compiledString = string.gsub(compiledString, "%%UnitRace", self:getRace(playerID));
	end
	if string.find(compiledString, "%%UnitLevel") ~= nil then
		compiledString = string.gsub(compiledString, "%%UnitLevel", self:getLevel(playerID));
	end
	if string.find(compiledString, "%%UnitName") ~= nil then
		compiledString = string.gsub(compiledString, "%%UnitName", name);
	end
	if string.find(compiledString, "%%UnitRank") ~= nil then
		compiledString = string.gsub(compiledString, "%%UnitRank", self:getPVPRank(playerID));
	end
	if string.find(compiledString, "%%UnitTitle") ~= nil then
		compiledString = string.gsub(compiledString, "%%UnitTitle", self:getTitle(name));
	end
	if string.find(compiledString, "%%UnitGuild") ~= nil then
		compiledString = string.gsub(compiledString, "%%UnitGuild", self:getGuild(playerID));
	end
	if string.find(compiledString, "%%flagRSPFriendlistText") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPFriendlistText", self:getFriendlistTooltipText(UnitName(playerID)));
	end
	if string.find(compiledString, "%%flagRSPGuildFriendlistText") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPGuildFriendlistText", self:getFriendlistGuildTooltipText(playerID));
	end
	if string.find(compiledString, "%%flagRSPRPFlag") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPRPFlag", self:getRPTag(UnitName(playerID)));
	end
	if string.find(compiledString, "%%flagRSPPVPRank") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPPVPRank", self:getPVPRank(playerID));
	end
	if string.find(compiledString, "%%flagRSPPetOwnerSubLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPPetOwnerSubLine", self:getMouseoverPetOwnerTooltipSubText());
	end
	if string.find(compiledString, "%%flagRSPPetOwnerLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPPetOwnerLine", self:getMouseoverPetOwnerTooltipText());
	end
	if string.find(compiledString, "%%flagRSPPetOwner") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPPetOwner", self:getMouseoverPetOwner());
	end
	if string.find(compiledString, "%%flagRSPSurname") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPSurname", self:getSurname(name));
	end
	if string.find(compiledString, "%%flagRSPLevelLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPLevelLine", self:getLevelTooltipText(playerID));
	end
	if string.find(compiledString, "%%flagRSPLevel") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPLevel", self:getLevelText(playerID));
	end
	if string.find(compiledString, "%%flagRSPNameLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPNameLine", self:getNameTooltipText(playerID));
--		compiledString = string.gsub(compiledString, "%%flagRSPNameLine", self:BuildName(playerID));
	end
	if string.find(compiledString, "%%flagRSPRankLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPRankLine", self:getPVPRankTooltipText(playerID));
	end
	if string.find(compiledString, "%%flagRSPRPLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPRPLine", self:getRPTooltipText(name, playerID));
	end
	if string.find(compiledString, "%%flagRSPTitleLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPTitleLine", self:getTitleTooltipText(playerID));
	end
	if string.find(compiledString, "%%flagRSPGuildLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPGuildLine", self:getGuildTooltipText(playerID));
	end
	if string.find(compiledString, "%%flagRSPCivilianLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPCivilianLine", self:getCivilianLine(playerID));
	end
	if string.find(compiledString, "%%flagRSPSkinnableLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPSkinnableLine", self:getSkinnableLine(playerID));
	end
	if string.find(compiledString, "%%flagRSPCStatus") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPCStatus", self:getCharStatus(name));
	end
	if string.find(compiledString, "%%flagRSPCSText") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPCSText", self:getCharStatusText(name));
	end
	if string.find(compiledString, "%%flagRSPCharStatusLine") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPCharStatusLine", self:getCharStatusTooltipText(name, playerID));
	end
	if string.find(compiledString, "%%FriendlistFriendstateText") ~= nil then
		compiledString = string.gsub(compiledString, "%%FriendlistFriendstateText", Friendlist:GetFriendstateText(name));
	end
	if string.find(compiledString, "%%FriendlistFriendstateColour") ~= nil then
		compiledString = string.gsub(compiledString, "%%FriendlistFriendstateColour", Friendlist:GetFriendstateColour(name));
	end
	if string.find(compiledString, "%%flagRSPPvPFlag") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPPvPFlag", self:TooltipPVPFlagText(playerID));
	end
	if string.find(compiledString, "%%flagRSPResurrectableText") ~= nil then
		compiledString = string.gsub(compiledString, "%%flagRSPResurrectableText", self:TooltipResurrectableText(playerID))
	end
      
	return compiledString;
end

--[[

These next two methods are kinda hackish, no comments for them since they'll be rewritten or removed later.

]]--

function TooltipHandler:TooltipPVPFlagText(playerID)
	if ( UnitIsPVP(playerID) ) then
		return PVP_ENABLED;
	else
		return "";
	end
end

function TooltipHandler:TooltipResurrectableText(playerID)
	if ( UnitIsDead(playerID) and UnitFactionGroup(playerID) == UnitFactionGroup("player") ) then
		return FlagRSP_Locale_ResurrectableText;
	else
		return "";
	end
end

--[[

TooltipHandler:ParseNPCTooltip()

-- Extracts information from an NPC's tooltip that cannot be acquired through functions.

]]--

function TooltipHandler:ParseNPCTooltip()
	local name;
	local title = nil;
	local level;
	local faction = nil;
	local pvpLine;
	local leader = nil;
	local temp;
	
	-- Clear the local caches.
	self.npcTitle = nil;
	self.npcFaction = nil;
	self.npcLeader = nil;
	self.skinnable = nil;
	
	-- This pulls out some extraneous information, but it'll stay like this until I find something better.
	for i = 1, GameTooltip:NumLines() do
		temp = getglobal("GameTooltipTextLeft"..i):GetText();
		
		-- Throw in a quick check to see if something's skinnable.
		if ( string.find(temp, FlagRSP_Locale_SkinnableText) ) then
			self.skinnable = true;
		end
		
		-- Name always comes first.
		if ( i == 1 ) then
			name = temp;
		end
			
		-- Second line can be either NPC title or level.  If it's not level, then it's title.
		if ( i == 2 ) then
			if ( string.find(temp, FlagRSP_Locale_Level) ) then
				-- Level line.
				level = temp;
			else
				-- Title line.
				title = temp;
			end
		end
		
		-- Third line could be level, faction, or PvP.  If there's a title, it's level otherwise it's faction or PvP.
		if ( i == 3 and title ) then
			level = temp;
		elseif ( i == 3 and temp ~= PVP_ENABLED and not string.find(temp, FlagRSP_Locale_SkinnableText) ) then
			-- If it's the third line and it is not PvP and it is not "Skinnable", then it's a faction.
			faction = temp;
		end

		-- Fourth line is either faction or PvP.  If it's PvP, no faction.
		if ( i == 4 and temp == PVP_ENABLED ) then
			pvpLine = temp;
		elseif ( i == 4 ) then
			faction = temp;
		end
		
		-- If we get to line five, it's obviously PvP.
		if ( i == 5 ) then
			pvpLine = temp;
		end
		
		-- If we get to line six, then it's special because it's a leader.
		if ( i == 6 ) then
			leader = temp;
		end
	end
	
	-- Assign local caches.
	self.npcTitle = title;
	self.npcFaction = faction;
	self.npcLeader = leader;
end

--[[

TooltipHandler:GetNPCTitleLine()

-- Returns the leader line extracted from TooltipHandler:ParseNPCTooltip().

]]--

function TooltipHandler:GetNPCTitleLine()
	return self.npcTitle;
end

--[[

TooltipHandler:GetNPCFactionLine()

-- Returns the faction line extracted from TooltipHandler:ParseNPCTooltip().

]]--

function TooltipHandler:GetNPCFactionLine()
	return self.npcFaction;
end

--[[

TooltipHandler:GetNPCLeaderLine()

-- Returns the leader line extracted from TooltipHandler:ParseNPCTooltip().

]]--

function TooltipHandler:GetNPCLeaderLine()
	return self.npcLeader;
end


--[[

TooltipHandler:getAlternativeEnemyLevelText(playerID)

- Returns alternative level information for enemies.

]]--
function TooltipHandler:getAlternativeEnemyLevelText(playerID)
	local Type, prefix;
	local level;

	if string.sub(playerID,1,5) == "index" then
		local iname = self:GetCharacterName(playerID, "unit");
		level = Friendlist:GetLevel(iname);
	else
		level = UnitLevel(playerID);
	end      

	if level ~= nil and level ~= "" and level ~= 0 then
		--FlagRSP:printDebug("level is: " .. level);
		Diff = level - UnitLevel("player");

		if string.sub(playerID,1,5) ~= "index" and UnitClassification(playerID) == "elite" then
			Diff = Diff + 5;
		end
      
		local r, g, b;
		if ( level == -1 or Diff >= 7 ) then
			r = QuestDifficultyColor["impossible"].r;
			g = QuestDifficultyColor["impossible"].g;
			b = QuestDifficultyColor["impossible"].b;
		elseif ( Diff >= 4 ) then
			r = QuestDifficultyColor["verydifficult"].r;
			g = QuestDifficultyColor["verydifficult"].g;
			b = QuestDifficultyColor["verydifficult"].b;
		elseif ( Diff >= -1 ) then
			r = QuestDifficultyColor["difficult"].r;
			g = QuestDifficultyColor["difficult"].g;
			b = QuestDifficultyColor["difficult"].b;
		elseif ( -Diff <= GetQuestGreenRange() ) then
			r = QuestDifficultyColor["standard"].r;
			g = QuestDifficultyColor["standard"].g;
			b = QuestDifficultyColor["standard"].b;
		else
			r = QuestDifficultyColor["trivial"].r;
			g = QuestDifficultyColor["trivial"].g;
			b = QuestDifficultyColor["trivial"].b;
		end
      
		prefix = "|cFF" .. FlagRSP:getHexString(r*255,2) .. FlagRSP:getHexString(g*255,2) .. FlagRSP:getHexString(b*255,2);
      
		--DEFAULT_CHAT_FRAME:AddMessage("DEBUG: r: " .. r .. " g: " .. g .. " b: " .. b, 1.0, 1.0, 0.0);   
      
		if ( level == -1 or Diff >= 10 ) then
			Type = prefix .. FlagRSP_Locale_Impossible;
		elseif ( Diff >= 7 ) then
			Type = prefix .. FlagRSP_Locale_Estrong;
		elseif ( Diff >= 4 ) then
			Type = prefix .. FlagRSP_Locale_Vstrong;
		elseif ( Diff >= 2 ) then
			Type = prefix .. FlagRSP_Locale_Strong;
		elseif ( Diff >= -1 ) then
			Type = prefix .. FlagRSP_Locale_Equal;
		elseif ( Diff >= -GetQuestGreenRange()) then
			Type = prefix .. FlagRSP_Locale_Weak;
		elseif ( Diff >= (-4 -GetQuestGreenRange())) then
			Type = prefix .. FlagRSP_Locale_Puny;
		else
			Type = prefix .. FlagRSP_Locale_Epuny;
		end
      
--		if string.sub(playerID,1,5) ~= "index" and UnitClassification(playerID) == "elite" then
--			Type = Type .. FlagRSP_Locale_Elite;
--		elseif string.sub(playerID,1,5) ~= "index" and UnitClassification(playerID) == "worldboss" then
--			Type = Type .. FlagRSP_Locale_Boss;
--		end
      
		Type = Type .. "|r";
	else
		Type = "";
	end

	return Type;
end

--[[

TooltipHandler:getAlternateLevelText(playerID)

- Colors the level text the same as in the target frame.

]]--

function TooltipHandler:getAlternateLevelText(playerID)
	local Type, prefix;
	local level;

	if string.sub(playerID,1,5) == "index" then
		local iname = self:GetCharacterName(playerID, "unit");
		level = Friendlist:GetLevel(iname);
	else
		level = UnitLevel(playerID);
	end

	if level ~= nil and level ~= "" and level ~= 0 then
		--FlagRSP:printDebug("level is: " .. level);

		local r,g,b;
		local color;

		color = GetDifficultyColor(level);
		r = color.r;
		g = color.g;
		b = color.b;

		if ( level == -1 ) then 
			level = "??"
			r=1;
			g=0.13;
			b=0.13;
		end

		prefix = "|cFF" .. FlagRSP:getHexString(r*255,2) .. FlagRSP:getHexString(g*255,2) .. FlagRSP:getHexString(b*255,2);
		Type = prefix .. FlagRSP_Locale_TradLevelLine .. level;

		Type = Type .. "|r";
	else
		Type = "";
	end

	return Type;
end


--[[

TooltipHandler:getFriendlistTooltipText(name)

- Returns text for friend/foe entry of Friendlist in tooltip for player name.

]]--
function TooltipHandler:getFriendlistTooltipText(name)
	local friendstateText = "";
	local r,g,b,text,friendstate;
	friendstate = Friendlist:GetFriendstate(name);

	if friendstate ~= nil then

		--FlagRSP:printDebug("friendstate is: " .. friendstate);

		text = ""; 
		r,g,b,text = Friendlist:GetFriendstateInfo(friendstate);

		if text ~= nil and text ~= "" then
			friendstateText = "|cFF" .. FlagRSP:getHexString(r*255,2) .. FlagRSP:getHexString(g*255,2) .. FlagRSP:getHexString(b*255,2) .. text .. "|r";     
		end
	end

	return friendstateText;
end


--[[

TooltipHandler:getFriendlistGuildTooltipText(playerID)

- Returns text for friend/foe entry of Friendlist in tooltip for guild.

]]--
function TooltipHandler:getFriendlistGuildTooltipText(playerID)
	local friendstateText = "";
	local r,g,b,text,friendstate;

	local a,b, guildname;
	guildname, a, b = GetGuildInfo(playerID);
   
	friendstate = Friendlist:GetFriendstate(guildname);

	if friendstate ~= nil then
		r,g,b,text = Friendlist:GetFriendstateGuildInfo(friendstate);
      
		friendstateText = "|cFF" .. FlagRSP:getHexString(r*255,2) .. FlagRSP:getHexString(g*255,2) .. FlagRSP:getHexString(b*255,2) .. text .. "|r";     
	end

	return friendstateText;
end


--[[

TooltipHandler:getLevel(playerID)

- Returns level of player.

]]--
function TooltipHandler:getLevel(playerID)
	local Level = "";

	if string.sub(playerID,1,5) == "index" then
		local iname = self:GetCharacterName(playerID, "unit");
		Level = Friendlist:GetLevel(iname);
	else
		if UnitLevel(playerID) >= 1 then
			Level = UnitLevel(playerID);
		else
			Level = "??";
		end
	end

	return Level;
end


--[[

TooltipHandler:isPet:isPet(playerID)

- Returns true if <playerID> is a pet.

]]--
function TooltipHandler:isPet(playerID)
	local isPet = false;

	if (not UnitIsPlayer(playerID)) and (UnitPlayerControlled(playerID)) then isPet = true; end
   
	return isPet;
end


--[[

TooltipHandler:getPetOwner(tooltipLines)

-- Returns the name of the pet's owner.

]]--
function TooltipHandler:getPetOwner(tooltipLines)
	local ownerName = "";
	--local ownerLine = "";

	for t=1, 8 do
		if tooltipLines[t] ~= nil then
			--if TooltipHandler:isPet("mouseover") then 
				--local match, match2, match3 = string.find("Begleiter von Ulsdfsdfsdfdfsdfsfi", "Begleiter von (.+)");  
				--FlagRSP:printDebug(match .. " " .. match2 .. " " .. match3);
			--end
			local i = 0;
			while FlagRSP_Locale_MinionLine[i] ~= nil do
				--if tooltipLines[t] ~= "" then
					--FlagRSP:printDebug("Line: " .. tooltipLines[t] .. ", Minion line: " .. FlagRSP_Locale_MinionLine[i]);
				--end

				local s, e, match = string.find(tooltipLines[t], FlagRSP_Locale_MinionLine[i]);

				--if s ~= nil then
					--FlagRSP:printDebug("s" .. s);
				--end
				--if e ~= nil then
					--FlagRSP:printDebug("e" .. e);
				--end
				--if match ~= nil then
					--FlagRSP:printDebug("m" .. match);
				--end

				if match ~= nil and match ~= "" then 
					ownerName = match; 
					--FlagRSP:printDebug("m" .. match);
					--ownerLine = tooltipLines[t];
				end
				i = i + 1;
			end
		end
	end
   
	return ownerName;
end


--[[

TooltipHandler:getPetOwnerLine(tooltipLines)

-- Returns the line for the pet's owner.

]]--
function TooltipHandler:getPetOwnerLine(tooltipLines)
	--local ownerName = "";
	local ownerLine = "";

	for t=1, 8 do
		if tooltipLines[t] ~= nil then
			--if TooltipHandler:isPet("mouseover") then 
				--local match, match2, match3 = string.find("Begleiter von Ulsdfsdfsdfdfsdfsfi", "Begleiter von (.+)");  
				--FlagRSP:printDebug(match .. " " .. match2 .. " " .. match3);
			--end
			local i = 0;
			while FlagRSP_Locale_MinionLine[i] ~= nil do
				local s, e, match = string.find(tooltipLines[t], FlagRSP_Locale_MinionLine[i]);
				if match ~= nil and match ~= "" then 
					--ownerName = match; 
					ownerLine = tooltipLines[t];
				end
				i = i + 1;
			end
		end
	end
   
	return ownerLine;
end

--[[

TooltipHandler:GetPetOwner(str)

-- Extracts the name of the pet's owner from str.

]]--

function TooltipHandler:GetPetOwner(str)
	local s, e, match;
	
	if ( str == nil ) then
		return;
	end
	
	for i = 0, table.getn(FlagRSP_Locale_MinionLine) do
		s, e, match = string.find(str, FlagRSP_Locale_MinionLine[i]);
		
		if ( match ~= nil and match ~= "" ) then
			return match, i;
		end
	end
	
	-- If all else fails, return an empty string.
	return "";
end

--[[

TooltipHandler:BuildPetOwnerLine()

]]--
function TooltipHandler:BuildPetOwnerLine()
	local result, index;
	local ownerLine;
	
	-- By the time this is called, GameTooltip's contents have been destroyed.
	-- So we use a hidden tooltip to scan for the information we need.
	FlagRSPTooltip:SetUnit("mouseover");
	
	for t = 1, GameTooltip:NumLines() do
		local line = getglobal("FlagRSPTooltipTextLeft" .. t)
		local text = line:GetText();
		
		result, index = self:GetPetOwner(text);
		
		if ( result ~= "" ) then
			break;
		end
	end
	
	if ( result == "" ) then
		return "";
	end

	if ( FlagRSP:getNameDisp() and not Friendlist:isFriend(result) )  then
		-- Pet belongs to an unknown player.  Hide the name.
		ownerLine = string.gsub(FlagRSP_Locale_Minion[index], "%%s", FlagRSP_Locale_Unknown);
	else
		-- Pet owner's name can be shown.
		ownerLine = string.gsub(FlagRSP_Locale_Minion[index], "%%s", result);
	end
	
	return ownerLine;
end


--[[

TooltipHandler:getMouseoverPetOwner()

-- Returns the name of the pet's owner.

]]--
function TooltipHandler:getMouseoverPetOwner()
	local Lines = {};
	local ttext;

	--FlagRSP:printDebug("looking for owner");

	--GameTooltip:AddLine("test");

	for t = 1, 8 do
		ttext = getglobal("GameTooltipTextLeft" .. t);
		local tline = ttext:GetText();
		if tline == nil then 
			tline = ""; 
		end
		Lines[t] = tline;
		--if tline ~= "" then FlagRSP:printDebug(tline); end
		--if Lines[t] ~= "" then FlagRSP:printDebug(Lines[t]); end
	end

	--FlagRSP:print(TooltipHandler:getPetOwner(Lines));

	return self:getPetOwner(Lines);
end


--[[

TooltipHandler:getMouseoverPetOwnerLine()

-- Returns the owner's tooltip line of the pet.

]]--
function TooltipHandler:getMouseoverPetOwnerLine()
	local Lines = {};
	local ttext;

	--FlagRSP:printDebug("looking for owner");

	--GameTooltip:AddLine("test");

	for t = 1, 8 do
		ttext = getglobal("GameTooltipTextLeft" .. t);
		local tline = ttext:GetText();
		if tline == nil then 
			tline = ""; 
		end
		Lines[t] = tline;
		--if Lines[t] ~= "" then FlagRSP:printDebug(Lines[t]); end
	end
   
   --FlagRSP:print(self:getPetOwner(Lines));
   
   return self:getPetOwnerLine(Lines);
end


--[[

TooltipHandler:getClass(playerID)

- Returns class of player.

]]--
function TooltipHandler:getClass(playerID)
	local Class = "";
   
	-- capture self-made playerID for Friendlist
	if string.sub(playerID,1,5) == "index" then
		local iname = self:GetCharacterName(playerID, "unit");
		Class = Friendlist:GetClass(iname);
	else
		if UnitClass(playerID) ~= nil then
			-- Lets the class be colored on the tooltip.
			if ( FlagRSPConfigure:GetClassColor() ) then
				local class, file = UnitClass(playerID);
				local color;
--[[				color = { Shaman = 	{ r = 0,		g = 0.86, 	b = 0.73	},
						Paladin = { r = 0.96,	g = 0.55, 	b = 0.73	},
						Druid = 	{ r = 1, 		g = 0.49, 	b = 0.04	},
						Hunter = 	{ r = 0.67,	g = 0.83, 	b = 0.45	},
						Warrior = { r = 0.78,	g = 0.61, 	b = 0.43	},
						Mage = 	{ r = 0.41,	g = 0.8, 		b = 0.94	},
						Priest = 	{ r = 1, 		g = 1, 		b = 1	},
						Rogue = 	{ r = 1, 		g = 0.96, 	b = 0.41	},
						Warlock = { r = 0.58,	g = 0.51, 	b = 0.79	}
					};
				temp = UnitClass(playerID); ]]--
				color = RAID_CLASS_COLORS[file];
				
				Class = "|cFF" .. FlagRSP:getHexString(color.r*255,2) .. FlagRSP:getHexString(color.g*255,2) .. FlagRSP:getHexString(color.b*255,2);
				Class = Class .. class .. "|r";
			else
				Class = UnitClass(playerID);
		end
	end
		if UnitCreatureType(playerID) ~= nil and UnitCreatureType(playerID) ~= "" and not UnitIsPlayer(playerID) and not UnitPlayerControlled(playerID) then
			Class = UnitCreatureType(playerID);
		end
		if UnitCreatureFamily(playerID) ~= nil and UnitCreatureFamily(playerID) ~= "" then
			Class = UnitCreatureFamily(playerID);
		end
	end
   
	return Class;
end


--[[

TooltipHandler:getRace(playerID)

- Returns race of player.

]]--
function TooltipHandler:getRace(playerID)
	local Race = "";

	-- capture self-made playerID for Friendlist
	if string.sub(playerID,1,5) == "index" then
		local iname = self:GetCharacterName(playerID, "unit");
		Race = Friendlist:GetRace(iname);
	else
		if UnitRace(playerID) ~= nil then
			Race = UnitRace(playerID);
		end
	end
	
	if ( Race == nil ) then
		Race = "";
	end

	return Race;
end


--[[

TooltipHandler:getName(playerID)

- Returns name of player.

]]--
function TooltipHandler:getName(playerID)
	return self:GetCharacterName(playerID, "first");
end

--[[

TooltipHandler:getSurname(name)

- Returns surname for player name.

]]--
function TooltipHandler:getSurname(name)
	local surname = "";
   
	--if xTP_CTList[name] ~= "" and xTP_CTList[name] ~= nil then
		--surname = xTP_CTList[name];
	if FlagHandler:getFlag("Surname", name) ~= "" then
		surname = FlagHandler:getFlag("Surname", name);
	elseif Friendlist:GetSurname(name) ~= "" and Friendlist:GetSurname(name) ~= nil then
		surname = Friendlist:GetSurname(name);
	end
   
	return surname;
end

--[[

TooltipHandler:GetCharacterName(playerID, position)

-- Returns the type of name for the character and, if possible, the server.
--  These values may change later.
--  Handled types for <position>: unit, first, last

]]--
function TooltipHandler:GetCharacterName(playerID, position)
	if ( position == nil or position == "" or playerID == nil or playerID == "" ) then
		return;
	end
	
	local name = "";
	
	if ( string.sub(playerID, 1, 5) ~= "index" and position == "unit" and UnitName(playerID) ~= nil ) then
		local server;
		name, server = UnitName(playerID);
		return name, server;
	elseif ( string.sub(playerID, 1, 5) == "index" and position == "unit" ) then
		name = Friendlist:GetName(playerID);
		return name;
	elseif ( position == "first" ) then
		name = FlagHandler:getFlag("Name", self:GetCharacterName(playerID, "unit"))
		if ( name ~= nil and name ~= " " and name ~= "" ) then
			return name;
		elseif ( string.sub(playerID,1,5) == "index" ) then
			name = Friendlist:GetName(playerID, true);
			return name
		else
			if ( UnitName(playerID) ~= nil ) then
				name = UnitName(playerID);
				return name
			end
		end
	elseif ( position == "middle" ) then
		
	elseif ( position == "last" ) then
		if ( playerID == "mouseover" or playerID == "target" or playerID == "player" ) then
			local temp = self:GetCharacterName(playerID, "unit")
			
			if ( FlagHandler:getFlag("Surname", temp) ~= "" ) then
				name = FlagHandler:getFlag("Surname", temp);
				return name;
			elseif ( Friendlist:GetSurname(temp) ~= "" and Friendlist:GetSurname(temp) ~= nil ) then
				name = Friendlist:GetSurname(temp);
				return name;
			end
		end
	end
	
end

--[[
TooltipHandler:BuildName(playerID)

- Builds a full character name of the playerID, whether it be from mouseover,
  target, or Friendlist.

]]--
function TooltipHandler:BuildName(playerID)
	local nameText;
	local firstName, unitName, lastName
	
	if ( string.sub(playerID, 1, 5) == "index" ) then
		-- We have a Friendlist entry, build from there.
		unitName, firstName = Friendlist:GetName(playerID);
		
		if ( FlagHandler:getFlag("Surname", unitName) ~= "" ) then
			lastName = FlagHandler:getFlag("Surname", unitName);
		elseif ( Friendlist:GetSurname(unitName) ~= "" and Friendlist:GetSurname(unitName) ~= nil ) then
			lastName = Friendlist:GetSurname(unitName);
		end
		
		-- Okay, we've got our names, let's put them together.
		nameText = ""
		
		if ( firstName ~= "" and firstName ~= nil ) then
			nameText = firstName .. " ";
		end
		if ( unitName ~= nil and unitName~= "" )  then
			nameText = nameText .. unitName;
		end
		
		if ( lastName ~= nil and lastName ~= "" ) then
			if ( string.sub(lastName, 1, 1) == "," ) then
				nameText = nameText .. lastName;
			else
				nameText = nameText .. " " .. lastName;
			end
		end
		
		return nameText;
	elseif ( playerID == "target" or playerID == "mouseover" or playerID == "player" ) then
		-- We have a target or mouseover.
	end
end

--[[

TooltipHandler:getPVPRank(playerID)

- Returns name of player.

]]--
function TooltipHandler:getPVPRank(playerID)
	local Rank = "";

	-- capture self-made playerID for Friendlist
	if string.sub(playerID,1,5) == "index" then
		local iname = self:GetCharacterName(playerID, "unit");
		if ( Friendlist:GetRank(iname) ~= nil ) then
			Rank = Friendlist:GetRank(iname);
		end
	else
		local name = UnitName(playerID);
		--if UnitPVPRank(playerID) ~= nil and GetPVPRankInfo(UnitPVPRank(playerID), playerID) ~= nil then
		if ( UnitPVPName(playerID) ~= name and name ~= nil and UnitPVPName(playerID) ~= nil ) then
			Rank = ( string.sub(UnitPVPName(playerID), 1, string.find(UnitPVPName(playerID), name)-1) );
			--Rank = GetPVPRankInfo(UnitPVPRank(playerID), playerID);
			--FlagRSP:printDebug("flagRSP: DEBUG: Selected Unit's PVP rank is: " .. Rank .. ", rank number is: " .. UnitPVPRank(playerID));
		end
	end

	return Rank;
end


--[[

TooltipHandler:getGuild(playerID)

- Returns guild of player.

]]--
function TooltipHandler:getGuild(playerID)
	local guild = "";

	-- capture self-made playerID for Friendlist
	if string.sub(playerID,1,5) == "index" then
		local iname = self:GetCharacterName(playerID, "unit");
		guild = Friendlist:GetGuild(iname);
	else
		local a,b;
		guild, a, b = GetGuildInfo(playerID);
	end
	
	if ( guild == nil ) then 
		guild = ""; 
	end

	return guild;
end

--[[

TooltipHandler:getAlternateGuild(playerID)

- Returns guild of player the way I want it to be.

]]--
function TooltipHandler:getAlternateGuild(playerID)
	local guild = "";
   
	-- capture self-made playerID for Friendlist
	if string.sub(playerID,1,5) == "index" then
		local iname = self:GetCharacterName(playerID, "unit");
		guild = Friendlist:GetGuild(iname);
	else
		local temp, rank, index;
		temp, rank, index = GetGuildInfo(playerID);
      
		if ( temp ~= nil and temp ~= "" ) then
			if ( rank ~= nil and rank ~= "" and FlagRSPConfigure:GetGuildRank() ) then
				guild = rank .. " " .. FlagRSP_Locale_Of .. " " .. temp;
			else
				guild = temp;
			end
		else
			guild = "";
		end
	end

	return guild;
end

--[[

TooltipHandler:getTitle(name)

- Returns title for player name.

]]--
function TooltipHandler:getTitle(name)
	local title = "";

	--if xTP_CTList2[name] ~= "" and xTP_CTList2[name] ~= nil then
		--title = xTP_CTList2[name];
	if FlagHandler:getFlag("Title", name) ~= "" then
		title = FlagHandler:getFlag("Title", name);
	elseif Friendlist:GetTitle(name) ~= nil then
		title = Friendlist:GetTitle(name);
	end

	return title;
end


--[[

TooltipHandler:getSkinningSkill()

- Returns skinnung skill for player.

]]--
function TooltipHandler:getSkinningSkill()
	local skill = 0;
	local skillName, isHeader, isExpanded, skillRank, numTempPoints, skillModifier, skillMaxRank, isAbandonable, stepCost, rankCost, minLevel, skillCostType;

	for i=1, GetNumSkillLines() do
		skillName, isHeader, isExpanded, skillRank, numTempPoints, skillModifier, skillMaxRank, isAbandonable, stepCost, rankCost, minLevel, skillCostType = GetSkillLineInfo(i);
		if skillName == FlagRSP_Locale_Skinning then
			--FlagRSP:printDebug("Name: " .. skillName);
			--FlagRSP:printDebug("Rank: " .. skillRank);
			--FlagRSP:printDebug("TempPoints: " .. numTempPoints);
			--FlagRSP:printDebug("Mod: " .. skillModifier);
			--FlagRSP:printDebug("SkillCostType: " .. skillCostType);

			skill = skillRank + skillModifier;
		end
	end

	return skill;
end


--[[

TooltipHandler:getSkinningColor(playerID)

- Returns skinnung skill for player.

]]--
function TooltipHandler:getSkinningColor(playerID)
	local r,g,b;
	local level = UnitLevel(playerID);
	local skillReal = self:getSkinningSkill();

	if ( not FlagRSPConfigure:GetSkinnableFancy() ) then

		--FlagRSP:printDebug("Not doing fancy skinnable line.");

		local foundColour = "";
      
		--FlagRSP:printDebug("Skill: " .. skill);
		--FlagRSP:printDebug("Mod: " .. math.mod(skill,5));
      
		local skill = skillReal - math.fmod(skillReal,5);
      
		r = 1; g = 1; b = 1;
      
		--FlagRSP:printDebug("Skill is: " .. skill .. " UnitLevel is: " .. level);
      
		local found = false;
      
		local colours = {};
		colours[0] = "grey";
		colours[1] = "green";
		colours[2] = "yellow";
		colours[3] = "orange";
      
		for i=0, 3 do
			if ( level ~= nil and self.skinnableTable[colours[i]][skill] ~= nil ) then
				--FlagRSP:printDebug(self.skinnableTable[colours[i]][skill]);
				if not found and self.skinnableTable[colours[i]][skill] >= level then
					foundColour = colours[i];
					found = true;
					break;
				end
			end
		end

		--FlagRSP:printDebug("Found: " .. foundColour);
      
		if not found or skillReal == 0 then
			r = self.skinnableColours["red"].r;
			g = self.skinnableColours["red"].g;
			b = self.skinnableColours["red"].b;
		else
			r = self.skinnableColours[foundColour].r;
			g = self.skinnableColours[foundColour].g;
			b = self.skinnableColours[foundColour].b;
		end
	else
		--FlagRSP:printDebug("Doing fancy skinnable line.");

		local lSkill = skillReal - math.mod(skillReal,5);
		local hSkill = skillReal - math.mod(skillReal,5) + 5;

		local quotSkill = (skillReal - lSkill)*0.2;

		--FlagRSP:printDebug("Skill is: " .. skillReal .. ", high skill: " .. hSkill .. ", low skill: " .. lSkill .. ", quot: " .. quotSkill);

		local colours = {};
		colours[1] = "grey";
		colours[2] = "green_a";
		colours[3] = "yellow_a";
		colours[4] = "orange_a";
		colours[5] = "red";

		local colourLevel = {};
      
		for i=1, 4 do
			colourLevel[i] = self.skinnableTable[colours[i]][lSkill] + (self.skinnableTable[colours[i]][hSkill] - self.skinnableTable[colours[i]][lSkill])*quotSkill;
	 
			--FlagRSP:printDebug("Colour is: " .. colours[i] .. ", colourLevel: " .. colourLevel[i]);
		end      
		-- red is special.
		colourLevel[5] = self.skinnableTable["orange"][lSkill]+1 + (self.skinnableTable["orange"][hSkill] - self.skinnableTable["orange"][lSkill])*quotSkill;
		--FlagRSP:printDebug("Colour is: red, colourLevel: " .. colourLevel[4]);
		colourLevel[0] = -1;
		colourLevel[6] = 1000;

		-- find the two colours that are interesting for us.
		local lColour, hColour;
		for i=1, 6 do
			--FlagRSP:printDebug("level is: " .. level);
			--FlagRSP:printDebug("i: " .. i);
			--FlagRSP:printDebug("i is: " .. colourLevel[i]);
			--FlagRSP:printDebug("i-1 is: " .. colourLevel[i-1]);
			if colourLevel[i] >= level and colourLevel[i-1] < level then
				lColour = i-1;
				hColour = i;
			end
		end

		--FlagRSP:printDebug("lColour is: " .. lColour);
		--FlagRSP:printDebug("hColour is: " .. hColour);

		-- special case: level for lColour is -1. Then  hColour is our colour.
		if colourLevel[lColour] <= -1 then
			--FlagRSP:printDebug("colour: " .. colours[hColour]);
			r = self.skinnableColours[colours[hColour]].r;
			g = self.skinnableColours[colours[hColour]].r;
			b = self.skinnableColours[colours[hColour]].r;
		elseif colourLevel[hColour] == 1000 then
			r = self.skinnableColours["red"].r;
			g = self.skinnableColours["red"].g;
			b = self.skinnableColours["red"].b;
		else
			local quotColour = 1/(colourLevel[hColour] - colourLevel[lColour]);

			local hQuot, lQuot;

			hQuot = quotColour*(level-colourLevel[lColour]);
			lQuot = quotColour*(colourLevel[hColour]-level);

			r = hQuot*selfskinnableColours[colours[hColour]].r + lQuot*self.skinnableColours[colours[lColour]].r;
			g = hQuot*self.skinnableColours[colours[hColour]].g + lQuot*self.skinnableColours[colours[lColour]].g;
			b = hQuot*self.skinnableColours[colours[hColour]].b + lQuot*self.skinnableColours[colours[lColour]].b;
	 
		end

		if skillReal == 0 then
			r = self.skinnableColours["red"].r;
			g = self.skinnableColours["red"].g;
			b = self.skinnableColours["red"].b;
		end
	end

	if level == -1 then
		r = self.skinnableColours["red"].r;
		g = self.skinnableColours["red"].g;
		b = self.skinnableColours["red"].b;
	end

	return r,g,b;
end


--[[

TooltipHandler:getRPTag(name)

- Returns rp flag for player name (no colours, just the string).

]]--
function TooltipHandler:getRPTag(name)
	local rptag = "";

	--if xTP_RPList[name] ~= nil then
		--if xTP_RPList[name] >= 1 then
	if FlagHandler:getFlag("RPFlag", name) ~= "" and FlagHandler:getFlag("RPFlag", name) >= 1 then
		if FlagHandler:getFlag("RPFlag", name) == 1 then
			rptag = FlagRSP_Locale_RP;
		elseif FlagHandler:getFlag("RPFlag", name) == 2 then
			rptag = FlagRSP_Locale_RP2;
		elseif FlagHandler:getFlag("RPFlag", name) == 3 then
			rptag = FlagRSP_Locale_RP3;
		elseif FlagHandler:getFlag("RPFlag", name) == 4 then
			rptag = FlagRSP_Locale_RP4;
		end
	end

	--if xTP_RP2List[name] ~= nil and xTP_RP2List[name] then
		--rptag = rptag .. "\n" .. FlagRSP_Locale_Unicorn;
	--end
    
	return rptag;
end


--[[

TooltipHandler:getRP2Tag(name)

- Returns rp flag for player name (no colours, just the string).

]]--
function TooltipHandler:getRP2Tag(name)
	local rptag = "";

	if xTP_RP2List[name] ~= nil and xTP_RP2List[name] then
		if UList_Installed and UList[FlagRSP.rName] ~= nil and UList[FlagRSP.rName][name] then
			rptag = FlagRSP_Locale_UnicornOfficial;
		else
			rptag = FlagRSP_Locale_UnicornNonOfficial;
		end
	end
    
	return rptag;
end


--[[

TooltipHandler:getLevelTooltipText(playerID)

- Returns text for level line in tooltip depending on levelchange.
- Needed: Other level description for friends.

]]--
function TooltipHandler:getLevelTooltipText(playerID)
	local levelText = "";

	local isplayer;
	local iname = self:getName(playerID);

	if string.sub(playerID,1,5) == "index" then
		isplayer = true;
	else
		isplayer = UnitIsPlayer(playerID);
	end

	local level = TooltipHandler:getLevel(playerID);

	--FlagRSP:printDebug("level is: " .. level .. ", name: " .. iname);

	if level ~= "" and level ~= 0 then
		if isplayer then
			--FlagRSP:print("Catchpoint A.");
			if ( FlagRSPConfigure:GetLevelDisplay() == "relative" ) then
				--levelText = FlagRSP_Locale_AltLevelPrefix .. self:getAlternativeEnemyLevelText();
				levelText = self:getAlternativeEnemyLevelText(playerID) .. " " .. self:getRace(playerID) .. " " .. self:getClass(playerID);
			elseif ( FlagRSPConfigure:GetLevelDisplay() == "color" ) then
				levelText = self:getAlternateLevelText(playerID) .. " " .. self:getRace(playerID) .. " " .. self:getClass(playerID);
			else
				levelText = FlagRSP_Locale_TradLevelLine .. self:getLevel(playerID) .. " " .. self:getRace(playerID) .. " " .. self:getClass(playerID);
				--FlagRSP:printDebug("trad level line.");
			end
		else
			--FlagRSP:print("Catchpoint B.");
			if ( FlagRSPConfigure:GetLevelDisplay() == "relative" ) then
				--levelText = FlagRSP_Locale_AltLevelPrefix .. self:getAlternativeEnemyLevelText();
				levelText = FlagRSP_Locale_AltLevelLine .. self:getAlternativeEnemyLevelText(playerID);
			elseif ( FlagRSPConfigure:GetLevelDisplay() == "color" ) then
				levelText = self:getAlternateLevelText(playerID);
			else
				levelText = FlagRSP_Locale_TradLevelLine .. self:getLevel(playerID);
			end

			if ( not UnitIsFriend("player", playerID) and not UnitIsDead(playerID) ) then
				levelText = levelText .. " " .. UnitCreatureType(playerID);
			end

			if ( UnitIsDead(playerID) ) then
				levelText = levelText .. FlagRSP_Locale_Corpse;
			end

			if ( string.sub(playerID,1,5) ~= "index" and UnitClassification(playerID) == "elite" ) then
				levelText = levelText .. FlagRSP_Locale_Elite;
			elseif ( string.sub(playerID,1,5) ~= "index" and UnitClassification(playerID) == "worldboss" ) then
				levelText = levelText .. FlagRSP_Locale_Boss;
			elseif ( string.sub(playerID,1,5) ~= "index" and UnitClassification(playerID) == "rare" ) then
				levelText = levelText .. FlagRSP_Locale_Rare;
			elseif ( string.sub(playerID,1,5) ~= "index" and UnitClassification(playerID) == "rareelite" ) then
				levelText = levelText .. FlagRSP_Locale_RareElite;
			end
		end
	end
   
	return levelText;
end


--[[

TooltipHandler:getLevelText(playerID)

- Returns text for level line in tooltip depending on levelchange.
- Needed: Other level description for friends.

]]--
function TooltipHandler:getLevelText(playerID)
	local levelText = "";
	--local level = self:getLevel(playerID);

	if ( FlagRSPConfigure:GetLevelDisplay() == "relative" ) then 
		--levelText = FlagRSP_Locale_AltLevelPrefix .. self:getAlternativeEnemyLevelText();
		levelText = FlagRSP_Locale_AltLevelLine .. self:getAlternativeEnemyLevelText(playerID);
	else
		if self:getLevel(playerID) ~= 0 then
			levelText = FRIENDLIST_LOCALE_LevelLine .. self:getLevel(playerID);
		end

		--levelText = FlagRSP_Locale_TradLevelPrefix .. UnitLevel(playerID) .. " " .. UnitRace(playerID) .. " " .. UnitClass(playerID);
	end
   
	return levelText;
end


--[[

TooltipHandler:updateFriendEntries()

-- Updates the list of standard friend list entries.

]]--
function TooltipHandler:updateFriendEntries()
	self.friendEntries = nil;
	self.friendEntries = {};

	FlagRSP:printDebug("updating friend list.");   
	for t = 1, GetNumFriends() do
		local fName = GetFriendInfo(t);
		self.friendEntries[t] = fName;
	end
end


--[[

TooltipHandler:updateIgnoredList()

-- Updates the list of ignored players.

]]--
function TooltipHandler:updateIgnoredList()
	self.ignoredList = nil;
	self.ignoredList = {};
   
	FlagRSP:printDebug("updating ignored list.");
	for t = 1, GetNumIgnores() do
		local iName = GetIgnoreName(t);

		self.ignoredList[t] = iName;
	end
end


--[[

TooltipHandler:updateGuildMembers()

-- Updates the list of own guild members.

]]--
function TooltipHandler:updateGuildMembers()
	self.guildMembers = nil;
	self.guildMembers = {};
   
	FlagRSP:printDebug("updating guild list.");
	local u = GetNumGuildMembers();
	for t = 1, u do
		local gName = GetGuildRosterInfo(t);

		self.guildMembers[t] = gName;
	end
end


--[[

TooltipHandler:playerIsGuildMember(name)

- Checks, if player <name> is a guild member of the user.
- Returns true if so, false if not.

]]--
function TooltipHandler:playerIsGuildMember(name)
	local isMember = false;

	--FlagRSP:printDebug("searching in list of guild members. Number of entries: " .. table.getn(self.guildMembers));
	for i=1, table.getn(self.guildMembers) do
		if self.guildMembers[i] == name then
			isMember = true;
		end
		--FlagRSP:printDebug("entry #" .. i .. " is: " .. self.guildMembers[i]);
	end

	return isMember;
end


--[[

TooltipHandler:playerIsFriendEntry(name)

- Checks, if player <name> is a guild member of the user.
- Returns true if so, false if not.

]]--
function TooltipHandler:playerIsFriendEntry(name)
	local isFriend = false;

	--FlagRSP:printDebug("searching in list of friends. Number of entries: " .. table.getn(self.friendEntries));
	for i=1, table.getn(self.friendEntries) do
		if self.friendEntries[i] == name then
			isFriend = true;
		end
		--FlagRSP:printDebug("entry #" .. i .. " is: " .. self.friendEntries[i]);
	end

	return isFriend;
end


--[[

TooltipHandler:playerIsIgnored(name)

- Checks, if player <name> is a guild member of the user.
- Returns true if so, false if not.

]]--
function TooltipHandler:playerIsIgnored(name)
	local isIgnored = false;

	--FlagRSP:printDebug("searching in list of ignored players. Number of entries: " .. table.getn(self.ignoredList));
	for i=1, table.getn(self.ignoredList) do
		if self.ignoredList[i] == name then
			isIgnored = true;
		end
		--FlagRSP:printDebug("entry #" .. i .. " is: " .. self.ignoredList[i]);
	end

	return isIgnored;
end


--[[

TooltipHandler:playerIsKnown(name)

- Checks, if player name is known to us (self, friends, ignore, guild, Friendlist).
- Returns true if known, false if unknown.

]]--
function TooltipHandler:playerIsKnown(name)
	local isKnown = false;

	--FlagRSP:printDebug("hey: " .. name);

	if name == UnitName("player") then 
		isKnown = true; 
	end
   
	--FlagRSP:printDebug("Owner's name: " .. );

	if self:playerIsFriendEntry(name) then
		isKnown = true;
	end

	if 1 == 0 then
		for t = 1, GetNumFriends() do
			local fName = GetFriendInfo(t);
			if fName == name then 
				isKnown = true;
				break; 
			end
		end
	end

	if self:playerIsIgnored(name) then
		isKnown = true;
	end

	if 1 == 0 then
		for t = 1, GetNumIgnores() do
			local iName = GetIgnoreName(t);
			if iName == name then 
				isKnown = true; 	
				break; 
			end
		end
	end

	--FlagRSP:printDebug("is this player known?");

	if self:playerIsGuildMember(name) then
		isKnown = true;
	end

	if 1 == 0 then
		local u = GetNumGuildMembers();

		for t = 1, u do
			local gName = GetGuildRosterInfo(t);
			if gName == name then 
				isKnown = true;
				break; 
			end
		end
	end
   
	if Friendlist:isFriend(name) then 
		isKnown = true;
	end

	return isKnown;
end


--[[

TooltipHandler:getCharStatus(name)

- Returns character status for player <name>.

]]--
function TooltipHandler:getCharStatus(name)
	local charstatus = "";

	-- Check to be sure not to get malformed status.
	if flagRSP_CharStatusList[name] == "ooc" or flagRSP_CharStatusList[name] == "ic" or flagRSP_CharStatusList[name] == "ffa-ic" or flagRSP_CharStatusList[name] == "st" then
		charstatus = flagRSP_CharStatusList[name];
	end

	return charstatus;
end


--[[

TooltipHandler:getNameTooltipText(playerID)

- Returns text for name line in tooltip.

]]--
function TooltipHandler:getNameTooltipText(playerID)
	local nameText = "";
	local prefix;

	--if UnitIsPlayer(playerID) then
   
	local r, g, b = self:getTooltipNameColor(playerID);
	prefix = "|cFF" .. FlagRSP:getHexString(r*255,2) .. FlagRSP:getHexString(g*255,2) .. FlagRSP:getHexString(b*255,2);

	--if UnitReaction(playerID, "player") >= 5 then prefix = "|cFF" .. FlagRSP:getHexString(0*255,2) .. FlagRSP:getHexString(0.75*255,2) .. FlagRSP:getHexString(0*255,2); end
	--if UnitReaction(playerID, "player") < 4 then prefix = "|cFF" .. FlagRSP:getHexString(0.75*255,2) .. FlagRSP:getHexString(0*255,2) .. FlagRSP:getHexString(0*255,2); end
	--if UnitReaction(playerID, "player") == 4 then prefix = "|cFF" .. FlagRSP:getHexString(0.95*255,2) .. FlagRSP:getHexString(0.95*255,2) .. FlagRSP:getHexString(0*255,2); end
   
	--local name, server = UnitName(playerID);
	local name, server = self:GetCharacterName(playerID, "unit");
	local firstName = self:GetCharacterName(playerID, "first");

	if ( firstName ~= nil and firstName ~= "" and firstName ~= " " and name ~= firstName and not FlagRSP:getNameDisp() ) then
		prefix = prefix .. firstName .. " ";
	end
	
	if UnitIsPlayer(playerID) then
		local lastName = self:GetCharacterName(playerID, "last");
		if ( lastName ~= nil and lastName ~= "" and lastName ~= " " and name ~= lastName )  then
			if ( string.sub(lastName, 1, 1) == "," ) then
				nameText = prefix .. name .. lastName;
			else
				nameText = prefix .. name .. " " .. lastName;
			end
		else
			nameText = prefix .. UnitName(playerID);
		end
		
		if ( server ~= nil and server ~= "" ) then
			nameText = nameText .. " " .. FlagRSP_Locale_Of .. " " .. server;
		end

		nameText = nameText .. "|r";
	elseif self:isPet(playerID) then
		nameText = prefix .. name .. "|r";
	else
		nameText = prefix .. name .. "|r";
	end

	if FlagRSP:getNameDisp() then
		if not self:playerIsKnown(name) then
			if UnitIsPlayer(playerID) then 
				nameText = prefix .. FlagRSP_Locale_Unknown .. "|r";
			elseif self:isPet(playerID) then
				if playerID == "mouseover" then
					if self:playerIsKnown(self:getMouseoverPetOwner()) then
						if self:getMouseoverPetOwner() ~= FlagRSP.pName then	       
							nameText = prefix .. "<" .. self:getMouseoverPetOwnerTooltipText() .. ">|r";
						end
					else
						nameText = prefix .. FlagRSP_Locale_UnknownPet .. "|r";
					end
				else
					nameText = prefix .. FlagRSP_Locale_UnknownPet .. "|r";
				end
			end
		end	    
	end
	--end
   
	--nameText = nameText .. "|r";
	
	return nameText;
end


--[[

TooltipHandler:getMouseoverPetOwnerTooltipText()

- Returns text for pet owner line in tooltip.

]]--
function TooltipHandler:getMouseoverPetOwnerTooltipText()
	local ownerline = "";
	local ownerName, origLine;

	--FlagRSP:printDebug("invoked");

	--if xTP_NameChange[UnitName("player")] == 0 or self:playerIsKnown(UnitName("mouseover")) then
	--FlagRSP:printDebug("known");
	if self:getMouseoverPetOwner() ~= "" then
		--FlagRSP:printDebug("owner known");
		--if FlagRSP_Locale_KnownPetOwnerLine ~= nil and FlagRSP_Locale_KnownPetOwnerLine ~= "" then
			--ownerline = self:ParseString(FlagRSP_Locale_KnownPetOwnerLine, "mouseover");
			--else
		ownerline = self:getMouseoverPetOwnerLine();
		--end
		--FlagRSP:printDebug(ownerLine);
	end
	--end

	--FlagRSP:printDebug("line is" .. ownerline);
   
	return ownerline;
end


--[[

TooltipHandler:getMouseoverPetOwnerTooltipText()

- Returns text for pet owner subline in tooltip.

]]--
function TooltipHandler:getMouseoverPetOwnerTooltipSubText()
	local line = "";

	if not FlagRSP:getNameDisp() or self:playerIsKnown(UnitName("mouseover")) or self:getMouseoverPetOwner() == UnitName("player") then
		line = self:getMouseoverPetOwnerTooltipText();
	end

	--FlagRSP:printDebug("subline is" .. line);

	return line;
end


--[[

TooltipHandler:getPVPRankTooltipText(playerID)

- Returns text for pvp rank text in tooltip.

]]--
function TooltipHandler:getPVPRankTooltipText(playerID)
	local pvpRankText = "";

	-- capture self-made playerID for Friendlist
	if string.sub(playerID,1,5) == "index" then
		--local iname = self:getName(playerID);
		if self:getPVPRank(playerID) ~= "" then
			pvpRankText = FlagRSP_Locale_PVPRankLine .. self:getPVPRank(playerID);
		end
	else

		--DEFAULT_CHAT_FRAME:AddMessage(UnitPVPRank("mouseover") .. " " .. GetPVPRankInfo(UnitPVPRank("mouseover")));
		if UnitIsPlayer(playerID) and FlagRSP:getRankDisp() and self:getPVPRank(playerID) ~= "" then
			pvpRankText = FlagRSP_Locale_PVPRankLine .. self:getPVPRank(playerID);
			--FlagRSP:printDebug("rank");
		end
	end

	return pvpRankText;
end


--[[

TooltipHandler:getTitleTooltipText()

- Returns text for title line in tooltip.

]]--
function TooltipHandler:getTitleTooltipText(playerID)
	local titleText = "";

	local name = UnitName(playerID);

	if UnitIsPlayer(playerID) and self:getTitle(name) ~= "" then
		titleText = self:getTitle(name);
		--self:ParseString(FlagRSP_Locale_TitleLine, playerID, name);
	end
   
	return titleText;
end


--[[

TooltipHandler:getRPTooltipText(name)

- Returns text for rp tag line in tooltip for player name.

]]--
function TooltipHandler:getRPTooltipText(name, playerID)
	local RPTag = "";

	if playerID == nil then
		playerID = "";
	end

	--FlagRSP:printDebug("rp?");

	if ((playerID == "target" or playerID == "mouseover") and (UnitIsPlayer(playerID) or UnitPlayerControlled(playerID))) or (playerID ~= "target" and playerID ~= "mouseover") then
      
		--if xTP_RPList[name] ~= nil then
		if FlagHandler:getFlag("RPFlag", name) ~= "" and FlagHandler:getFlag("RPFlag", name) >= 1 then
			RPTag = "|cFF" .. FlagRSP:getHexString(1*255,2) .. FlagRSP:getHexString(1*255,2) .. FlagRSP:getHexString(0.5*255,2);

			--FlagRSP:printDebug("rp!");

			RPTag = RPTag .. self:getRPTag(name);

			RPTag = RPTag .. "|r";
		end
	end

	return RPTag;
end


--[[

TooltipHandler:getRP2TooltipText(name)

- Returns text for rp tag line in tooltip for player name.

]]--
function TooltipHandler:getRP2TooltipText(name, playerID)
	local RPTag = "";

	if playerID == nil then
		playerID = "";
	end

	if ((playerID == "target" or playerID == "mouseover") and (UnitIsPlayer(playerID) or UnitPlayerControlled(playerID))) or (playerID ~= "target" and playerID ~= "mouseover") then
      
		if xTP_RP2List[name] ~= nil and xTP_RP2List[name] then
			if UList_Installed and UList[FlagRSP.rName] ~= nil and UList[FlagRSP.rName][name] then
				--FlagRSP:printDebug("OFF");
				RPTag = "|cFF" .. FlagRSP:getHexString(1*255,2) .. FlagRSP:getHexString(0.667*255,2) .. FlagRSP:getHexString(0.1*255,2);
			else
				--FlagRSP:printDebug("UNOFF");
				RPTag = "|cFF" .. FlagRSP:getHexString(0.33*255,2) .. FlagRSP:getHexString(0.33*255,2) .. FlagRSP:getHexString(0.33*255,2);
			end
	 
			RPTag = RPTag .. self:getRP2Tag(name);

			RPTag = RPTag .. "|r";
		end
	end
   
	return RPTag;
end


--[[

TooltipHandler:getCharStatusText(name)

- Returns text for character status for player <name>.

]]--
function TooltipHandler:getCharStatusText(name)
	local charstatus = "";

	if self:getCharStatus(name) ~= "" then
		charstatus = "|cFF" .. FlagRSP:getHexString(1*255,2) .. FlagRSP:getHexString(1*255,2) .. FlagRSP:getHexString(0.5*255,2);

		--DEFAULT_CHAT_FRAME:AddMessage("DEBUG: " .. xTP_RPList[name]);
	
		--DEFAULT_CHAT_FRAME:AddMessage(FlagRSP:getHexString(1*255,2) .. FlagRSP:getHexString(1*255,2) .. FlagRSP:getHexString(0.5*255,2));

		local cstatus = self:getCharStatus(name);
 
		if cstatus == "ooc" then
			charstatus = charstatus .. FlagRSP_Locale_OOC;
		elseif cstatus == "ic" then
			charstatus = charstatus .. FlagRSP_Locale_IC;
		elseif cstatus == "ffa-ic" then
			charstatus = charstatus .. FlagRSP_Locale_FFAIC;
		elseif cstatus == "st" then
			charstatus = charstatus .. FlagRSP_Locale_ST;
		end

		charstatus = charstatus .. "|r";
	end
   
	return charstatus;
end


--[[

TooltipHandler:getCivilianLine(playerID)

- Returns colored civilian line.

]]--
function TooltipHandler:getCivilianLine(playerID)
	local prefix, line;

	prefix = "|cFF" .. FlagRSP:getHexString(0*255,2) .. FlagRSP:getHexString(1*255,2) .. FlagRSP:getHexString(0*255,2);

	line = prefix .. FlagRSP_Locale_CivilianLine .. "|r";

	return line;
end


--[[

TooltipHandler:getSkinnableLine(playerID)

- Returns colored skinnable line.

]]--
function TooltipHandler:getSkinnableLine(playerID)
	local prefix, line;
	local r,g,b;

	--FlagRSP:printDebug(self:getSkinningSkill());
	if ( not self.skinnable ) then
		return;
	end

	r, g, b = self:getSkinningColor(playerID);
   
	prefix = "|cFF" .. FlagRSP:getHexString(r*255,2) .. FlagRSP:getHexString(g*255,2) .. FlagRSP:getHexString(b*255,2);

	line = prefix .. FlagRSP_Locale_SkinnableLine .. "|r";

	return line;
end


--[[

TooltipHandler:getCharStatusTooltipText(name, playerID)

- Returns text for character status for tooltip line for player <name>.

]]--
function TooltipHandler:getCharStatusTooltipText(name, playerID)
	local charstatus = "";

	if ((playerID == "target" or playerID == "mouseover") and (UnitIsPlayer(playerID) or UnitPlayerControlled(playerID))) or (playerID ~= "target" and playerID ~= "mouseover") then
		local cs = self:getCharStatusText(name);
		if cs ~= "" then
			charstatus = FlagRSP_Locale_CharStatusLine .. cs;
		end
	end

	return charstatus;
end



--[[

TooltipHandler:getGuildTooltipText(playerID)

- Returns text for guild line in tooltip.

]]--
function TooltipHandler:getGuildTooltipText(playerID)
	local guildText = "";
	local guild = self:getGuild(playerID);


	if UnitIsPlayer(playerID) and FlagRSP:getGuildDisp() == 1 and guild ~= "" then
		--FlagRSP:printDebug(guild);
		--FlagRSP:printDebug(FlagRSP_Locale_GuildLine);
		--FlagRSP:printDebug(self:ParseString(FlagRSP_Locale_GuildLine, playerID));
		--guildText = "<" .. self:getGuild(playerID) .. ">";
		guildText = self:getAlternateGuild(playerID);
	elseif UnitIsPlayer(playerID) and FlagRSP:getGuildDisp() == 0 and guild ~= "" then
		if Friendlist:isFriend(guild) and Friendlist:GetType(guild) == "guild" then 
			--guildText = "<" .. self:getGuild(playerID) .. ">";
			guildText = self:getAlternateGuild(playerID);
		end
	end
   
	return guildText;
end


--[[

TooltipHandler:getTooltipBGColor(playerID)

- Returns background color for tooltip.

]]--
function TooltipHandler:getTooltipBGColor(playerID)
	local r, g, b;
	r = 0.09;
	g = 0.09;
	b = 0.19;

	local reaction = UnitReaction(playerID, "player");

	if reaction ~= nil then   
		if not UnitIsPlayer(playerID) and not UnitPlayerControlled(playerID) then
			if reaction >= 5 then r = 0.09; g = 0.19; b = 0.09; end
			if reaction < 4 then r = 0.10; g = 0.09; b = 0.09; end
			if reaction == 4 then r = 0.19; g = 0.19; b = 0.09; end
		elseif UnitIsPVP(playerID) then
			if reaction >= 5 then r = 0.09; g = 0.19; b = 0.1; end
			if reaction < 4 and not UnitIsPVP("player") then
				r = 0.19; g = 0.19; b = 0.09;
			elseif reaction < 4 and UnitIsPVP("player") then
				r = 0.19; g = 0.09; b = 0.09;
			end
			if reaction == 4 then r = 0.19; g = 0.19; b = 0.09; end
		else
			r = 0.09; g = 0.09; b = 0.19;
		end
	else
		if not UnitIsPlayer(playerID) and not UnitPlayerControlled(playerID) then
			r = 0.19; g = 0.19; b = 0.09;
		else
			r = 0.09; g = 0.09; b = 0.19;
		end
	end

	return r, g, b;
end


--[[

TooltipHandler:getTooltipNameColor(playerID)

- Returns text color for tooltip name line.

]]--
function TooltipHandler:getTooltipNameColor(playerID)
	local r,g,b;

	r = 1;
	g = 1;   
	b = 1;

	local reaction = UnitReaction(playerID, "player");
   
	if reaction ~= nil then
		if not UnitIsPlayer(playerID) and not UnitPlayerControlled(playerID) then
			if reaction >= 5 then r = 0; g = 0.95; b = 0; end
			if reaction < 4 then r = 0.95; g = 0; b = 0; end
			if reaction == 4 then r = 0.95; g = 0.95; b = 0; end
		elseif UnitIsPVP(playerID) then
			if reaction >= 5 then r = 0; g = 0.95; b = 0; end
			if reaction < 4 and not UnitIsPVP("player") then
				r = 0.95; g = 0.95; b = 0.1; 
			elseif reaction < 4 and UnitIsPVP("player") then
				r = 0.95; g = 0; b = 0; 
			end
			if reaction == 4 then r = 0.95; g = 0.95; b = 0; end
		else
			r = 0.5; g = 0.5; b = 0.95;
		end
	else
		if not UnitIsPlayer(playerID) and not UnitPlayerControlled(playerID) then
			r = 0.95; g = 0.95; b = 0;
		else
			r = 0.5; g = 0.5; b = 0.95;
		end
	end
   
	--if UnitReaction(playerID, "player") >= 5 then prefix = "|cFF" .. FlagRSP:getHexString(0*255,2) .. FlagRSP:getHexString(0.75*255,2) .. FlagRSP:getHexString(0*255,2); end
	--if UnitReaction(playerID, "player") < 4 then prefix = "|cFF" .. FlagRSP:getHexString(0.75*255,2) .. FlagRSP:getHexString(0*255,2) .. FlagRSP:getHexString(0*255,2); end
	--if UnitReaction(playerID, "player") == 4 then prefix = "|cFF" .. FlagRSP:getHexString(0.95*255,2) .. FlagRSP:getHexString(0.95*255,2) .. FlagRSP:getHexString(0*255,2); end
   
	return r,g,b;
end


--[[

TooltipHandler:buildSkinnableTable()

- Returns text color for tooltip name line.

]]--
function TooltipHandler:buildSkinnableTable()
	-- build standard table.
	local treshold = {};
	treshold["grey"] = 95;
	treshold["green"] = 45;
	treshold["yellow"] = 20;
	treshold["orange"] = -5;
	local i, d1, d2;

	for colour, t in pairs(treshold) do
		d1 = 19-t/5;
		d2 = t/5+1;
		self.skinnableTable[colour] = {};

		for i=0, 75 do
			if ( t >= (i * 5) ) then
				self.skinnableTable[colour][i*5] = -1;
			elseif ( t < (i * 5) ) then
				if ( (i + d1) <= 40 ) then
					if math.fmod(((i+d1)*5), 10) == 0 then	    
						self.skinnableTable[colour][i*5] = (i+d1)/2;
					else
						self.skinnableTable[colour][i*5] = (i+d1-1)/2;
					end
				else
					self.skinnableTable[colour][i*5] = i-d2;	  
				end
			end
		end
	end
   


	-- build dynamic table.
	self.skinnableTable["green_a"] = {};
	self.skinnableTable["yellow_a"] = {};
	self.skinnableTable["orange_a"] = {};
	for i=0, 65 do 
		self.skinnableTable["green_a"][i*5] = 0.5*(self.skinnableTable["green"][i*5] + self.skinnableTable["grey"][i*5] + 1);
		self.skinnableTable["yellow_a"][i*5] = 0.5*(self.skinnableTable["yellow"][i*5] + self.skinnableTable["green"][i*5] + 1);
		self.skinnableTable["orange_a"][i*5] = 0.5*(self.skinnableTable["orange"][i*5] + self.skinnableTable["yellow"][i*5] + 1);
	end
   
	--[[
	local c,s,cn;
	for i=1, 20 do
		s = math.random(0,65);
		cn = math.random(1,3);

		s=s*5;

		if cn == 1 then c = "green_a";
		elseif cn == 2 then c = "yellow_a";
		elseif cn == 3 then c = "orange_a";
		end

		FlagRSP:print("flagRSP: DEBUG: c: " .. c .. " s: " .. s .. " level: " .. self.skinnableTable[c][s]);
	end
	]]--

	-- colours.
	self.skinnableColours["grey"]= {};
	self.skinnableColours["green"]= {};
	self.skinnableColours["yellow"]= {};
	self.skinnableColours["orange"]= {};
	self.skinnableColours["green_a"]= {};
	self.skinnableColours["yellow_a"]= {};
	self.skinnableColours["orange_a"]= {};
	self.skinnableColours["red"]= {};

	self.skinnableColours["grey"].r = 0.5;
	self.skinnableColours["grey"].g = 0.5;
	self.skinnableColours["grey"].b = 0.5;

	self.skinnableColours["green"].r = 0.25;
	self.skinnableColours["green"].g = 0.75;
	self.skinnableColours["green"].b = 0.25;

	self.skinnableColours["yellow"].r = 1;
	self.skinnableColours["yellow"].g = 1;
	self.skinnableColours["yellow"].b = 0;

	self.skinnableColours["orange"].r = 1;
	self.skinnableColours["orange"].g = 0.5;
	self.skinnableColours["orange"].b = 0.25;

	self.skinnableColours["green_a"].r = 0.25;
	self.skinnableColours["green_a"].g = 0.75;
	self.skinnableColours["green_a"].b = 0.25;

	self.skinnableColours["yellow_a"].r = 1;
	self.skinnableColours["yellow_a"].g = 1;
	self.skinnableColours["yellow_a"].b = 0;

	self.skinnableColours["orange_a"].r = 1;
	self.skinnableColours["orange_a"].g = 0.5;
	self.skinnableColours["orange_a"].b = 0.25;

	self.skinnableColours["red"].r = 1;
	self.skinnableColours["red"].g = 0;
	self.skinnableColours["red"].b = 0;
end


--[[

TooltipHandler:removeColourCode(s)

-- removes colour codes from string <s>.

]]--
function TooltipHandler:removeColourCode(s)
	--[0-9,a-f][0-9,a-f][0-9,a-f][0-9,a-f][0-9,a-f][0-9,a-f][0-9,a-f][0-9,a-f]
	local sNew = s;

	if sNew ~= nil then
		while string.find(sNew, "|[c,C][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F]") ~= nil do
			sNew = string.gsub(sNew,"|[c,C][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F][0-9,a-f,A-F]", "");
		end
		while string.find(sNew, "|[r,R]") ~= nil do
			sNew = string.gsub(sNew,"|[r,R]", "");
		end
	end
   
	return sNew;
end


--[[
function TooltipHandler:test(tooltip)
   tt = getglobal(tooltip);
   
   tt:SetOwner(UIParent, "ANCHOR_NONE");
   tt:SetPoint("TOP", "UIParent", "TOP", 0, -32);
   tt:AddLine("Test" .. GetTime());
   tt:AddLine("Test");
   tt:AddLine("Test");
   tt:Show();
end

function TooltipHandler:test2(tooltip)
   tt = getglobal(tooltip);
   
   tt:ClearLines();
   tt:SetHeight(0);

   tt:AddLine("Test2");
   tt:Show();
end

]]--