-- This table will hold all the possible string replacements
-- that will be available for the tooltip.
TooltipLookup = { };
TooltipLookup["%flagRSPVersion"] = function () return FlagRSP.VERSION; end
TooltipLookup["%flagRSPAltLevelEnemy"] = function (x) return TooltipHandler:getAlternativeEnemyLevelText(x); end
TooltipLookup["%UnitClass"] = function (x) return TooltipHandler:getClass(x); end
TooltipLookup["%UnitRace"] = function (x) return TooltipHandler:getRace(x); end
TooltipLookup["%UnitLevel"] = function (x) return TooltipHandler:getLevel(x); end
TooltipLookup["%UnitName"] = function (x) return TooltipHandler:GetCharacterName(x, "unit"); end
TooltipLookup["%UnitRank"] = function (x) return TooltipHandler:getPVPRank(x); end
TooltipLookup["%UnitTitle"] = function (x) return TooltipHandler:getTitle(TooltipHandler:GetCharacterName(x, "unit")); end
TooltipLookup["%UnitGuild"] = function (x) return TooltipHandler:getGuild(x); end
TooltipLookup["%flagRSPFriendlistText"] = function (x) return TooltipHandler:getFriendlistTooltipText(UnitName(x)); end
TooltipLookup["%flagRSPGuildFriendlistText"] = function (x) return TooltipHandler:getFriendlistGuildTooltipText(x); end
TooltipLookup["%flagRSPRPFlag"] = function (x) return TooltipHandler:getRPTag(UnitName(x)); end
TooltipLookup["%flagRSPPVPRank"] = function (x) return TooltipHandler:getPVPRank(x); end
TooltipLookup["%flagRSPPetOwnerSubLine"] = function () return TooltipHandler:getMouseoverPetOwnerTooltipSubText(); end
TooltipLookup["%flagRSPPetOwnerLine"] = function () return TooltipHandler:getMouseoverPetOwnerTooltipText(); end
TooltipLookup["%flagRSPPetOwner"] = function () return TooltipHandler:getMouseoverPetOwner(); end
TooltipLookup["%flagRSPPetOwnerText"] = function () return TooltipHandler:BuildPetOwnerLine(); end
TooltipLookup["%flagRSPSurname"] = function (x) return TooltipHandler:GetCharacterName(x, "last"); end
TooltipLookup["%flagRSPLevelLine"] = function (x) return TooltipHandler:getLevelTooltipText(x); end
TooltipLookup["%flagRSPLevel"] = function (x) return TooltipHandler:getLevelText(x); end
TooltipLookup["%flagRSPNameLine"] = function (x) return TooltipHandler:getNameTooltipText(x); end
TooltipLookup["%flagRSPRankLine"] = function (x) return TooltipHandler:getPVPRankTooltipText(x); end
TooltipLookup["%flagRSPRPLine"] = function (x) return TooltipHandler:getRPTooltipText(TooltipHandler:GetCharacterName(x, "unit"), x); end
TooltipLookup["%flagRSPTitleLine"] = function (x) return TooltipHandler:getTitleTooltipText(x); end
TooltipLookup["%flagRSPGuildLine"] = function (x) return TooltipHandler:getGuildTooltipText(x); end
TooltipLookup["%flagRSPCivilianLine"] = function (x) return TooltipHandler:getCivilianLine(x); end
TooltipLookup["%flagRSPSkinnableLine"] = function (x) return TooltipHandler:getSkinnableLine(x); end
TooltipLookup["%flagRSPCStatus"] = function (x) return TooltipHandler:getCharStatus(TooltipHandler:GetCharacterName(x, "unit")); end
TooltipLookup["%flagRSPCharStatusLine"] = function (x) return TooltipHandler:getCharStatusTooltipText(TooltipHandler:GetCharacterName(x, "unit"), x); end
TooltipLookup["%FriendlistFriendstateText"] = function (x) return Friendlist:GetFriendstateText(TooltipHandler:GetCharacterName(x, "unit")); end
TooltipLookup["%FriendlistFriendstateColour"] = function (x) return Friendlist:GetFriendstateColour(TooltipHandler:GetCharacterName(x, "unit")); end
TooltipLookup["%flagRSPPvPFlag"] = function (x) return TooltipHandler:TooltipPVPFlagText(x); end
TooltipLookup["%flagRSPResurrectableText"] = function (x) return TooltipHandler:TooltipResurrectableText(x); end
TooltipLookup["%NPCTitleLine"] = function (x) return TooltipHandler:GetNPCTitleLine(); end
TooltipLookup["%NPCFactionLine"] = function (x) return TooltipHandler:GetNPCFactionLine(); end
TooltipLookup["%NPCLeaderLine"] = function (x) return TooltipHandler:GetNPCLeaderLine(); end

-- This will hold the default tooltip style for known, unknown, and ignored players.
PlayerTooltip = { };

-- A known player is either a player stored in the Friendlist or any player depending on settings.
PlayerTooltip["known"] = { };
PlayerTooltip["known"][1] = "%flagRSPNameLine";
PlayerTooltip["known"][2] = "%flagRSPTitleLine";
PlayerTooltip["known"][3] = "%flagRSPGuildLine";
PlayerTooltip["known"][4] = "%flagRSPLevelLine";
PlayerTooltip["known"][5] = "%flagRSPRankLine";
PlayerTooltip["known"][6] = "%flagRSPRPLine";
PlayerTooltip["known"][7] = "%flagRSPCharStatusLine";
PlayerTooltip["known"][8] = "%flagRSPFriendlistText";
PlayerTooltip["known"][9] = "%flagRSPGuildFriendlistText";
PlayerTooltip["known"][10] = "%flagRSPResurrectableText";
PlayerTooltip["known"][11] = "%flagRSPPvPFlag";

-- An unknown player is any player not on the Friendlist with hide unknown player names set.
-- This is almost entirely based off of the previous one, but it exists to facilitate custom tooltips.
PlayerTooltip["unknown"] = { };
PlayerTooltip["unknown"][1] = "%flagRSPNameLine";
PlayerTooltip["unknown"][2] = "%flagRSPTitleLine";
PlayerTooltip["unknown"][3] = "%flagRSPGuildLine";
PlayerTooltip["unknown"][4] = "%flagRSPLevelLine";
PlayerTooltip["unknown"][5] = "%flagRSPRankLine";
PlayerTooltip["unknown"][6] = "%flagRSPRPLine";
PlayerTooltip["unknown"][7] = "%flagRSPCharStatusLine";
PlayerTooltip["unknown"][8] = "%flagRSPFriendlistText";
PlayerTooltip["unknown"][9] = "%flagRSPGuildFriendlistText";
PlayerTooltip["unknown"][10] = "%flagRSPResurrectableText";
PlayerTooltip["unknown"][11] = "%flagRSPPvPFlag";

-- An ignored player is ignored.  You don't care at all about him or her.
PlayerTooltip["ignored"] = { };
PlayerTooltip["ignored"][1] = "%flagRSPNameLine";
PlayerTooltip["ignored"][2] = FlagRSP_Locale_Ignored;

-- Tooltip for an NPC.  Some of these may come out weird.
PlayerTooltip["npc"] = { };
PlayerTooltip["npc"][1] = "%flagRSPNameLine";
PlayerTooltip["npc"][2] = "%NPCTitleLine";
PlayerTooltip["npc"][3] = "%flagRSPLevelLine";
PlayerTooltip["npc"][4] = "%NPCFactionLine";
PlayerTooltip["npc"][5] = "%flagRSPPvPFlag";
PlayerTooltip["npc"][6] = "%NPCLeaderLine";
PlayerTooltip["npc"][7] = "%flagRSPFriendlistText";
PlayerTooltip["npc"][8] = "%flagRSPSkinnableLine";

PlayerTooltip["pet"] = { };
PlayerTooltip["pet"][1] = "%flagRSPNameLine";
PlayerTooltip["pet"][2] = "%flagRSPPetOwnerText";
PlayerTooltip["pet"][3] = "%flagRSPLevelLine";